/********************************************************************
 *  Shinobi Library
 *  Copyright (c) 1998-1999 SEGA
 *
 *  Library : High layer Configuration Library
 *  Module  : Library Interface Header
 *  File    : sg_sycfg.h
 *  Date    : 1999-03-31
 *  Version : 1.14
 *
 ********************************************************************/

#ifndef _SG_SYCFG_H_
#define _SG_SYCFG_H_

/********************************************************************/
/*  CN[ht@C                                            */
/*  include files                                                   */
/********************************************************************/
#include    <sg_xpt.h>                      /*                      */
#include    <shinobi.h>                     /*                      */
/********************************************************************/
/*  萔`                                                        */
/*  constants                                                       */
/********************************************************************/
#define SYD_CFG_STEREO  (0x00)              /* XeIݒ         */
#define SYD_CFG_MONO    (0x01)              /* mݒ         */
#define SYD_CFG_OK      (0)                 /* I             *//* Ver1.10 */
#define SYD_CFG_NG      (-1)                /* ُI             *//* Ver1.10 */

                                            /* Ver1.10              */
/*** Jg[R[h ***/
/*** country code     ***/
#define SYD_CFG_JAPAN    (0x30)             /* {                 */
#define SYD_CFG_AMERICA  (0x31)             /* AJEuW...*/
#define SYD_CFG_EUROPE   (0x32)             /* B                 */

/*** ݒ ***/
/*** language ***/
#define SYD_CFG_JAPANESE   (0x0)            /* {               */
#define SYD_CFG_ENGLISH    (0x1)            /* p                 */
#define SYD_CFG_GERMAN     (0x2)            /* hCc             */
#define SYD_CFG_FRENCH     (0x3)            /* tX           */
#define SYD_CFG_SPANISH    (0x4)            /* XyC           */
#define SYD_CFG_ITALIAN    (0x5)            /* C^A           */

#define SYD_CFG_D_JAPANESE (0x30)           /* {               */
#define SYD_CFG_D_ENGLISH  (0x31)           /* p                 */
#define SYD_CFG_D_GERMAN   (0x32)           /* hCc             */
#define SYD_CFG_D_FRENCH   (0x33)           /* tX           */
#define SYD_CFG_D_SPANISH  (0x34)           /* XyC           */
#define SYD_CFG_D_ITALIAN  (0x35)           /* C^A           */

/*** ` ***/
/*** bloadcast type ***/
#define SYD_CFG_NTSC     (0x30)             /* NTSC                 */
#define SYD_CFG_PAL      (0x31)             /* PAL                  */
#define SYD_CFG_PAL_M    (0x32)             /* PAL-M                */
#define SYD_CFG_PAL_N    (0x33)             /* PAL-N                */


/*** ̎ʔԍ ***/
/*** individual id ***/
#define SYD_CFG_IID_SIZE (6)				/* ̎ʎqf[^   */
											/* individual id data size */

#define SYD_CFG_IID_OK		(1)				/* IID擾OK            *//* Ver1.11 */
#define SYD_CFG_IID_CHKERR	(2)				/* `FbNTG[   *//* Ver1.11 */
#define SYD_CFG_IID_NG  	(0)				/* IID擾NG            *//* Ver1.11 */

/********************************************************************/
/*  ^`                                                          */
/*  structure/union/enum                                            */
/********************************************************************/

/********************************************************************/
/*  Lϐ`                                                    */
/*  global valiables                                                */
/********************************************************************/

/********************************************************************/
/*  ֐`                                                        */
/*  functions                                                       */
/********************************************************************/
#ifdef __cplusplus
extern "C"{                                 /* for C++ Interface    */
#endif  /* __cplusplus */

Sint32 syCfgInit( Void* ) ;                 /* Cu */
Sint32 syCfgExit( Void  ) ;                 /* CuI   */
Sint32 syCfgSetSoundMode( Sint32  ) ;       /* ݒ̍XV       */
Sint32 syCfgGetSoundMode( Sint32* ) ;       /* ݒ̎Q       */
                                            /* Ver1.02              */
Sint32 syCfgGetCountryCode  ( Sint32* ) ;   /* Jg[R[h擾 */
Sint32 syCfgGetLanguage     ( Sint32* ) ;   /* ݒ擾         */
Sint32 syCfgGetDefaultLanguage( Sint32* ) ; /* ftHgݒ擾*//* Ver1.14*/
Sint32 syCfgGetBroadcastType( Sint32* ) ;   /* `擾         */

Sint32 syCfgGetIndividualID( Sint8* ) ;     /* ő̎ʔԍ         */

#ifdef __cplusplus
}                                           /* for C++ Interface    */
#endif /* __cplusplus  */
#endif /* _SG_SYCFG_H_ */
/****************************************** End of sg_sycfg.h *******/
