#ifndef _SJ_H_INCLUDED
#define _SJ_H_INCLUDED
/****************************************************************************/
/*																			*/
/*				Xg[WCgCuwb_@						*/
/*					Stream Joint Library									*/
/*																			*/
/*				 1998.4.14			written by M.Oshimi						*/
/*																			*/
/****************************************************************************/

#define	SJ_VER	"5.45"

#ifdef _MSC_VER
#pragma comment(lib, "sj.lib")
#endif

/***************************************************************************
 *      萔}N
 *      MACRO CONSTANT
 ***************************************************************************/

/*	`NC	*/
/*	Chunk line		*/
#define	SJ_LIN_FREE	(0)				/*	f[^`NC				*/
									/*	Data chunk line						*/
#define	SJ_LIN_DATA	(1)				/*	t[`NC				*/
									/*	Free chunk line						*/

/*	G[R[h	*/
/*	Error code		*/
#define SJ_ERR_FATAL		(-1)
#define SJ_ERR_INTERNAL		(-2)
#define SJ_ERR_PRM			(-3)

/***************************************************************************
 *      }N
 *      MACRO CONSTANT
 ***************************************************************************/

/* AhX̃|C^^ւ̕ϊ */
#define SJ_VOID_PTR(adr)	((void *)(adr))

/* nrbg[ɂ
 * @1,2,8,16rbg̏ꍇASH́AړĨWX^gp2߂ŏ
 * ł̂ŁAVtgɂB
 * @3`7rbg̏ꍇASH́A-128܂ł͖߃R[hɃC~fBGCgf[^
 * i[ł̂ŁA}XNɂB1߂܂2߁B
 * @̑̏ꍇA󋵂ɉčœKƂ͌ȂAVtgɂĂB
 */
#define SJ_OFF_LSB(val, n)	((((unsigned long)(val)) >> (n)) << (n))
#define SJ_OFF_LSB1(val)	((((unsigned long)(val)) >> (1)) << (1))
#define SJ_OFF_LSB2(val)	((((unsigned long)(val)) >> (2)) << (2))
#define SJ_OFF_LSB3(val)	(((unsigned long)(val)) & (0xfffffff8))
#define SJ_OFF_LSB4(val)	(((unsigned long)(val)) & (0xfffffff0))
#define SJ_OFF_LSB5(val)	(((unsigned long)(val)) & (0xffffffe0))
#define SJ_OFF_LSB6(val)	(((unsigned long)(val)) & (0xffffffc0))
#define SJ_OFF_LSB7(val)	(((unsigned long)(val)) & (0xffffff80))
#define SJ_OFF_LSB8(val)	((((unsigned long)(val)) >> (8)) << (8))
#define SJ_OFF_LSB16(val)	((((unsigned long)(val)) >> (16)) << (16))

/* |C^2,4,8,16,32byteE܂Ŗ߂iӁFʂ(void*)^j */
#define SJ_BACK_BND2(ptr)	SJ_VOID_PTR(SJ_OFF_LSB1(ptr))
#define SJ_BACK_BND4(ptr)	SJ_VOID_PTR(SJ_OFF_LSB2(ptr))
#define SJ_BACK_BND8(ptr)	SJ_VOID_PTR(SJ_OFF_LSB3(ptr))
#define SJ_BACK_BND16(ptr)	SJ_VOID_PTR(SJ_OFF_LSB4(ptr))
#define SJ_BACK_BND32(ptr)	SJ_VOID_PTR(SJ_OFF_LSB5(ptr))

/* |C^2,4,8,16,32byteE܂Ői߂iӁFʂ(void*)^j */
#define SJ_FORE_BND2(ptr)	SJ_BACK_BND2( ((unsigned long)(ptr)) +  1)
#define SJ_FORE_BND4(ptr)	SJ_BACK_BND4( ((unsigned long)(ptr)) +  3)
#define SJ_FORE_BND8(ptr)	SJ_BACK_BND8( ((unsigned long)(ptr)) +  7)
#define SJ_FORE_BND16(ptr)	SJ_BACK_BND16(((unsigned long)(ptr)) + 15)
#define SJ_FORE_BND32(ptr)	SJ_BACK_BND32(((unsigned long)(ptr)) + 31)

/* 32byteË̗mۂ̂߂ɁÄTCY𐅑 */
#define SJ_SIZ_BND32(siz)	((siz) + 32)

/* SJobt@AhX32oCgE̎擾 */
#define	SJ_ADR_BND32(adr)	SJ_FORE_BND32(adr)

/* E̐[ƌI[߂ */
#define SJ_GET_ENDPOS(bgn, num)		((bgn) + (num) - 1)

/* ĚiElFbgn <= endj */
#define SJ_INNER_NUM(bgn, end)		((end) - (bgn) + 1)

/* E̔iElFbgn <= x <= endj */
#define SJ_IS_INNER(x, bgn, end) ( ((x) >= (bgn)) && ((x) <= (end)) )

/***************************************************************************
 *      f[^^̐錾
 *      Data type declaration
 ***************************************************************************/

#ifndef UUID_DEFINED
#define UUID_DEFINED
typedef struct _UUID {
    unsigned long Data1;
    unsigned short Data2;
    unsigned short Data3;
    unsigned char Data4[8];
} UUID;
#define uuid_t UUID
#endif

/*	f[^`N	*/
/*	Data chunk		*/
#ifndef SJCK_DEFINED
#define SJCK_DEFINED
typedef struct {
	char *data;						/*	f[^AhX						*/
									/*	Data address						*/
	long len;						/*	oCg							*/
									/*	Number of bytes						*/
} SJCK;
#endif

/*	Cunh	*/
/*	Library handle		*/
typedef struct {
	struct _sj_vtbl *vtbl;			/*	C^tF[X֐					*/
									/*	Interface function					*/
} SJ_OBJ;
#ifndef SJ_DEFINED
#define SJ_DEFINED
typedef SJ_OBJ *SJ;
#endif

/*	C^tF[X֐  	*/
/*	Interface function		*/
typedef struct _sj_vtbl {
	void (*QueryInterface)();		/*	for COM compatibility				*/
	void (*AddRef)();				/*	for COM compatibility				*/
	void (*Release)();				/*	for COM compatibility				*/
	void (*Destroy)(SJ sj);			/*	nh̏						*/
									/*	Destroy of handle					*/
	UUID *(*GetUuid)(SJ sj);		/*	UUID̎擾							*/
									/*	Get UUID							*/
	void (*Reset)(SJ sj);			/*	Zbg							*/
									/*	Reset of handle						*/
	/*	`N̎擾	(FIFO̐擪擾)								*/
	/*	Get Chunk															*/
	void (*GetChunk)(SJ sj, long id, long nbyte, SJCK *ck);
	/*	`N߂@(FIFO̐擪ɑ})									*/
	/*	Give back Chunk														*/
	void (*UngetChunk)(SJ sj, long id, SJCK *ck);
	/*	`N}	(FIFO̍Ōɑ})									*/
	/*	Put Chunk															*/
	void (*PutChunk)(SJ sj, long id, SJCK *ck);
	/*	擾łf[^̃oCg̎擾									*/
	/*	Get number of data which get it										*/
	long (*GetNumData)(SJ sj, long id);
	/*	`N̎擾\̔											*/
	/*	Check whether you get chunk or not									*/
	long (*IsGetChunk)(SJ sj, long id, long nbyte, long *rbyte);
	/*	G[ɋN֐̓o^									*/
	/*	Entry callback function of error									*/
	void (*EntryErrFunc)(SJ sj,
					void (*func)(void *obj, long ecode), void *obj);
} SJ_IF;
typedef SJ_IF *SJIF;

/*	Xg[WCg̏							*/
/*	Destroy of Stream Joint								*/
#define SJ_Destroy(sj) \
		(*(sj)->vtbl->Destroy)(sj)

/*	Xg[WCgUUID̎擾 (UUIDւ̃AhX)	*/
/*	Get UUID of Stream Joint							*/
#define SJ_GetUuid(sj) \
		(*(sj)->vtbl->GetUuid)(sj)

/*	Xg[WCg̃Zbg						*/
/*	Reset of Stream Joint								*/
#define SJ_Reset(sj) \
		(*(sj)->vtbl->Reset)(sj)

/*	`N̎擾										*/
/*	Get Chunk											*/
#define SJ_GetChunk(sj, id, nbyte, ck) \
		(*(sj)->vtbl->GetChunk)(sj, id, nbyte, ck)

/*	`N߂										*/
/*	Give back Chunk										*/
#define SJ_UngetChunk(sj, id, ck) \
		(*(sj)->vtbl->UngetChunk)(sj, id, ck)

/*	`Nn										*/
/*	Put Chunk											*/
#define SJ_PutChunk(sj, id, ck) \
		(*(sj)->vtbl->PutChunk)(sj, id, ck)

/*	擾\ȃf[^̃oCg߂					*/
/*	Get number of data which get it						*/
#define SJ_GetNumData(sj, id) \
		(*(sj)->vtbl->GetNumData)(sj, id)

/*	`N̎擾\̔							*/
/*	Check whether you get chunk or not					*/
#define SJ_IsGetChunk(sj, id, nbyte, rbyte) \
			(*(sj)->vtbl->IsGetChunk)(sj, id, nbyte, rbyte)

/*	G[ɋNR[obN֐̓o^		*/
/*	Entry callback function of error					*/
#define SJ_EntryErrFunc(sj, id, f, o) \
		(*(sj)->vtbl->EntryErrFunc)(sj, id, f, o)


/***************************************************************************
 *		֐錾
 *      Function Declaration
 ***************************************************************************/

#ifdef		__cplusplus
extern	"C" {
#endif

/*	$func$ `N̕
 * [@] void SJ_SplitChunk(SJCK *ck, long nbyte,
 *													SJCK *ck1, SJCK *ck2);
 * [@] ck		: ΏۂƂȂ`N
 *			nbyte	: ck1 ̃oCg
 * [o@] ck1		: ꂽÕ`N
 *			ck2		: ꂽ㔼̃`N
 * [֐l] ck2	`ÑoCg
 * [@@\] ck`Nck1`Nck2`NɕB
 *			ck1`ŃAnbyte ̒ɂȂB
 *			ck`N̒Anbyte ɖȂꍇ́AꂸA
 *			ck2`N̒́A0ƂȂB
 *			ck1cḱÂw肵ĂǂB
 *			Pɕꍇ́Aȉ̂悤ɋLqB
 *				SJ_SplitChunk(&ck, 100, &ck, &ck2);
 *	Divition of a chunk
 * [Inputs  ] ck	: Chunk of the division object
 *			  nbyte	: Length of 'ck1' chunk
 * [Outputs ] ck1	:First half chunk which was divided
 *			  ck2	:Latter half chunk which was divided
 * [Return  ] Length of 'ck2' chunk
 * [Function] Divides 'ck' chunk into 'ck1' chunk and 'ck2' chunk.
 *			  The length of 'ck1' chunk is 'nbyte'.
 *			  When length of 'ck' chunk is less than 'nbyte', it is not 
 *			  divided, and length of 'ck2' chunk becomes 0.
 *			  You can specify an equal thing to 'ck1' and 'ck'.
 *			  For example
 *				SJ_SplitChunk(&ck, 100, &ck, &ck2);
 */
void SJ_SplitChunk(SJCK *ck, long nbyte, SJCK *ck1, SJCK *ck2);

/***
 *		Oobt@^CṽXg[WCg
 *		Ring buffer type
 ***/

/*													*/
/*	Initialization										*/
void SJRBF_Init(void);

/*	I											*/
/*	Termination											*/
void SJRBF_Finish(void);

/*	Oobt@̐								*/
/*	Creation of ring buffer								*/
SJ SJRBF_Create(char *buf, long bsize, long xsize);

/***
 *		^CṽXg[WCg
 *		Memory type
 ***/

/*													*/
/*	Initialization										*/
void SJMEM_Init(void);

/*	Xg[̐								*/
/*	Creation of memory stream							*/
SJ SJMEM_Create(char *data, long bsize);

/***
 *		ėpXg[WCg
 *		Universal type
 ***/

/*	`Ň[h		*/
/*	Combination mode of chunk	*/
#define	SJUNI_MODE_SEPA			(0)
#define	SJUNI_MODE_JOIN			(1)

/*	Calculation of working area	*/
#define	SJUNI_CALC_WORK(nck)	((nck)*16)

/*	ėpXg[WCg̐					*/
/*	Creationg of Universal Stream Joint				*/
SJ SJUNI_Create(long mode, char *work, long wksize);

/*	`N̎擾								*/
/*	Get number of chunks							*/
long SJUNI_GetNumChunk(SJ sj, long id);

/*	`FCv[̎擾							*/
/*	Get number of Chain pools						*/
long SJUNI_GetNumChainPool(SJ sj);

#if 0
/*	GetChunk֐Ă΂ꂽƂ̃R[obN֐̓o^	*/
void SJUNI_EntryGetFunc(SJ sj, long id, void (*f)(void *o, SJCK *ck), void *o);
/*	PutChunk֐Ă΂ꂽƂ̃R[obN֐̓o^	*/
void SJUNI_EntryPutFunc(SJ sj, long id, void (*f)(void *o, SJCK *ck), void *o);
/*	UngetChunk֐Ă΂ꂽƂ̃R[obN֐̓o^*/
void SJUNI_EntryUngetFunc(SJ sj, long id, void (*f)(void *o, SJCK *ck), void *o);
#endif

#ifdef		__cplusplus
}
#endif


#endif     /*  #ifndef _SJ_H_INCLUDED	*/
