/*
    UserFlash Library Sample

    COPYRIGHT (C) SEGA ENTERSRISES,LTD.

    Based on F40 Sample for SET5

    1999.03.03
*/

#include <Shinobi.h>
#include <Nindows.h>

#define OBJECT  object_F40_GTE_sh_null1_1_null1_1
#define TEXLIST texlist_F40_GTE_sh_null1_1

extern  NJS_OBJECT  OBJECT[];
extern NJS_TEXLIST TEXLIST[];

/* eNX`̐ݒ */
/* setting of texture */
NJS_TEXMEMLIST  tex[100];

extern NJS_MATRIX   matrix[32];
extern NJS_VERTEX_BUF   vbuf[4096];

NJS_VIEW    view;
NJS_LIGHT   light;

Sint32  xx = 0,yy = 0,zz = 0;


/*** variables ***/

/* [U[qXgp[N */
/* work area for User History */
Uint32 Work1[0x10000L / sizeof(Uint32)];
Uint32 Work2[60 / sizeof(Uint32)];
Uint32 Work3[0x10000L / sizeof(Uint32)];
Uint32 Work4[0x8000L / sizeof(Uint32)];

Sint32  scene;
Sint32  vcnt;
Sint32  fade;
Sint32  cary;
Sint32  est;
Sint32  net_f;


#define SCENE_TIME  (60*60*10)/*32400*/
#define WRITE_TIME  ((SCENE_TIME)/3)


void njUserInit(void)
{
    /*
        njInitSystem̕ςsbInitSystemsB
        ڂ́Asbinit.c
    */
    /*
       Executing "sbInitSystem" in a change of "njInitSystem".
       (reference with sbinit.c in detail)
    */
    njSetBorderColor( 0x00000000 ) ;
    sbInitSystem( NJD_RESOLUTION_640x480_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1 );
    /*
        eNX`̃[Nobt@mۂB܂łF40̃eNX`ōő
        TCY1024x128MIPMAPȂ̃[hłTCY0x40800oCgm
        Ă0x800ȏ0x800Pʂ̎wŃ[hł悤ɕύX܂B
        őTCYق[h͑
    */
    /*
        Securing work buffer of texture. 
        So far, in texture of F40, it was secured 0x40800 byte that was the size 
        that could load it without MIPMAP of 1024x128 of the greatest size.
        But it was changed to can load it by setting of 0x800 unit more than 0x800.
        It does not take the time that the greatest size was used for loads.
    */
    njInitTextureBuffer((Sint8*)vbuf,0x800*100);

    njInitVertexBuffer( 900000, 0, 200000, 0 ,0);
    njInitPrint(NULL,0,0);

    njInitMatrix( matrix, 32 , 0);
    njInit3D( vbuf, 4096 );
    njInitView( &view );
    njCreateLight( &light, NJD_SPEC_DIR );
    njSetLightIntensity( &light, 0.5f, 2.0f, 0.5f );
    njSetView( &view );

    njInitTexture( tex,100);

    /*
        NINDOWS SET4Ƀ|[gݒ肷
    */
    /*
        NINDOWS initialization
        Establishing a port in an argument (than SET 4)
    */
    nwInitSystem(100,NJD_PORT_A0);

    /*
        eNX`GD WorkShop̃JgfBNg
        uĂ
    */
    /*
        Put texture with baing current directory of GD WorkShop
    */
    njLoadTexture( TEXLIST );
    njSetTexture( TEXLIST );

    njControl3D( NJD_CONTROL_3D_CONSTANT_ATTR|NJD_CONTROL_3D_NO_CLIP_CHECK );
    njSetConstantAttr( 0xffffffff, NJD_FILTER_BILINEAR);

    njClipZ( -2.0f, -100.f );
    njSetAspect( 1.0f, 1.0f );

    njSetBackColor(0x00000000,0x00000000,0x000000FF);
    njPrintSize(16);

	syRtcInit();

	/* to read the per-info correctly */
	njWaitVSync();
	njWaitVSync();

	/* Init the UserFlash Library */
	ufInitSystem((Uint8*)Work1, (Uint8*)Work2, NULL, NULL);
	ufAutoSynch(0);
	
	/* Init Variables */
	scene = 0;
	vcnt = 0;
	fade = 255;
	cary = 0;
	est = 0;
	net_f = 0;
	
	{
		static UFS_AllPlayHistory plyhst;
		
		if (ufReadAllHead(NULL, &plyhst) == TRUE) {
			if (plyhst.GameEst != 0xff) est = plyhst.GameEst;
			if (plyhst.GameCarry != 0xff) cary = plyhst.GameCarry;
		}
	}
}


void DrawScreenMask(Sint32 step)
{
	static NJS_POLYGON_VTX poly[4];
	Sint32 type;
	
	step &= 0xff;
	
	poly[0].x = 0.0f;
	poly[0].y = 0.0f;
	poly[0].z = 65535.0f;
	poly[0].col = (step << 24) + 0x0;
	
	poly[1].x = 0.0f;
	poly[1].y = 480.f;
	poly[1].z = 65535.0f;
	poly[1].col = (step << 24) + 0x0;
	
	poly[2].x = 640.f;
	poly[2].y = 0.0f;
	poly[2].z = 65535.0f;
	poly[2].col = (step << 24) + 0x0;
	
	poly[3].x = 640.f;
	poly[3].y = 480.0f;
	poly[3].z = 65535.0f;
	poly[3].col = (step << 24) + 0x0;
	
	if (step == 255) type = FALSE;
	else type = TRUE;
	
	njDrawPolygon( poly, 4, type );
}


Sint32 WritePlayTime(void)
{
	ufChangeWorkBuffer( NULL,  NULL, Work3, Work4);
	ufPlayTime(UFD_PLAY, est, cary, NULL);
	
	if (cary >= 254) cary = 0;
	else cary++;
	
	est = (rand() & 0xff);
	if (est == 255) est = 0;
}


Sint32 njUserMain(void)
{
	const PDS_PERIPHERAL* per;
	per = pdGetPeripheral(PDD_PORT_A0);
	
	syRtcExecServer();
	
	njPrintC(NJM_LOCATION(2,3), "UF_LIB TEST WITH F40");
	vcnt++;
	
	njPrint(NJM_LOCATION(2,5), "EST : %d", est);
	njPrint(NJM_LOCATION(2,6), "CARY: %d", cary);
	njPrint(NJM_LOCATION(2,7), "NET : %s", (net_f == ON) ? "ON" : "OFF");
	
	if (per->press & PDD_DGT_TX) {
		if (net_f == OFF) {
			SYS_RTC_DATE date;
			Uint32 cnt;
			
			/* get a substitute of network time */
			syRtcGetDate( &date );
			syRtcDateToCount( &date, &cnt );
			
			ufConnect(cnt);
		} else {
			ufDisConnect();
		}
		
		net_f ^= 1;
	}
	
	if ( ((per->on & (PDD_DGT_TA|PDD_DGT_TB|PDD_DGT_TX|PDD_DGT_TY))
				== (PDD_DGT_TA|PDD_DGT_TB|PDD_DGT_TX|PDD_DGT_TY)) &&
		 (per->press & PDD_DGT_ST) ) {
		
		/* write PlayTime before softreset */
		WritePlayTime();
		ufSynch();
		
		return NJD_USER_EXIT;
	}
	
	switch (scene) {
	case 0:
		/* scene 0 */
		njSetBackColor(0x00000000,0x00000000,0x000000C0);
		njClearMatrix();
		njTranslate( NULL, 0.f, -1.f, -5.f );
		njRotateXYZ( NULL, xx,yy,zz );
		
		njSimpleDrawObject(OBJECT);
		
		yy += 128;
		xx = 0;
		zz = 0;
		
		if (fade < 255) DrawScreenMask(255 - fade);
		
		/* Write PlayTime 3 times per scene */
		if ((vcnt % WRITE_TIME) == WRITE_TIME - 1) WritePlayTime();
		
		if (vcnt >= SCENE_TIME) {
			if (--fade <= 0) {
				/* change the scene */
				scene = 1;
				vcnt = 0;
				fade = 255;
				
				WritePlayTime();
				ufSynch();
			}
		}
		break;
	
	case 1:
	default:
		/* scene 1 */
		njSetBackColor(0x00000000,0x00000000,0x00C00000);
		njClearMatrix();
		njTranslate( NULL, 0.f, -0.5f, -8.f );
		njRotateXYZ( NULL, xx,yy,zz );
		njSimpleDrawObject(OBJECT);
		
		yy -= 512;
		xx -= 96;
		zz = 0;
		
		if (fade < 255) DrawScreenMask(255 - fade);
		
		/* Write PlayTime 3 times per scene */
		if ((vcnt % WRITE_TIME) == WRITE_TIME - 1) WritePlayTime();
		
		if (vcnt >= SCENE_TIME) {
			if (--fade <= 0) {
				/* change the scene */
				scene = 0;
				vcnt = 0;
				fade = 255;
				
				WritePlayTime();
				ufSynch();
			}
		}
		break;
	}
	
	return nwExecute();

}


void njUserExit(void)
{
    nwExitSystem();
    njExitPrint();
    njExitTexture();
    sbExitSystem();
    
	/* do softreset */
    syBtExit();
}

