/*
 *
 *		ADXT Sample No.1(Playing CD stream)
 *
 */

/***************************************************************************
 *      CN[ht@C
 *      Include file
 ***************************************************************************/
#include	"shinobi.h"
#include	"sg_sd.h"
#include	"cri_adxf.h"
#include	"cri_adxt.h"

/***************************************************************************
 *      萔}N
 *      MACRO CONSTANT
 ***************************************************************************/
/*	ő`l				*/
/*	The number of maximum channels	*/
#define	MAX_CH			(2)

/*	ĐőCDXg[									*/
/*	The number of maximum CD streams playing at the same time	*/
#define	MAX_CDSTM		(1)

/*	ōTvOg		*/
/*	Maximum sampling frequency	*/
#define	MAX_SFREQ		(44100)

/*	t@CĐp[N̈̑傫	*/
/*	Work area size of CD stream play	*/
#define	WKSIZE		(ADXT_CALC_WORK(MAX_CH, 1, MAX_CDSTM, MAX_SFREQ))

/***************************************************************************
 *      ϐ`
 *		Variable Declaration
 ***************************************************************************/
/*	t@CĐp ADXT [N̈	*/
/*	Work area						*/
char work[WKSIZE];

/*	ADXT nh	*/
/*	ADXT handle		*/
ADXT adxt;

/***************************************************************************
 *      ֐`
 *      Function Declaration
 ***************************************************************************/

/***
 *		TEh̏
 *		Initialize sound section
 ***/

/*	TEhhCo̓]E					*/
/*	Initialize sound library and load sound driver	*/
void	sound_init(void *ptr)
{
	SDMEMBLK	memblk = NULL;

	/*	Initialize Sound library	 */
	sdLibInit(NULL, 0, 0);		/*	This api's argument is dummy now.  */
	/* 	Download and Initialize Sound driver.	 */
	/*	Create Memory block handle  */
	sdMemBlkCreate(&memblk);
	/*  Setting Memoby block handle  */
	sdMemBlkSetPrm(memblk, ptr, 0, SDD_MEMBLK_SYNC_FUNC, NULL);
	/*	Initialize Sound driver  */
	sdDrvInit(memblk);
	sdMemBlkDestroy(memblk);
}

/***
 *			[eBeB֐
 *			Utility function
 ***/

/*	f[^̓ǂݍ	*/
/*	Load data to memory	*/
void *load_file(char *fname, long *len)
{
	GDFS gdfs;
	long fsize, nsct;
	void *dat=NULL;

	if ( (gdfs=gdFsOpen(fname, NULL)) == NULL ) {
		for (;;) {
			njPrint(NJM_LOCATION(3, 5), "can't open %s", fname);
			njWaitVSync();
		}
	}
	gdFsGetFileSize(gdfs, &fsize);
	nsct = (fsize+2047)/2048;
	if ( (dat=syMalloc(nsct*2048)) != NULL ) {
		gdFsRead(gdfs, nsct, dat);
	}
	gdFsClose(gdfs);
	if ( len != NULL )
		*len = fsize;

	return dat;
}

/*	Ԃւ̕ϊ															*/
/*	Convert form sampling frequency and counter to time(hour,min,sec,frame)	*/
void sfcnt2time(long sf, long ncnt, long *hh, long *mm, long *ss, long *ff)
{
	register long nf = (long)((double)ncnt/(double)sf*100.0);

	*hh = nf/(60*60*100);
	*mm = nf/(60*100) - *hh*60;
	*ss = nf/100 - *hh*60*60 - *mm*60;
	*ff = nf%100;
}

/***
 *			TvvO
 *			Sample program
 ***/

/*	Ԃ̕\				*/
/*	Display status of program	*/
void adxtst_disp_stat(ADXT adxt)
{
	char *ststr[6] =
		{"STOP   ", "DECINFO   ", "PREP   ", "PLAYING", "DECEND ", "PLAYEND"};
	long stat, sfreq, cnt, td;
	long hh, mm, ss, ff;
	extern long adxt_svrcnt;

	njPrint(NJM_LOCATION(3, 3), "ADX Sample Program No.1");
	njPrint(NJM_LOCATION(3, 4), "   ( CD Stream Play )");
	stat = ADXT_GetStat(adxt);
	njPrint(NJM_LOCATION(3, 6), "Stat = %s", ststr[stat]);
	ADXT_GetTime(adxt, &cnt, &sfreq);
	sfcnt2time(sfreq,  cnt, &hh, &mm, &ss, &ff);
	njPrint(NJM_LOCATION(3, 7), "Time = %2d:%2d:%2d.%2d", hh, mm, ss, ff);
	td = syTmrCountToMicro(adxt_svrcnt);
	njPrint(NJM_LOCATION(3, 9), "CPU Load = %4d (%2d%%)", td, td*100/16667);
}

/*	ADX t@CĐTv	*/
/*	Playing ADX file			*/
void adxsmp(void)
{
	const PDS_PERIPHERAL	*per;
	long					req_smpl=0, dcd_smpl=0, pause;
	char					*pstr[3] = {"OFF","ON "};

	/*	ADXT nh̐	*/
	/*	Create ADXT handle	*/
	if ( (adxt=ADXT_Create(2, work, WKSIZE)) == NULL ) {
		for (;;) {
			njPrint(NJM_LOCATION(5, 5), "can't create ADXT\n");
			njWaitVSync();
		}
	}
	/*	G[΍̐ݒ (BGM̂ƂREPLAYAZtȂǂSTOP)	*/
	/*	Set recovery mode(BGM:REPLYA,Speech:STOP)				*/
	ADXT_SetAutoRcvr(adxt, ADXT_RMODE_REPLAY);
	/*	ĐJn		*/
	/*	Start to play	*/
	ADXT_StartFname(adxt, "SAMPLE.ADX");
	for (;;) {
		per = pdGetPeripheral(PDD_PORT_A0);
		if (per->press & NJD_DGT_ST) {
			break;
		}
		adxtst_disp_stat(adxt);
		/*	Ԃ̎擾			*/
	    /*	Check status of ADXT	*/
		if ( ADXT_GetStat(adxt) == ADXT_STAT_PLAYEND )
			break;
		njWaitVSync();
	}
	/*	ADXT nh̏	*/
	/*	Destroy ADXT handle	*/
	ADXT_Destroy(adxt);
	njWaitVSync();
}

/***
 *		C
 *		MAIN
 ***/

/*	AvP[VI	*/
/*	Finalize application		*/
void usr_exit(void)
{
	/*	ADXTCuI				*/
	/*	Finalize ADXT library				*/
	ADXT_Finish();
	/*	ECȕI				*/
	/*	Finalize SHINOBI					*/
	sbExitSystem();
	/*	VvvCփWv			*/
	/*	Jump to Simple player				*/
	syBtExit();
}

/*	GDt@CVXẽG[ɋN֐			*/
/*	Callback function when an error occur in GD file system	*/
void usr_gd_err_func(void *obj, Sint32 errcode)
{
	if (errcode == GDD_ERR_TRAYOPEND || errcode == GDD_ERR_UNITATTENT) {
		/*	AvP[VI	*/
		/*	Finalize application		*/
		usr_exit();
 	}
 	return;
}

/*	[UV-SYNC荞݂ɓo^֐	*/
/*	Callback function when V-sync interrupt	*/
void usr_vsync_func(void)
{
	Sint32 dstat;

    /*	TEhCũT[o֐		*/
	/*	Server function of sound library	*/
    sdSysServer();

	/*	GDhCȕԃ`FbN	*/
	/*	check status of GD-drive	*/
	dstat = gdFsGetDrvStat();
	if (dstat == GDD_DRVSTAT_OPEN || dstat == GDD_DRVSTAT_BUSY) {
		gdFsReqDrvStat();
	}
	return;
}

/*	ADXCũG[ɋN֐				*/
/*	Callback function when an error occur in ADX library	*/
void usr_adx_err_func(void *obj, char *msg)
{
	/*	
	 *	ADXŁAG[Ƃ̊֐Ăяo܂B
	 *	msg ɃG[bZ[Wn܂B
	 *	msǵAR5WX^Ɋi[Ă̂ŁAR5WX^̃AhX
	 *	_v邱ƂɂăG[bZ[Wm邱Ƃł܂B
	 *	̊֐́AV-Sync荞݂Ăяo邱Ƃ܂̂ŁA
	 *	Ninjå֐͎gpȂłB
	 *	܂AAvP[V[XƂ́Aɖ߂悤
 	 *	֐ɂĂB
	 *	This function call when error occur in ADX library.
	 *	Error message is put into 'msg' variable.
	 *	'msg' house R5 register. You can look error message in address of 
	 *	R5 register.
	 *	You cannot call Ninja function because this function is called 
	 *	from V-Int.
	 *	You must change this to no operation function when you release 
	 *	the application.
	 */

	for (;;);		/*	[Xɂ͖					*/
					/*	Delete when you release application.	*/

}

void main(void)
{
	void *snddrv;

	/*	ECȕ	*/
	/*	Initialize SHINOBI		*/
    njSetBorderColor( 0x00000000 ) ;
	sbInitSystem(NJD_RESOLUTION_320x240_NTSCNI,NJD_FRAMEBUFFER_MODE_RGB565,1);
	njInitVertexBuffer( -30000, 0, 30000, 0, 0);
    njInitPrint(NULL, 0, 0);
	/*	GDt@CVXeG[R[obN֐̓o^	*/
	/*	Entry callback function of GD file system error	*/
	gdFsEntryErrFuncAll((void *)usr_gd_err_func, NULL);

	/*	TEhCȕ	*/
	/*	Prepare sound library		*/
	snddrv = load_file("manatee.drv", NULL);
	sound_init(snddrv);
	syFree(snddrv);
	/*	DMA ][h				*/
	/*	Set transfer mode to DMA  	*/
	sdMemBlkSetTransferMode(SDE_MEMBLK_TRANSFER_MODE_DMA);

	njSetVSyncFunction((void (*)(void))usr_vsync_func);

	/*	ADXCu		*/
	/*	Initialize ADX library	*/
	ADXT_Init();
	/*	G[R[obN֐̓o^		*/
	/*	Entry ADX error callback function	*/
	ADXT_EntryErrFunc(usr_adx_err_func, NULL);

	for (;;)
		adxsmp();					/*	ADX t@CĐTv	*/
									/*	Playing ADX file			*/

	/*	AvP[VI	*/
	/*	Finalize application		*/
	usr_exit();
}


/* End of file */
