/*
 *
 *			Middleware MPEG Sofdec Playing Sample
 *
 *			Chainging location, size, depth, video output sw
 *
 */

/***************************************************************************
 *      CN[ht@C
 *      Include file
 ***************************************************************************/
#include <shinobi.h>
#include <nindows.h>
#include <sg_sd.h>
#include <sg_mw.h>


/***************************************************************************
 *      萔}N
 *      MACRO CONSTANT
 ***************************************************************************/
/*
 * \[h
 *   CPUԔz̗Dx́ASofdecAvP[V(|S)B
 *   |Sׂ点΁ASofdecCPUԂB
 *   1VɃ|SA2V̕\XV(C^[X)̕A
 *   ̃R}̊댯͏B
 * Display mode
 *   CPU time distribution of the application(poligon operation) takes 
 *   precedence over Sofdec decoder. CPU time of Sofdec increases when you 
 *   reduce poligon operation.
 */
#define SYS_MODE		NJD_RESOLUTION_640x480_NTSCI
#define SYS_FRAME		NJD_FRAMEBUFFER_MODE_ARGB8888
#define SYS_COUNT		1

/* _o^pobt@TCY(1}CiXɂ2V[eV[h)	*/
/*	Vertex buffer size(2V latency mode is when a valiable is minus.)	*/
#define VB_OP			-800000
#define VB_OM			0
#define VB_TP			200000
#define VB_TM			0
#define VB_PT			0

/*
 * Đ̎w
 *   ON   :蓮t@CȂΉĐsBftHgB
 *   OFF  :Đ}~B蓮t@CłfĐB
 * Setting play audio
 *   ON   :Play audio when the animation file is interleaved audio(default)
 *   OFF  :Not play audio
 */
#define AUDIO_SW		ON

/*	G[bZ[W		*/
/*	Length of error message	*/
#define ERRMSG_LEN		256

/*	TeapotIuWFNg	*/
/*	Teapot object		*/
#define OBJECT			object_tea_Teapot1_Teapot1


/***************************************************************************
 *      }N
 *      Process MACRO
 ***************************************************************************/

/*	tOON/OFF̔]		*/
/*	Turn over flag(ON/OFF)	*/
#define NOT_FLAG(flag)		(((flag) == OFF) ? ON : OFF)

/*	Đt@Cԍ̑Oi	*/
/*	Renew file number		*/
#define NEXT_FILE_NO(file_no, nfiles) \
			(((file_no) <= ((nfiles) - 2)) ? (file_no) + 1 : 0)


/***************************************************************************
 *      ϐ`
 *		Variable Declaration
 ***************************************************************************/

/*	Teapot֘AOϐ					*/
/*	Global variable for display Teapot	*/
extern NJS_OBJECT		OBJECT[];
extern Uint16			T009[];
extern NJS_MATRIX		matrix[8];
extern NJS_VERTEX_BUF	vbuf[4096];


/*	G[		*/
/*	The number of error	*/
Sint32 errcnt = 0;

/*	G[bZ[W	*/
/*	Error message		*/
char errmsg[ERRMSG_LEN] = "(OK)";

/*	Teapot\tO		*/
/*	Flag for display Teapot	*/
Sint32 disp_flag = ON;

/*	|[Y		*/
/*	Pause status	*/
Sint32 pause = OFF;

/*	nhp[^		*/
/*	Parameter for handle create	*/
MWS_PLY_CPRM_SFD cprm;

/*	~hEFAĐnh	*/
/*	Middleware playing handle	*/
MWPLY ply = NULL;

/*	Teapot֘Aϐ				*/
/*	Variable for display Teapot	*/
NJS_TEXNAME			texname[1];
NJS_TEXLIST			tlist1 = {texname, 1};
NJS_TEXINFO			info;
NJS_TEXMEMLIST		tex[10];
NJS_VIEW			view;
NJS_LIGHT			light;

/*	V݃JE^	*/
/*	V-Int counter	*/
Uint32 vcount = 0;

/*	}gNX̊ẻ]px	*/
/*	Revolving angles of matrix	*/
Sint32 xx, yy, zz = 0;

/*	Đt@CXg (t@Cǉł)	*/
/*	File name list(You can add other file.)			*/
char *fname[] = {
	"SAMPLE.SFD",
};

/*	Đt@Cԍ	*/
/*	File number			*/
long file_no = 0;

/*	Đt@C		*/
/*	The number of file	*/
long nfiles = sizeof(fname) / sizeof(char *);

/*	[r[̃TCYEʒuEs	*/
/*	location, size, Z of Movie		*/
long mv_lx=100, mv_ly=100, mv_sx=320, mv_sy=240;
float mv_lz=10.0;
/*	delta of location, size, Z 	*/
long mv_vlx=4, mv_vly=5, mv_vsx=2, mv_vsy=3;
float mv_vlz=0.1;

/*	[r[\tO		*/
/*	Flag for display Movie	*/
Sint32 mv_video_output_flag = ON;

/***************************************************************************
 *      ֐`
 *      Function Declaration
 ***************************************************************************/

/***
 *		TEh̏
 *		Initialize sound section
 ***/

/*	TEhhCo̓]E					*/
/*	Initialize sound library and load sound driver	*/
Void SoundInit(Void *ptr)
{
	SDMEMBLK	memblk = NULL;

	/*	Initialize Sound library	 */
	sdLibInit(NULL, 0, 0);		/*	This api's argument is dummy now.  */

	/* 	Download and Initialize Sound driver.	 */
	/*	Create Memory block handle  */
	sdMemBlkCreate(&memblk);
	/*  Setting Memoby block handle  */
	sdMemBlkSetPrm(memblk, ptr, 0, SDD_MEMBLK_SYNC_FUNC, NULL);
	/*	Initialize Sound driver  */
	sdDrvInit(memblk);
	sdMemBlkDestroy(memblk);

	/*	][h̐ݒ		*/
	/*	Setting transfer mode	*/
	sdMemBlkSetTransferMode(SDE_MEMBLK_TRANSFER_MODE_DMA);

	return;
}

/***
 *			[eBeB֐
 *			Utility function
 ***/

/*	f[^̓ǂݍ	*/
/*	Load data to memory	*/
void *LoadFile(char *fname, long *len)
{
	GDFS			gdfs;
	long			fsize, nsct;
	void			*dat;

	gdfs = gdFsOpen(fname, NULL);
	if (gdfs == NULL) {
		for (;;) ;
	}
	gdFsGetFileSize(gdfs, &fsize);
	nsct = (fsize + 2047) / 2048;
	dat = syMalloc(nsct * 2048);
	if (dat == NULL) {
		for (;;) ;
	}
	gdFsRead(gdfs, nsct, dat);
	gdFsClose(gdfs);
	if (len != NULL) {
		*len = fsize;
	}

	return dat;
}

/***
 *		C
 *		MAIN
 ***/

/*	~hEFÃG[ɋN֐			*/
/*	Callback function when an error occur in middleware	*/
void UsrMwErrFunc(void *obj, char *ecode)
{
	errcnt++;
	strncpy(errmsg, ecode, ERRMSG_LEN);

	return;
}

/*	GDt@CVXẽG[ɋN֐			*/
/*	Callback function when an error occur in GD file system	*/
void UsrGdErrFunc(void *obj, Sint32 errcode)
{
	if (errcode == GDD_ERR_TRAYOPEND || errcode == GDD_ERR_UNITATTENT) {
		njUserExit();
	}

	return;
}

/*	[UV-SYNC荞݂ɓo^֐	*/
/*	Callback function when V-sync interrupt	*/
void UsrVsyncFunc(void)
{
	Sint32 dstat;

    vcount++;

    /*	TEhCũT[o֐		*/
	/*	Server function of sound library	*/
	sdSysServer();

	/*	hAI[v`FbN	*/
	/*	Check door open			*/
	dstat = gdFsGetDrvStat();
	if (dstat == GDD_DRVSTAT_OPEN || dstat == GDD_DRVSTAT_BUSY) {
		gdFsReqDrvStat();
	}

	return;
}


void njUserInit(void)
{
	void *snddrv;
	MWS_PLY_INIT_SFD	iprm;

	/*	~hEFÂ߂̃VXe (sbInitSystem̑Oɒu)	*/
	/*	Initialize system for middleware(call before sbInitSystem)	*/
	mwPlyPreInitSofdec();

	/*	ECȕ	*/
	/*	Initialize SHINOBI		*/
	njSetBorderColor(0x00000000);
	sbInitSystem(SYS_MODE, SYS_FRAME, SYS_COUNT);
	njInitVertexBuffer(VB_OP, VB_OM, VB_TP, VB_TM, VB_PT);
	njInitPrint(NULL, 0, 0);
	njInitMatrix(matrix, 8 , 0);
	njInit3D(vbuf, 4096);
	njInitView(&view);
	njCreateLight(&light, NJD_PHONG_DIR);
	njSetLightIntensity(&light, 1.5f, 1.0f, 0.7f);
	njSetLightAngle(&light, NJM_RAD_ANG(NJD_PI / 30.f),
							NJM_RAD_ANG(NJD_PI /  4.f));
	njSetLightDirection(&light, 0, 0.707f, -0.707f);
	njSetView(&view);
	njInitTexture(tex, 10);
	nwInitSystem(10,NJD_PORT_A0);
	njSetTextureInfo(&info,
						T009,NJD_TEXFMT_RGB_565|NJD_TEXFMT_TWIDDLED,128,128);
	njSetTextureName(&texname[0],&info, 0, 
							NJD_TEXATTR_TYPE_MEMORY|NJD_TEXATTR_GLOBALINDEX);
	njLoadTexture(&tlist1);
	njSetTexture(&tlist1);
	njControl3D(NJD_CONTROL_3D_CONSTANT_ATTR);
	njSetConstantAttr(0xffffffff,
				NJD_FLAG_USE_TEXTURE | NJD_FLAG_USE_ENV|NJD_FILTER_BILINEAR);
	njPrintSize(16);

	/*	GDt@CVXeG[R[obN֐̓o^	*/
	/*	Entry callback function of GD file system error	*/
	gdFsEntryErrFuncAll((void *)UsrGdErrFunc, NULL);

	/*	TEhCȕ	*/
	/*	Prepare sound library		*/
	snddrv = LoadFile("manatee.drv", NULL);
	SoundInit(snddrv);

	njSetVSyncFunction(UsrVsyncFunc);

	/*	~hEFACu	*/
	/*	Initialize middleware			*/
	memset(&iprm, 0, sizeof(iprm));	/*	\񃁃õ[ݒ̂߂ɕKv	*/
									/*	To initialize reserved member		*/
	iprm.mode		= SYS_MODE;
	iprm.frame		= SYS_FRAME;
	iprm.count		= SYS_COUNT;
	iprm.latency	= MWD_PLY_LATENCY(VB_OP, VB_OM, VB_TP, VB_TM, VB_PT);
	mwPlyInitSofdec(&iprm);

	/*	nh̐	*/
	/*	Create handle	*/
	memset(&cprm, 0, sizeof(cprm));	/*	\񃁃õ[ݒ̂߂ɕKv	*/
									/*	To initialize reserved member		*/
	cprm.ftype			= MWD_PLY_FTYPE_SFD;
	cprm.dtype			= MWD_PLY_DTYPE_AUTO;	/*	AUTO̕掿ǂ	*/
												/*	Quality is good in case 
												 *	of specified 'AUTO'.	*/
	cprm.max_bps = 450*1024*8;		/*	őrbgXg[(bit/sec)
									 *	ۂȂ邱Ƃ\B
									 *	[r[rŃt[YƂ
									 *	̒l𑝂₵ĂB			*/
									/*	Maximum number of bit per second
									 *	You can reduce it than a fact.
									 *	Increase this value when the movie
									 *	stops on the way.					*/
	cprm.max_width = 320;			/*	Đ摜TCY̍ő啝				*/
									/*	Maximum width of video stream		*/
	cprm.max_height = 480;			/*	Đ摜TCY̍ő卂			*/
									/*	Maximum height of video stream		*/
	cprm.nfrm_pool_wk = 3;			/*	VXë̃t[v[
									 *	WIɂ͂RŗǂAׂ
									 *	ϓɂR}ꍇ
									 *	₵ĂB					*/
									/*	Size of working area
									 *	It is good with 3 normally. But please
									 *	increase it when frame drop occurs by
									 *	processing load change.				*/
	cprm.wksize = mwPlyCalcWorkSofdec(	/*	Ɨ̈̑傫̌vZ			*/
										/*	Calculation of working area size*/
								cprm.ftype,
								cprm.max_bps,
								cprm.max_width,
								cprm.max_height,
								cprm.nfrm_pool_wk);
	cprm.work = syMalloc(cprm.wksize);	/*	Ɨ̈̊m					*/
										/*	Allocation of working area		*/
	ply = mwPlyCreateSofdec(&cprm);
	if (ply == NULL) {
		for (;;) ;
	}

	mwPlyEntryErrFunc((void *)UsrMwErrFunc, &ply);
	mwPlySetAudioSw(ply, AUDIO_SW);
	mwPlyPause(ply, pause);				/*	OĐ̃|[YԂێ		*/
										/*	Keep the last time pause status	*/
	mwPlyStartFname(ply, fname[file_no]);	/*	ĐJn					*/
											/*	Start to play middleware	*/

	return;
}

/*	̃t@C̍Đ	*/
/*	Play the next file	*/
void playNext(void)
{
	file_no = NEXT_FILE_NO(file_no, nfiles);
	mwPlyStop(ply);
	mwPlyDestroy(ply);
	ply = mwPlyCreateSofdec(&cprm);
	if (ply == NULL) {
		for (;;) ;
	}

	mwPlyEntryErrFunc((void *)UsrMwErrFunc, &ply);
	mwPlySetAudioSw(ply, AUDIO_SW);
	mwPlyPause(ply, pause);				/*	OĐ̃|[YԂێ		*/
										/*	Keep the last time pause status	*/
	mwPlySetVideoSw(ply, mv_video_output_flag);
	mwPlyStartFname(ply, fname[file_no]);

	return;
}

Sint32 njUserMain(void)
{
	const PDS_PERIPHERAL	*per;
	MWE_PLY_STAT			stat;

	mwPlyStartFrame();
	/*	ʒuETCYEs̐ݒ	*/
	mwPlySetDispPos(ply, mv_lx, mv_ly);
	mwPlySetDispSize(ply, mv_sx, mv_sy);
	mwPlySetDispZ(ply, mv_lz);
	if ( mv_lx  >= 320 || mv_lx <= 0 )
		mv_vlx *= -1;
	if ( mv_ly  >= 240 || mv_ly <= 0 )
		mv_vly *= -1;
	if ( mv_sx <= 160 || mv_sx >= 480 )
		mv_vsx *= -1;
	if ( mv_sy <= 120 || mv_sy >= 360 )
		mv_vsy *= -1;
	if ( mv_lz <= 6.0 || mv_lz >= 14.0 )
		mv_vlz *= -1.0;
	mv_lx += mv_vlx, mv_ly += mv_vly, mv_lz += mv_vlz;
	mv_sx += mv_vsx, mv_sy += mv_vsy;

	per = pdGetPeripheral(PDD_PORT_A0);
	if (per->press & PDD_DGT_ST) {
		playNext();
	}
	if (per->press & PDD_DGT_TA) {
		disp_flag = NOT_FLAG(disp_flag);
	}
	if (per->press & PDD_DGT_TB) {
		mv_video_output_flag = NOT_FLAG(mv_video_output_flag);
		mwPlySetVideoSw(ply, mv_video_output_flag);
	}
	if (per->press & PDD_DGT_TX) {
		pause = ON;
		mwPlyPause(ply, ON);		/*	ꎞ~				*/
									/*	Pause					*/
	}
	if (per->press & PDD_DGT_TY) {
		pause = OFF;
		mwPlyPause(ply, OFF);		/*	ꎞ~			*/
									/*	Release pause status	*/
	}

	/*	ĐĨ`FbN	*/
	/*	Check end of play	*/
	stat = mwPlyGetStat(ply);
	if ((stat == MWE_PLY_STAT_PLAYEND) || (stat == MWE_PLY_STAT_ERROR)) {
		playNext();
	}

	/*	Teapot̕\			*/
	/*	Operation of display Teapot	*/
	njClearMatrix();
	njTranslate( NULL, 0.f, 0.f, -12.f );
	njRotateXYZ( NULL, xx, yy, zz );
	if (disp_flag) {
		njDrawObject(OBJECT);
	}
	xx += 257;
	yy += 179;
	zz += 193;
	njPrintD(NJM_LOCATION(2,3), vcount, 8);

	mwPlyExecServer();

	return nwExecute();
}

void njUserExit(void)
{
	mwPlyFinishSofdec();	/*	CuI					*/
							/*	Finalize Middleware					*/
	nwExitSystem();
	njExitPrint();
	njExitTexture();

	sbExitSystem();			/*	ECȕI				*/
							/*	Finalize SHINOBI					*/
	syBtExit();				/*	VvvCփWv			*/
							/*	Jump to Simple player				*/

	return;
}


/* end of file */
