/*
 *
 *		Middleware MPEG Sofdec Player Sample
 *
 */

/***************************************************************************
 *      CN[ht@C
 *      Include file
 ***************************************************************************/
#include <shinobi.h>
#include <sg_sd.h>
#include <sg_mw.h>
#include <cri_adxt.h>


/***************************************************************************
 *      萔}N
 *      MACRO CONSTANT
 ***************************************************************************/
/*	\[h		*/
/*	Display mode	*/
#define SYS_MODE		NJD_RESOLUTION_640x480_NTSCI
#define SYS_FRAME		NJD_FRAMEBUFFER_MODE_ARGB8888
#define SYS_COUNT		1

/*	_obt@TCY(1}CiXɂ2V[eV[h)			*/
/*	Vertex buffer size(2V latency mode is when a valiable is minus.)	*/
#define VB_OP			-500000
#define VB_OM			0
#define VB_TP			20000
#define VB_TM			0
#define VB_PT			0

/*
 * Đ̎w
 *   ON   :蓮t@CȂΉĐsBftHgB
 *   OFF  :Đ}~B蓮t@CłfĐB
 * Setting play audio
 *   ON   :Play audio when the animation file is interleaved audio(default)
 *   OFF  :Not play audio
 */
#define AUDIO_SW		ON

/*	G[bZ[W		*/
/*	Length of error message	*/
#define ERRMSG_LEN		256

/*	ő`l				*/
/*	The number of maximum channels	*/
#define	MAX_CH			(2)

/*	ĐőCDXg[									*/
/*	The number of maximum CD streams playing at the same time	*/
#define	MAX_CDSTM		(1)

/*	ōTvOg		*/
/*	Maximum sampling frequency	*/
#define	MAX_SFREQ		(44100)

/*	t@CĐp[N̈̑傫	*/
/*	Work area size of CD stream play	*/
#define	WKSIZE		(ADXT_CALC_WORK(MAX_CH, 1, MAX_CDSTM, MAX_SFREQ))

/***************************************************************************
 *      }N
 *      Process MACRO
 ***************************************************************************/

/*	tOON/OFF̔]		*/
/*	Turn over flag(ON/OFF)	*/
#define NOT_FLAG(flag)		(((flag) == OFF) ? ON : OFF)


/***************************************************************************
 *      ϐ`
 *		Variable Declaration
 ***************************************************************************/

/*	G[		*/
/*	The number of error	*/
Sint32 errcnt = 0;

/*	G[bZ[W	*/
/*	Error message		*/
char errmsg[ERRMSG_LEN] = "(OK)";

/*	\tO				*/
/*	Flag for a show of character	*/
Sint32 disp_flag = ON;

/*	|[Y		*/
/*	Pause status	*/
Sint32 pause = OFF;

/*	t@CĐp ADXT [N̈	*/
/*	Work area						*/
char work[WKSIZE];

/*	ADXT nh	*/
/*	ADXT handle		*/
ADXT adxt;

/***************************************************************************
 *      ֐`
 *      Function Declaration
 ***************************************************************************/

/***
 *		TEh̏
 *		Initialize sound section
 ***/

/*	TEhhCo̓]E					*/
/*	Initialize sound library and load sound driver	*/
Void SoundInit(Void *ptr)
{
	SDMEMBLK	memblk = NULL;

	/*	Initialize Sound library	 */
	sdLibInit(NULL, 0, 0);		/*	This api's argument is dummy now.  */

	/* 	Download and Initialize Sound driver.	 */
	/*	Create Memory block handle  */
	sdMemBlkCreate(&memblk);
	/*  Setting Memoby block handle  */
	sdMemBlkSetPrm(memblk, ptr, 0, SDD_MEMBLK_SYNC_FUNC, NULL);
	/*	Initialize Sound driver  */
	sdDrvInit(memblk);
	sdMemBlkDestroy(memblk);

	/*	][h̐ݒ		*/
	/*	Setting transfer mode	*/
	sdMemBlkSetTransferMode(SDE_MEMBLK_TRANSFER_MODE_DMA);

	return;
}

/***
 *			[eBeB֐
 *			Utility function
 ***/

/*	f[^̓ǂݍ	*/
/*	Load data to memory	*/
void *LoadFile(char *fname, long *len)
{
	GDFS			gdfs;
	long			fsize, nsct;
	void			*dat;

	gdfs = gdFsOpen(fname, NULL);
	if (gdfs == NULL) {
		for (;;) ;
	}
	gdFsGetFileSize(gdfs, &fsize);
	nsct = (fsize + 2047) / 2048;
	dat = syMalloc(nsct * 2048);
	if (dat == NULL) {
		for (;;) ;
	}
	gdFsRead(gdfs, nsct, dat);
	gdFsClose(gdfs);
	if (len != NULL) {
		*len = fsize;
	}

	return dat;
}

/*	msec -> time(hour,min,sec,frame)	*/
void Msec2Time(long mstime, long *hh, long *mm, long *ss, long *ff)
{
	*hh = mstime / (60*60*1000);
	*mm = (mstime - *hh*60*60*1000) / (60*1000);
	*ss = (mstime - *hh*60*60*1000 - *mm*60*1000) / 1000;
	*ff = mstime % 1000;

	return;
}

/***
 *			~hEFA̍Đ
 *			Playing middleware
 ***/

/*	~hEFÃG[ɋN֐			*/
/*	Callback function when an error occur in middleware	*/
void UsrMwErrFunc(void *obj, char *ecode)
{
	errcnt++;
	strncpy(errmsg, ecode, ERRMSG_LEN);

	return;
}

/*	̕\			*/
/*	Display infomation	*/
void DispInfoMw(MWPLY ply, char *fname)
{
	long			time, tunit, hh, mm, ss, ff, time_ms;
	float			timef;

	mwPlyGetTime(ply, &time, &tunit);
	timef = ((float)time / (float)tunit) * 1000.0;
	time_ms = (long)timef;
	Msec2Time(time_ms, &hh, &mm, &ss, &ff);
	ff = ff*30/1000;
	njPrint(NJM_LOCATION(0, 3), "File: %s  Time:%02d:%02d:%02d.%02d", 
							fname, hh, mm, ss, ff);
	njPrint(NJM_LOCATION(0, 4), "Error%2d:%s", errcnt, errmsg);

	return;
}

/*	̕\			*/
/*	Display infomation	*/
void DispInfoAdx(ADXT adxt, char *fname)
{
	long	time, tunit, hh, mm, ss, ff, time_ms;
	float	timef;

	ADXT_GetTime(adxt, &time, &tunit);
	timef = ((float)time / (float)tunit) * 1000.0;
	time_ms = (long)timef;
	Msec2Time(time_ms, &hh, &mm, &ss, &ff);
	ff = ff*30/1000;
	njPrint(NJM_LOCATION(0, 35), "File: %s  Time:%02d:%02d:%02d.%02d", 
							fname, hh, mm, ss, ff);

	return;
}

/*	̍Đ					*/
/*	Playing the animation file	*/
void SmpPlay(char *fname)
{
	MWPLY					ply;
	MWS_PLY_CPRM_SFD		cprm;
	MWE_PLY_STAT			mw_stat;
	long					adx_stat;
	char					*adx_fname="NARE_SMP.ADX";
	const PDS_PERIPHERAL	*per;

	/*	nh̐	*/
	/*	Create handle	*/
	memset(&cprm, 0, sizeof(cprm));	/*	\񃁃õ[ݒ̂߂ɕKv	*/
									/*	To initialize reserved member		*/
	cprm.ftype			= MWD_PLY_FTYPE_SFD;
	cprm.dtype			= MWD_PLY_DTYPE_AUTO;
	cprm.max_bps = (450*1024*8)*3/2;		/*	ʏ1.5{					*/
	cprm.max_width = 288;
	cprm.max_height = 160;
	cprm.nfrm_pool_wk = 3;
	cprm.wksize = mwPlyCalcWorkSofdec(
								cprm.ftype,
								cprm.max_bps,
								cprm.max_width,
								cprm.max_height,
								cprm.nfrm_pool_wk);
	cprm.work = syMalloc(cprm.wksize);
	ply = mwPlyCreateSofdec(&cprm);
	if (ply == NULL) {
		for (;;) ;
	}

	mwPlyEntryErrFunc(UsrMwErrFunc, &ply);
	mwPlySetAudioSw(ply, AUDIO_SW);
	mwPlyPause(ply, pause);				/*	OĐ̃|[YԂێ		*/
										/*	Keep the last time pause status	*/
	mwPlyStartFname(ply, fname);		/*	ĐJn						*/
										/*	Start to play middleware		*/
	while (1) {
		njWaitVSync();
		mwPlyStartFrame();
		per = pdGetPeripheral(NJD_PORT_A0);
		if (per->press & PDD_DGT_TA) {
			disp_flag = NOT_FLAG(disp_flag);
		}
		if (per->press & PDD_DGT_TL) {
			mwPlySetOutVol(ply, -60);
			ADXT_StartFname(adxt, adx_fname);
		}
		if (per->press & PDD_DGT_TR) {
			ADXT_Stop(adxt);
		}
		if (per->press & PDD_DGT_TX) {
			pause = ON;
			mwPlyPause(ply, ON);		/*	ꎞ~				*/
										/*	Pause					*/
		}
		if (per->press & PDD_DGT_TY) {
			pause = OFF;
			mwPlyPause(ply, OFF);		/*	ꎞ~			*/
										/*	Release pause status	*/
		}
		if (per->press & PDD_DGT_ST) {
			break;
		}
		mw_stat = mwPlyGetStat(ply);
		if ((mw_stat == MWE_PLY_STAT_PLAYEND)
			 || (mw_stat == MWE_PLY_STAT_ERROR)) {
			break;
		}
		if (disp_flag == ON) {
			DispInfoMw(ply, fname);
			adx_stat = ADXT_GetStat(adxt);
			if ((adx_stat == ADXT_STAT_PLAYING)
				|| (adx_stat == ADXT_STAT_DECEND)) {
					DispInfoAdx(adxt, adx_fname);
			}
		}
		mwPlyExecServer();
	}
	mwPlyStop(ply);						/*	Đ~ 					*/
										/*	Stop to play middleware		*/
	njWaitVSync();						/*	pbh̏Ԏ擾̂		*/
										/*	for getting status of PAD	*/
	mwPlyDestroy(ply);					/*	nh				*/
										/*	Destroy handle				*/
	syFree(cprm.work);

	return;
}

/***
 *		C
 *		MAIN
 ***/

/*	AvP[VI	*/
/*	Finalize application		*/
void UsrExit(void)
{
	ADXT_Finish();			/*	ADXTCuI				*/
							/*	Finalize ADXT library				*/
	mwPlyFinishSofdec();	/*	CuI					*/
							/*	Finalize Middleware					*/
	sbExitSystem();			/*	ECȕI				*/
							/*	Finalize SHINOBI					*/
	syBtExit();				/*	VvvCփWv			*/
							/*	Jump to Simple player				*/
}

/*	GDt@CVXẽG[ɋN֐			*/
/*	Callback function when an error occur in GD file system	*/
void UsrGdErrFunc(void *obj, Sint32 errcode)
{
	if (errcode == GDD_ERR_TRAYOPEND || errcode == GDD_ERR_UNITATTENT) {
		UsrExit();					/*	AvP[VI	*/
									/*	Finalize application		*/
	}

	return;
}

/*	[UV-SYNC荞݂ɓo^֐	*/
/*	Callback function when V-sync interrupt	*/
void UsrVsyncFunc(void)
{
	Sint32 dstat;

    /*	TEhCũT[o֐		*/
	/*	Server function of sound library	*/
	sdSysServer();

	/*	hAI[v`FbN	*/
	/*	Check door open			*/
	dstat = gdFsGetDrvStat();
	if (dstat == GDD_DRVSTAT_OPEN || dstat == GDD_DRVSTAT_BUSY) {
		gdFsReqDrvStat();
	}

	return;
}

void main(void)
{
	MWS_PLY_INIT_SFD	iprm;
	void				*snddrv;

	/*	~hEFÂ߂̃VXe (sbInitSystem̑Oɒu)	*/
	/*	Initialize system for middleware(call before sbInitSystem)	*/
	mwPlyPreInitSofdec();

	/*	ECȕ	*/
	/*	Initialize SHINOBI		*/
	njSetBorderColor(0x00000000);
	sbInitSystem(SYS_MODE, SYS_FRAME, SYS_COUNT);
	njInitVertexBuffer(VB_OP, VB_OM, VB_TP, VB_TM, VB_PT);
	njInitPrint(NULL, 0, NJD_TEXFMT_ARGB_8888);
	njPrintSize(12);
	/*	GDt@CVXeG[R[obN֐̓o^	*/
	/*	Entry callback function of GD file system error	*/
	gdFsEntryErrFuncAll((void *)UsrGdErrFunc, NULL);

	/*	TEhCȕ	*/
	/*	Prepare sound library		*/
	snddrv = LoadFile("manatee.drv", NULL);
	SoundInit(snddrv);

	njSetVSyncFunction(UsrVsyncFunc);

	/*	~hEFACu	*/
	/*	Initialize middleware			*/
	memset(&iprm, 0, sizeof(iprm));	/*	\񃁃õ[ݒ̂߂ɕKv	*/
									/*	To initialize reserved member		*/
	iprm.mode		= SYS_MODE;
	iprm.frame		= SYS_FRAME;
	iprm.count		= SYS_COUNT;
	iprm.latency	= MWD_PLY_LATENCY(VB_OP, VB_OM, VB_TP, VB_TM, VB_PT);
	mwPlyInitSofdec(&iprm);

	/*	ADXCu		*/
	/*	Initialize ADX library	*/
	ADXT_Init();
	/*	ADXT nh̐	*/
	/*	Create ADXT handle	*/
	if ( (adxt=ADXT_Create(2, work, WKSIZE)) == NULL ) {
		for (;;) {
			njPrint(NJM_LOCATION(5, 5), "can't create ADXT\n");
			njWaitVSync();
		}
	}

	for (;;) {
		SmpPlay("SAMPLE.SFD");		/*	̍Đ			*/
									/*	Playing animation	*/
	}

	UsrExit();						/*	AvP[VI	*/
									/*	Finalize application		*/
}


/* end of file */
