
/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F XvCgilp`|Sjɔ
              alpha
  ҏW F 98-04-24 Jn
              98-05-12 R[fBOKɍ킹
              98-05-15 SET2/4؂ւ}Nǉ
              98-05-25 SET4RpC̃oOC
              98-06-19 SET5Ή
              98-07-07 C0ĂtɑΉi|[Yǉj
              98-08-20 _obt@TCYύX
              98-09-16 eNX`obt@mۂ̃TCYύX
              99-04-05 appends the English comments
************************************************************/


#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}

#define SPRITE_NUM 2
#define TEXNUM 2
#define MAX_VERTEXES 200 * 20

static NJS_VERTEX_BUF *VBuf;

/* eNX`ݒ */
/* texture */
static NJS_TEXNAME Texname[] = {
   /* t@C                    Agr[g                 hc */
   /* file name                     attribute                       ID  */
    {"sprite1.pvr", NJD_TEXATTR_GLOBALINDEX, 0},
    {"sprite2.pvr", NJD_TEXATTR_GLOBALINDEX, 1},
};
static NJS_TEXLIST Texlist = {Texname, TEXNUM};
static NJS_TEXANIM Texanim[] = {
   /* TCY   SW  eNX`tul eNX`hc Agr[g */
   /* size(x,y) center(x,y) texture u,v, texture id , attribute         */
    {400, 300, 200, 150,  0, 0, 255, 255,        0,             0},
    {400, 300, 200, 150,  0, 0, 255, 255,        1,             0},
};
static NJS_TEXMEMLIST Texmemlist[TEXNUM];

static NJS_SPRITE Sprite[SPRITE_NUM];
static NJS_ARGB  Argb;

PDS_PERIPHERAL* Per;

void PauseMode(void);

/************************************************************
  ֐
  initialize
************************************************************/
void njUserInit(void)
{
    /* VXe */
    /* Initializes the Dreamcast H/W and readies the SEGA library */
    sbInitSystem(NJD_RESOLUTION_320x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);

    /* vertexobt@̊m */
    /* allocates the memory */
    VBuf = (NJS_VERTEX_BUF *)syMalloc(sizeof (NJS_VERTEX_BUF) * MAX_VERTEXES);

    /* obNOEhJ[ݒ */
	/* sets background color */
    njSetBackColor(ARGB(0, 128, 0, 128),
        ARGB(0, 128, 0, 128), ARGB(0, 0, 0, 0));

    /* eNX`obt@̊m */
    /* sets necessary memory for work area of a texture */
    njInitTextureBuffer((Sint8 *)VBuf,0x800*10);

    /* _f[^o^pobt@AP[g */
    /* allocates the buffers for registration of vertex data */
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );

    /* eNX`i[̈ݒ */
    /* sets the area used for storing texture information */
    njInitTexture(Texmemlist, TEXNUM);

    /* eNX`[h */
    /* loads the textuer */
    njLoadTexture(&Texlist);

    /* XvCg̓ݒ */
    /* sets the sprite attribute */
    Sprite[0].p.x = 120;
    Sprite[0].p.y = 100;
    Sprite[0].sx = 0.5F;
    Sprite[0].sy = 0.5F;
    Sprite[0].ang = NJM_DEG_ANG(0.0F);
    Sprite[0].tlist = &Texlist;
    Sprite[0].tanim = Texanim;
    Sprite[1].p.x = 200;
    Sprite[1].p.y = 150;
    Sprite[1].sx = 0.5F;
    Sprite[1].sy = 0.5F;
    Sprite[1].ang = NJM_DEG_ANG(0.0F);
    Sprite[1].tlist = &Texlist;
    Sprite[1].tanim = Texanim;

    /* fAIuWFNg̕`Rg[ */
    /* controls drawing of models and objects */
    njControl3D(NJD_CONTROL_3D_CONSTANT_MATERIAL);
    Argb.r = 1.0F;
    Argb.g = 1.0F;
    Argb.b = 1.0F;

    /* fobO̐F */
  	/* sets the text color */
    njPrintColor(ARGB(255, 150, 150, 150));
}

/************************************************************
  s郁C
  main
************************************************************/
Sint32 njUserMain(void)
{
    /* ȉ̃ufBO[h炻ꂼI */
    /* blending mode */
    static const Int blendingModeTable[] = {
        /*  0 */ NJD_COLOR_BLENDING_BOTHINVALPHA,
        /*  1 */ NJD_COLOR_BLENDING_BOTHSRCALPHA,
        /*  2 */ NJD_COLOR_BLENDING_DESTALPHA,
        /*  3 */ NJD_COLOR_BLENDING_DESTCOLOR,
        /*  4 */ NJD_COLOR_BLENDING_INVDESTALPHA,
        /*  5 */ NJD_COLOR_BLENDING_INVDESTCOLOR,
        /*  6 */ NJD_COLOR_BLENDING_INVSRCALPHA,
        /*  7 */ NJD_COLOR_BLENDING_INVSRCCOLOR,
        /*  8 */ NJD_COLOR_BLENDING_SRCALPHA,
        /*  9 */ NJD_COLOR_BLENDING_SRCCOLOR,
        /* 10 */ NJD_COLOR_BLENDING_ONE,
        /* 11 */ NJD_COLOR_BLENDING_ZERO,
    };

    static Bool pauseMode = FALSE;

    Int srcBlendingMode = blendingModeTable[8];
    Int destBlendingMode = blendingModeTable[6];

    static Float step = 0.01F;

    /* Tv̕\ */
    /* prints the sample program name */
    njPrintC(NJM_LOCATION(4, 3), "Ninja Sample (Sprite Alpha Blending)");
    njPrintC(NJM_LOCATION(4, 5), "Press Start Button To Pause");

    /* ytF`FbN */
    /* gets the peripheral infomation */
    Per = pdGetPeripheral(PDD_PORT_A0);
    if (Per->press & PDD_DGT_ST) { /* X^[g{^ꂽ */
                                   /* pressing the start button ? */
        pauseMode = !pauseMode;
    }
    /* |[Yʂ */
    /* puase */
    if (pauseMode == TRUE) {
        static NJS_POINT2 pnt[4] = { 0, 0, 640, 0, 640, 480, 0, 480 };
        static NJS_COLOR col[4] = {
            ARGB(150, 0, 0, 0), ARGB(150, 0, 0, 0),
            ARGB(150, 0, 0, 0), ARGB(150, 0, 0, 0),
        };
        static NJS_POINT2COL p2c = { pnt, col, NULL, 4 };

        njColorBlendingMode(0, NJD_COLOR_BLENDING_BOTHSRCALPHA);
        njDrawPolygon2D(&p2c, 4, -1.0F, NJD_FILL | NJD_TRANSPARENT);

        PauseMode();
    }

    /* l̐ݒ */
    /* sets the alpha value */
    if (pauseMode == FALSE) {
        Argb.a = Argb.a + step;
        if (Argb.a >= 1.0F || Argb.a <= 0.0F) {
            step = -step;
        }
        /* f}eA̐ݒ  */
        /* sets model materials */
        njSetConstantMaterial(&Argb);
    }

    /* XvCg̃ufBO[hݒ */
    /* sets the blending mode of the upper left sprite */
    njColorBlendingMode(NJD_SOURCE_COLOR, blendingModeTable[10]);
    njColorBlendingMode(NJD_DESTINATION_COLOR, blendingModeTable[11]);
 
    /* QcXvCgij̕\ */
    /* draw upper left sprite */
    njDrawSprite2D(&Sprite[0], 0, -3.0F, NJD_SPRITE_ALPHA | NJD_SPRITE_COLOR);

    /* EXvCg̃ufBO[hݒ */
    /* sets the blending mode of the  lower right sprite */
    njColorBlendingMode(NJD_SOURCE_COLOR, srcBlendingMode);
    njColorBlendingMode(NJD_DESTINATION_COLOR, destBlendingMode);

    /* QcXvCgiEj̕\ */
    /* draw lower right sprite */
    njDrawSprite2D(&Sprite[1], 1, -2.0F, NJD_SPRITE_ALPHA | NJD_SPRITE_COLOR);

    return NJD_USER_CONTINUE;
}

/************************************************************
  sIɌĂяoI
  exit
************************************************************/
void njUserExit(void)
{
	njExitPrint();
    njExitTexture();
    syFree(VBuf);
    sbExitSystem();
}

/************************************************************
  |[YɌĂяo鏈
  pause routine
************************************************************/
void PauseMode(void)
{
    static Sint16 interval = 0;
    static Bool display = TRUE;

    interval++;
    if (interval >= 30) {
        display = !display;
        interval = 0;
    }
    if (display == TRUE) {
        njPrintSize(16);
        njPrintC(NJM_LOCATION(7, 6),"PAUSE!");
        njPrintSize(8);
    }
}
