/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F XN[gk
              scroll
  ҏW F 98-04-27 Jn
              98-06-19 SET5Ή
              98-09-16 eNX`obt@mۂ̃TCYύX
              99-04-05 appends the English comments
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}


/* O[oZNV */
/* global data          */

#define VERTEX_MAX  1000     /* _̍ő吔          */
                             /* maximum vertex number */
/* eNX`f[^ */
/* texture data */
#define TEXTURE_NUM  1  /* eNX`f[^̐       */
                        /* the number of texture data */
static NJS_VERTEX_BUF *vbuf;

/* LbVɓǂݍ܂eNX``          */
/* defines the textuer data that loads to the cache memory */
static NJS_TEXNAME g_TexName[] = {"tex.pvr", NJD_TEXATTR_GLOBALINDEX, 0};
static NJS_TEXLIST g_TexList = {g_TexName, TEXTURE_NUM};
static NJS_TEXMEMLIST g_Texture[TEXTURE_NUM];

/* XN[pf[^ */
/* scroll data        */
#define MAP_CELL_WIDTH  5
#define MAP_CELL_HEIGHT 4

static Uint32 g_Map[MAP_CELL_HEIGHT][MAP_CELL_WIDTH] = {
    {NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), 
                                NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0)},
    {NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), 
                                NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0)},
    {NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), 
                                NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0)},
    {NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), 
                                NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0)},
};

static NJS_SCROLL g_Scroll;

/* |[YtO */
/* pause flag       */
Bool g_bPause = FALSE;

/* |[Y֐ */
/* pause function   */
void PausePhase(void);
/* ANeBu֐ */
/* active (not pause) function */
void ActivePhase(void);

/***************************************************************************

	njSetBorderColor( 0x00000000 );
    njUserInit --- NinjaVXe֐
                   initialize
***************************************************************************/

void njUserInit (void)
{
    /* ʃ[ȟ */
    /* Initializes the Dreamcast H/W and readies the SEGA library */
    sbInitSystem(NJD_RESOLUTION_320x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);
	
    vbuf = (NJS_VERTEX_BUF *)syMalloc(sizeof (NJS_VERTEX_BUF) * VERTEX_MAX);

    /* eNX`obt@̊m */
    /* sets necessary memory for work area of a texture */
    njInitTextureBuffer((Sint8 *)vbuf,0x800*10);

    /* _̍ő吔obt@AP[g */
    /* allocates the buffers for registration of vertex data */
    njInitVertexBuffer(VERTEX_MAX * 64 / 4, 0, VERTEX_MAX * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );

    /* eNX`̃[hƃZbgAbv */
    /* loads and sets up the texture */

    njInitTexture(g_Texture, TEXTURE_NUM);  /* eNX`f[^̈m */
                                            /* sets the area used for storing texture information */
    njLoadTexture(&g_TexList);  /* eNX`XgɂeNX`f[^*/
                                /* eNX`Ƀ[h */
                                /* loads the texture to cache memory */

    /* XN[̃ZbgAbv */
    /* sets up scroll data */
    g_Scroll.celps = 128;           /* Z̃sNZTCY */
                                    /* scroll cell size     */
    g_Scroll.mapw = MAP_CELL_WIDTH; /* }bv̉̃Ž */
                                    /* scroll map width           */
    g_Scroll.maph = MAP_CELL_HEIGHT;/* }bv̏c̃Ž */
                                    /* scroll map height          */
    g_Scroll.sw = 0;                /* XN[ʂ̕`扡̑傫 */
                                    /* currentry unused                 */
    g_Scroll.sh = 0;                /* XN[ʂ̕`c̑傫 */
                                    /* currentry unused                 */
    g_Scroll.list = &g_TexList;     /* eNX`Xgw */
                                    /* Texture list pointer   */
    g_Scroll.map = (Uint32 *)g_Map; /* }bvzw   */
                                    /*  Map array pointer */
    g_Scroll.px = 0.0F;             /* XN[ʂ̈ړW           */
    g_Scroll.py = 0.0F;             /* scroll surface movement coordinate */
    g_Scroll.bx = 0.0F;             /* }bv̏n߂̍W */
    g_Scroll.by = 0.0F;             /* map home coordinates   */
    g_Scroll.pr = -100.0F;          /* XN[̃vCIeBiD揇ʁj*/
                                    /* priority                              */
    g_Scroll.sflag = OFF;           /* gk邩Ȃ̃tO  */
                                    /* scale flag (do not use scale) */
    g_Scroll.mflag = OFF;           /* ]邩Ȃ̃tO               */
                                    /* rotation matrix flag (do not use rotation) */
    g_Scroll.colmode = NJD_COLOR_MODE_PACKED_TEXTURE;/* J[[h̎w */
                                                     /* scroll color mode  */
    g_Scroll.sclc.argb.a = 255;     /* XN[ŜɂJ[ */
    g_Scroll.sclc.argb.r = 255;     /* scroll screen vertex color   */
    g_Scroll.sclc.argb.g = 255;
    g_Scroll.sclc.argb.b = 255;

    /* wiݒ */
    /* sets the background */
    /*  E  ̃J[w */
    /* sets the colors of upper left, upper right and lower left */
    njSetBackColor(0xffc00000, 0xff00c000, 0xff0000c0); 
    /* eLXg̃J[w */
    /* sets the text color */
    njPrintColor(ARGB(0xff, 0xc0, 0xc0, 0xc0));
}


/***************************************************************************

    njUserMain --- NinjaVXeC֐

***************************************************************************/

Sint32 njUserMain(void)
{
    NJS_PERIPHERAL *per;

    /* WCXeBbN|[gP̃ytF擾 */
    /* gets the peripheral infomation */
    per = njGetPeripheral(NJD_PORT_A0);    

    /* {^ꂽǂ`FbN */
    /* checks the start button */
    if (per->press & NJD_DGT_ST) {
        g_bPause = !g_bPause;
    }

	if (!g_bPause) {
	    /* XN[̕` */
		/* draws a 2D scroll surface */
   		njDrawScroll(&g_Scroll);
	} else {
	    njPrintC(NJM_LOCATION(19, 15), "PAUSE");
	}	
	
    /* fobO̕\ */
    /* prints the sample program name */
    njPrintC(NJM_LOCATION(10, 6), "Ninja Sample SCROLL");
    
    return NJD_USER_CONTINUE;
}


/***************************************************************************

    njUserExit --- NinjaVXeI֐
                   exit
***************************************************************************/

void njUserExit(void)
{
	njExitPrint();
    njExitTexture();
    sbExitSystem(); /* VXȅIs܂ */
                    /* exits the system    */

}
