
/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F XN[̕\ivCIeB̕ύXj
              scroll( changes priority )
  ҏW F 98-04-28 Jn
              98-04-30 pvrt@C̃pX̕ύX
                       sKvȋ@\̍폜
              98-04-30 XN[G̕ύX
              98-04-30 vCIeB`FW̕@ύX
              98-05-12 R[fBOKɍ킹
              98-05-15 SET2/4؂ւ}Nǉ
              98-05-25 SET4RpC̃oOC
              98-06-18 SET5Ή
              98-07-08 C0ĂtɑΉi|[Yǉj
              98-09-16 eNX`obt@mۂ̃TCYύX
              99-04-07 appends the English comments
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}

#define MAX_VERTEXES 10000
#define TEX_NUM 2000

static NJS_VERTEX_BUF *VBuf;

/* XN[ŎgeNX`̐ݒ */
/* textures for scroll surface #1 */
static NJS_TEXNAME Texture0[] = {
    {"mae00.pvr", NJD_TEXATTR_GLOBALINDEX, 1000}, /* 00 */
    {"mae01.pvr", NJD_TEXATTR_GLOBALINDEX, 1001}, /* 01 */
    {"mae02.pvr", NJD_TEXATTR_GLOBALINDEX, 1002}, /* 02 */
    {"mae03.pvr", NJD_TEXATTR_GLOBALINDEX, 1003}, /* 03 */
    {"mae04.pvr", NJD_TEXATTR_GLOBALINDEX, 1004}, /* 04 */
    {"mae05.pvr", NJD_TEXATTR_GLOBALINDEX, 1005}, /* 05 */
    {"mae06.pvr", NJD_TEXATTR_GLOBALINDEX, 1006}, /* 06 */
    {"mae07.pvr", NJD_TEXATTR_GLOBALINDEX, 1007}, /* 07 */
    {"mae08.pvr", NJD_TEXATTR_GLOBALINDEX, 1008}, /* 08 */
    {"mae09.pvr", NJD_TEXATTR_GLOBALINDEX, 1009}, /* 09 */
    {"mae10.pvr", NJD_TEXATTR_GLOBALINDEX, 1010}, /* 10 */
    {"mae11.pvr", NJD_TEXATTR_GLOBALINDEX, 1011}, /* 11 */
    {"mae12.pvr", NJD_TEXATTR_GLOBALINDEX, 1012}, /* 12 */
    {"mae13.pvr", NJD_TEXATTR_GLOBALINDEX, 1013}, /* 13 */
    {"mae14.pvr", NJD_TEXATTR_GLOBALINDEX, 1014}, /* 14 */
    {"mae15.pvr", NJD_TEXATTR_GLOBALINDEX, 1015}, /* 15 */
    {"mae16.pvr", NJD_TEXATTR_GLOBALINDEX, 1016}, /* 16 */
    {"mae17.pvr", NJD_TEXATTR_GLOBALINDEX, 1017}, /* 17 */
    {"mae18.pvr", NJD_TEXATTR_GLOBALINDEX, 1018}, /* 18 */
    {"mae19.pvr", NJD_TEXATTR_GLOBALINDEX, 1019}, /* 19 */
    {"mae20.pvr", NJD_TEXATTR_GLOBALINDEX, 1020}, /* 20 */
    {"mae21.pvr", NJD_TEXATTR_GLOBALINDEX, 1021}, /* 21 */
    {"mae22.pvr", NJD_TEXATTR_GLOBALINDEX, 1022}, /* 22 */
    {"mae23.pvr", NJD_TEXATTR_GLOBALINDEX, 1023}, /* 23 */
    {"mae24.pvr", NJD_TEXATTR_GLOBALINDEX, 1024}, /* 24 */
    {"mae25.pvr", NJD_TEXATTR_GLOBALINDEX, 1025}, /* 25 */
    {"mae26.pvr", NJD_TEXATTR_GLOBALINDEX, 1026}, /* 26 */
    {"mae27.pvr", NJD_TEXATTR_GLOBALINDEX, 1027}, /* 27 */
};

static NJS_TEXLIST Texlist0 = {Texture0, 28};

/* XN[PŎgeNX`̐ݒ */
/* textures for scroll surface #2 */
static NJS_TEXNAME Texture1[] = {
    {"mae00.pvr", NJD_TEXATTR_GLOBALINDEX, 1100}, /* 00 */
    {"mae01.pvr", NJD_TEXATTR_GLOBALINDEX, 1101}, /* 01 */
    {"mae02.pvr", NJD_TEXATTR_GLOBALINDEX, 1102}, /* 02 */
    {"mae03.pvr", NJD_TEXATTR_GLOBALINDEX, 1103}, /* 03 */
    {"mae04.pvr", NJD_TEXATTR_GLOBALINDEX, 1104}, /* 04 */
    {"mae05.pvr", NJD_TEXATTR_GLOBALINDEX, 1105}, /* 05 */
    {"mae06.pvr", NJD_TEXATTR_GLOBALINDEX, 1106}, /* 06 */
    {"mae07.pvr", NJD_TEXATTR_GLOBALINDEX, 1107}, /* 07 */
    {"mae08.pvr", NJD_TEXATTR_GLOBALINDEX, 1108}, /* 08 */
    {"mae09.pvr", NJD_TEXATTR_GLOBALINDEX, 1109}, /* 09 */
    {"mae10.pvr", NJD_TEXATTR_GLOBALINDEX, 1110}, /* 10 */
    {"mae11.pvr", NJD_TEXATTR_GLOBALINDEX, 1111}, /* 11 */
    {"mae12.pvr", NJD_TEXATTR_GLOBALINDEX, 1112}, /* 12 */
    {"mae13.pvr", NJD_TEXATTR_GLOBALINDEX, 1113}, /* 13 */
    {"mae14.pvr", NJD_TEXATTR_GLOBALINDEX, 1114}, /* 14 */
    {"mae15.pvr", NJD_TEXATTR_GLOBALINDEX, 1115}, /* 15 */
    {"mae16.pvr", NJD_TEXATTR_GLOBALINDEX, 1116}, /* 16 */
    {"mae17.pvr", NJD_TEXATTR_GLOBALINDEX, 1117}, /* 17 */
    {"mae18.pvr", NJD_TEXATTR_GLOBALINDEX, 1118}, /* 18 */
    {"mae19.pvr", NJD_TEXATTR_GLOBALINDEX, 1119}, /* 19 */
    {"mae20.pvr", NJD_TEXATTR_GLOBALINDEX, 1120}, /* 20 */
    {"mae21.pvr", NJD_TEXATTR_GLOBALINDEX, 1121}, /* 21 */
    {"mae22.pvr", NJD_TEXATTR_GLOBALINDEX, 1122}, /* 22 */
    {"mae23.pvr", NJD_TEXATTR_GLOBALINDEX, 1123}, /* 23 */
    {"mae24.pvr", NJD_TEXATTR_GLOBALINDEX, 1124}, /* 24 */
    {"mae25.pvr", NJD_TEXATTR_GLOBALINDEX, 1125}, /* 25 */
    {"mae26.pvr", NJD_TEXATTR_GLOBALINDEX, 1126}, /* 26 */
    {"mae27.pvr", NJD_TEXATTR_GLOBALINDEX, 1127}, /* 27 */
};

static NJS_TEXLIST Texlist1 = {Texture1, 28};

static NJS_TEXMEMLIST Texmemlist[TEX_NUM];

/* NJM_MAP(n, u, v) n:eNX`ԍ u:eNX`tW v:eNX`uW */
/* NJM_MAP(n, u, v) n:texture number u:U coordinate     v:V Coordinate */
static Uint32 Map0[4][7] = {
    { NJM_MAP(0, 0, 0), NJM_MAP(1, 0, 0), NJM_MAP(2, 0, 0),
      NJM_MAP(3, 0, 0), NJM_MAP(4, 0, 0), NJM_MAP(5, 0, 0),
      NJM_MAP(6, 0, 0), },
    { NJM_MAP(7, 0, 0), NJM_MAP(8, 0, 0), NJM_MAP(9, 0, 0),
      NJM_MAP(10, 0, 0), NJM_MAP(11, 0, 0), NJM_MAP(12, 0, 0),
      NJM_MAP(13, 0, 0), },
    { NJM_MAP(14, 0, 0), NJM_MAP(15, 0, 0), NJM_MAP(16, 0, 0),
      NJM_MAP(17, 0, 0), NJM_MAP(18, 0, 0), NJM_MAP(19, 0, 0),
      NJM_MAP(20, 0, 0), },
    { NJM_MAP(21, 0, 0), NJM_MAP(22, 0, 0), NJM_MAP(23, 0, 0),
      NJM_MAP(24, 0, 0), NJM_MAP(25, 0, 0), NJM_MAP(26, 0, 0),
      NJM_MAP(27, 0, 0), },
};
static Uint32 Map1[4][7] = {
    { NJM_MAP(0, 0, 0), NJM_MAP(1, 0, 0), NJM_MAP(2, 0, 0),
      NJM_MAP(3, 0, 0), NJM_MAP(4, 0, 0), NJM_MAP(5, 0, 0),
      NJM_MAP(6, 0, 0), },
    { NJM_MAP(7, 0, 0), NJM_MAP(8, 0, 0), NJM_MAP(9, 0, 0),
      NJM_MAP(10, 0, 0), NJM_MAP(11, 0, 0), NJM_MAP(12, 0, 0),
      NJM_MAP(13, 0, 0), },
    { NJM_MAP(14, 0, 0), NJM_MAP(15, 0, 0), NJM_MAP(16, 0, 0),
      NJM_MAP(17, 0, 0), NJM_MAP(18, 0, 0), NJM_MAP(19, 0, 0),
      NJM_MAP(20, 0, 0), },
    { NJM_MAP(21, 0, 0), NJM_MAP(22, 0, 0), NJM_MAP(23, 0, 0),
      NJM_MAP(24, 0, 0), NJM_MAP(25, 0, 0), NJM_MAP(26, 0, 0),
      NJM_MAP(27, 0, 0), },
};
static NJS_SCROLL Scroll0;
static NJS_SCROLL Scroll1;

PDS_PERIPHERAL* Per;

void PauseMode(void);

static void swapF(Float *fl1, Float *fl2);

/************************************************************
  
  initialize
************************************************************/
void njUserInit(void)
{
    /* VXe */
    /* Initializes the Dreamcast H/W and readies the SEGA library */
    sbInitSystem(NJD_RESOLUTION_640x480_NTSCI, NJD_FRAMEBUFFER_MODE_RGB565, 1);

    VBuf = (NJS_VERTEX_BUF *)syMalloc(sizeof (NJS_VERTEX_BUF) * MAX_VERTEXES);

    /* obNOEhJ[ݒ */
    /* sets the background */
    njSetBackColor(ARGB(0, 0, 128, 0),
        ARGB(0, 0, 128, 0), ARGB(0, 128, 0, 0));

    /* eNX`obt@̊m */
    /* sets necessary memory for work area of a texture */
    njInitTextureBuffer((Sint8 *)VBuf,0x800*100);

    /* _f[^o^pobt@AP[g */
    /* allocates the buffers for registration of vertex data */
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0, 0);

	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );

    /* eNX`i[̈ݒ */
    /* sets the area used for storing texture information */
    njInitTexture(Texmemlist, TEX_NUM);

    /* eNX`[h */
    /* loads the texuter */
    njLoadTexture(&Texlist0);
    njLoadTexture(&Texlist1);
    /* XN[O̐ݒ */
    /* sets the scroll surface #0 */
    Scroll0.celps = 128;            /* size of cell*/
    Scroll0.mapw = 7;               /* map width (7cells) */
    Scroll0.maph = 4;               /* map height (4cells) */
    Scroll0.list = &Texlist0;
    Scroll0.map = (Uint32 *)Map0;
    Scroll0.mflag = OFF;            /* ignore rotation */
    Scroll0.sflag = OFF;            /* ignore scaling */
    Scroll0.pr = -100.0F;           /* priority */
    Scroll0.px = 0.0F;              /* position x */
    Scroll0.py = 0.0F;              /* position y */
    Scroll0.sclc.argb.a = 255;      /* Alpha */
    Scroll0.sclc.argb.r = 150;      /* R */
    Scroll0.sclc.argb.g = 150;      /* G */
    Scroll0.sclc.argb.b = 150;      /* B */
    Scroll0.colmode = NJD_COLOR_MODE_PACKED_TEXTURE_TRANS; /* color mode */

    /* XN[P̐ݒ */
    /* sets the scroll surface #1 */
    Scroll1.celps = 128;            /* size of cell */
    Scroll1.mapw = 7;               /* map width (7 cells) */
    Scroll1.maph = 4;               /* map height (4 cells) */
    Scroll1.list = &Texlist1;
    Scroll1.map = (Uint32 *)Map1;
    Scroll1.mflag = OFF;            /* ignore rotation */
    Scroll1.sflag = OFF;            /* ignore scaling */
    Scroll1.pr = -200.0F;           /* priority */
    Scroll1.px = -50.0F;            /* position x */
    Scroll1.py = -25.0F;            /* position y */
    Scroll1.sclc.argb.a = 255;      /* Alpha */
    Scroll1.sclc.argb.r = 150;      /* R */
    Scroll1.sclc.argb.g = 150;      /* G */
    Scroll1.sclc.argb.b = 0;        /* B */
    Scroll1.colmode = NJD_COLOR_MODE_PACKED_TEXTURE_TRANS; /* color mode */

    /* fobO̐F */
    /* sets the text color */
    njPrintColor(ARGB(255, 150, 150, 150));
}

/************************************************************
  s郁C
  main
************************************************************/
Sint32 njUserMain(void)
{
    static int frame = 0;

    static Bool pauseMode = FALSE;

    njPrintC(NJM_LOCATION(4, 6), "NINJA SCROLL PRIORITY TEST");
    njPrintC(NJM_LOCATION(4, 8), "Press Start Button To Pause");
    if (Scroll0.pr > Scroll1.pr) {
        njPrintC(NJM_LOCATION(4, 10), "WHITE <--HIGH    YELLOW");
    }
    else {
        njPrintC(NJM_LOCATION(4, 10), "WHITE    HIGH--> YELLOW");
    }

    /* ytF`FbN */
    /* gets the peripheral infomation */
    Per = pdGetPeripheral(PDD_PORT_A0);

    /* checks the start button */
    if (Per->press & PDD_DGT_ST) { 
        pauseMode = !pauseMode;
    }

    if (pauseMode == TRUE) {
        Scroll0.sclc.argb.a = 64;
        Scroll1.sclc.argb.a = 64;

        PauseMode();
    }
    else {
        Scroll0.sclc.argb.a = 255;
        Scroll1.sclc.argb.a = 255;
    }

    /* PboXN[̃vCIeBύX */
	/* changes priority */
    if (pauseMode == FALSE) {
        frame++;
        if (frame == 60) {
            swapF(&Scroll0.pr, &Scroll1.pr);
            frame = 0;
        }
    }

	/* draws scroll surface */
    njDrawScroll(&Scroll0);
    njDrawScroll(&Scroll1);

    return NJD_USER_CONTINUE;
}

/************************************************************
  sIɌĂяoI
  exit
************************************************************/
void njUserExit(void)
{
	njExitPrint();
    njExitTexture();
    syFree(VBuf);
    sbExitSystem();
}

/************************************************************
  Qfloatlւ
  swap float value
************************************************************/
void swapF(Float *f1, Float *f2)
{
    Float tmp;
    tmp = *f1;
    *f1 = *f2;
    *f2 = tmp;
}

/************************************************************
  |[YɌĂяo鏈
  pause mode
************************************************************/
void PauseMode(void)
{
    static Sint16 interval = 0;
    static Bool display = TRUE;

    interval++;
    if (interval >= 30) {
        display = !display;
        interval = 0;
    }
    if (display == TRUE) {
        njPrintSize(32);
        njPrintC(NJM_LOCATION(7, 6),"PAUSE!");
        njPrintSize(8);
    }
}
