/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F XN[gk
              Scroll (change size)
  ҏW F 98-04-28 Jn
              98-06-19 SET5Ή
              98-09-16 eNX`obt@mۂ̃TCYύX
              99-04-07 appends the English comments
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}

#define MAX_MATRIX_DEPTH 10
#define MAX_VERTEXES 2000

#define TEX_NUM 100
#define SIZE_CHANGE_SPEED NJM_DEG_ANG(1.0F)/* gAk̑*/
                                           /* size change speed */
#define SCREEN_SAVE_TIME 30

static Uint32 ScaleMap[1][1] = {
    {NJM_MAP(0, 0, 0)}
};

static NJS_TEXNAME ScaleTexName[1]={
    {"frog.pvr",NJD_TEXATTR_GLOBALINDEX, 1000},
};
static NJS_TEXLIST ScaleTexList = {ScaleTexName, 1};
static NJS_SCROLL ScaleScroll;
static NJS_TEXMEMLIST ScaleTexMemList[TEX_NUM];

static NJS_MATRIX *ScaleMatrix;
static NJS_VERTEX_BUF *ScaleVbuf;
static Sint8 TextureBuf[0x40800];

/*-----------------------------------------------
    
    initialize
-----------------------------------------------*/
void njUserInit(void)
{
    /* VXȅ */
    /* Initializes the Dreamcast H/W and readies the SEGA library */
    sbInitSystem(NJD_RESOLUTION_320x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);

    /* 蓖 */
	/* allocates matrix stack */
    ScaleMatrix = syMalloc(sizeof(NJS_MATRIX) * MAX_MATRIX_DEPTH);
	/* allocates vertex calculation work */
    ScaleVbuf   = syMalloc(sizeof(NJS_VERTEX_BUF) * MAX_VERTEXES);

    njInitTextureBuffer( ( Sint8 * )TextureBuf, 0x800*10 );
    /* wiF̐ݒ */
    /* sets the background color*/
    njSetBackColor(0xFF000000, 0xFF000000, 0xFF000000);

    /* _i[obt@̊m */
    /* allocates the buffers for registration of vertex data */
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0, 0);

	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );

    /* }gbNXX^bN̏ */
	/* initialize matrix stack */
    njInitMatrix(ScaleMatrix, MAX_MATRIX_DEPTH, 1); 

    /* eNX`̏ */
    /* sets the area used for storing texture information */
    njInitTexture(ScaleTexMemList, TEX_NUM);

    /* XN[̐ݒ */
    /* sets the scroll surface */
    ScaleScroll.celps =  256;                  /* size of a cell           */
    ScaleScroll.mapw  =    1;                  /* map width                */
    ScaleScroll.maph  =    1;                  /* map height               */
    ScaleScroll.sx    =    1.0F;               /* map size x               */
    ScaleScroll.sy    =    1.0F;               /* map size y               */
    ScaleScroll.spx   =    0.0F;               /* center x(size change)    */
    ScaleScroll.spy   =    0.0F;               /* center y(size change)    */
    ScaleScroll.list  = &ScaleTexList;
    ScaleScroll.map   = (Uint32*)ScaleMap;
    ScaleScroll.mflag = OFF;                   /* ignore rotation          */
    ScaleScroll.sflag = ON;                    /* enable size change       */
    ScaleScroll.pr    = -1000.0F;              /* priority                 */
    ScaleScroll.px    =     0.0F;              /* position x               */
    ScaleScroll.py    =     0.0F;              /* position y               */
    ScaleScroll.bx    =     0.0F;
    ScaleScroll.by    =     0.0F;
    ScaleScroll.cx    =     0.0F;
    ScaleScroll.cy    =     0.0F;
    ScaleScroll.sclc.argb.a = 255;             /* Alpha        */
    ScaleScroll.sclc.argb.r = 255;             /* R        */
    ScaleScroll.sclc.argb.g = 255;             /* G        */
    ScaleScroll.sclc.argb.b = 255;             /* B        */
    ScaleScroll.colmode = NJD_COLOR_MODE_PACKED_TEXTURE;   /* color mode */
    njLoadTexture(&ScaleTexList);
	/* F̐ݒ */
    /* sets the text color */
	njPrintColor(0xFFC0C0C0);
}

Sint32 njUserMain(void)
{
    static Angle size = NJM_DEG_ANG(0.0F);/* gEk̃TCY߂ϐ */
	static PDS_PERIPHERAL *key;/* {^ */
	static Bool pause = FALSE;/* |[YĂ邩ǂ */
	static int counter = 0;

	key = pdGetPeripheral(PDD_PORT_A0);

	if (key->press & PDD_DGT_ST) {
	    if (pause == FALSE) {
		    pause = TRUE;
		} else {
		    pause = FALSE;
		}
	}

    /* Tv̕\ */
    /* prints the sample program name */
    njPrintC(NJM_LOCATION(10, 3), "Ninja Sample SCROLL ZOOM");
	if (pause == TRUE) {
	    njPrintC(NJM_LOCATION(16, 5), "PAUSE");
	}
    /* g嗦ikj̕ύX */
	/* size change */
    ScaleScroll.sx = njSin(size) + 1.5F;
    ScaleScroll.sy = njSin(size) + 1.5F;

	/* draws scroll surface */
	if (pause == FALSE) {
	    njDrawScroll(&ScaleScroll);
		size += SIZE_CHANGE_SPEED;
	} else {
	    counter++;
		if (counter > SCREEN_SAVE_TIME) {
		    njDrawScroll(&ScaleScroll);
		}
		if (counter == SCREEN_SAVE_TIME * 2) {
		    counter = 0;
		}
	}
    return NJD_USER_CONTINUE;
}

void njUserExit(void)
{
    syFree(ScaleMatrix);
    syFree(ScaleVbuf);
	njExitPrint();
    njExitTexture();
    sbExitSystem();
}
