/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F XvCg̕\
              Sprite 
  ҏW F 98-04-20 Jn
              98-06-18 SET5Ή
              98-07-13 @\(Fadegp)A
                       ĕth~ǉ
              98-09-16 eNX`obt@mۂ̃TCYύX
              99-04-07 appends the English comments
************************************************************/
#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
        njUserInit();
        while (njUserMain() == NJD_USER_CONTINUE) {
                njWaitVSync();
        }
        njUserExit();
}

#define MAX_VERTEXES 10000
#define SPRITE_Z -1500.0F

NJS_TEXNAME texname[1] ;
NJS_SPRITE sprite;
NJS_TEXLIST texlist = {texname, 1};
static NJS_VERTEX_BUF *vbuf;
NJS_TEXANIM anim[] = {{128, 128, 64, 64, 0, 0, 255, 255, 0, 0}};
NJS_TEXMEMLIST  texmemlist[1];

/*----------------------------------------------------------------------
           
           initialize
----------------------------------------------------------------------*/
void njUserInit(void)
{
    /* VXȅ */
    /* Initializes the Dreamcast H/W and readies the SEGA library */
    sbInitSystem(NJD_RESOLUTION_320x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);

    /*vertexobt@̊m*/
    /* allocates the vertex calculation work */
    vbuf = (NJS_VERTEX_BUF *)syMalloc(sizeof (NJS_VERTEX_BUF) * MAX_VERTEXES);

    /* wiF̐ݒ */
    /* sets the background */
    njSetBackColor(ARGB(0, 0, 0, 0), ARGB(0, 0, 0, 0), ARGB(0, 0, 0, 192));

    /* eNX`obt@̊m */
    /* sets necessary memory for work area of a texture */
    njInitTextureBuffer((Sint8 *)vbuf,0x800*10);

    /* _i[obt@̊m */
    /* allocates the buffers for registration of vertex data */
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0, 0);

	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );

    njInitTexture(texmemlist, 1);
    /*ꖇ̃eNX`[ݒ*/
	/* sets only 1 texture */
    njSetTextureName(&texname[0], "frog.pvr", 0, NJD_TEXATTR_TYPE_FILE | NJD_TEXATTR_GLOBALINDEX);
    njLoadTexture(&texlist);
    njSetTexture(&texlist);
    njSetTextureNum(0);

    /*ĕth~*/
    njPrintColor(0xffc0c0c0);
}

/*----------------------------------------------------------------------
         C
         main
----------------------------------------------------------------------*/
Sint32 njUserMain(void)
{
    static PDS_PERIPHERAL *input;
    static Bool pause = FALSE;  /*flag for pausing*/
    static float fade_val = 0.5F;   /*value to fade*/
    Uint32 fade_col = 0xffc0c0c0;   /*fade color*/
    static Uint32 print_col = 0x11c00000;

    input = pdGetPeripheral(PDD_PORT_A0);   /*get key state*/
    /*checking key*/
    if (input->press & PDD_DGT_ST){
        pause = !pause;
    }
    njPrintSize(8);
    njPrintColor(0xffc0c0c0);
    /* Tv̕\ */
    /* prints the sample program name */
    njPrintC(NJM_LOCATION(10, 5), "Ninja Sample SPRITE");

    if(pause) {     /*|[YȂtF[hĂ*/
                    /* if pause mode, do fadeout */
        njPrintSize(20);
        njPrintColor(print_col);
        njPrintC(NJM_LOCATION(6, 5), "PAUSE");
        njExecuteFade(fade_val);
        njFadeEnable();
        if (print_col < 0xffc0c0c0) {   /* text color change */
            print_col += 0x03000000;
        }
        if (fade_val < 0.7F) {         /* fade value change */
            fade_val += 0.01F;
        }
    } else {
        /*size/FƃtF[hl߂*/
        /* reset text color and fade value */
        print_col = 0x11c00000;
        fade_val = 0.F;
        njFadeDisable();

        sprite.tlist = &texlist;
        sprite.ang = 0x0000;
        sprite.sx = 1.0F;
        sprite.sy = 1.0F;
        sprite.p.x = 160.0F;
        sprite.p.y = 120.0F;
        sprite.tanim = anim;
    }
    njDrawSprite2D(&sprite, 0, SPRITE_Z, NJD_SPRITE_ANGLE );

    return NJD_USER_CONTINUE;
}

/*----------------------------------------------------------------------
         I
		exit
----------------------------------------------------------------------*/
void njUserExit(void)
{
	njExitPrint();
    /* eNX`̊J */
    /* free texture memory */
    njExitTexture();
    /*vertexobt@̊J*/
    /* free vertex calclation work */
    syFree(vbuf);
    /* VXȅI */
    /* exit system */
    sbExitSystem();
}
