
/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F XvCgilp`|Sj]Cgk\
              sprite (rotation & change size)
  ҏW F 98-04-21 Jn
              98-04-22 R[fBOKɍ킹
              98-05-12 f[^Angle^ɓ
              98-05-15 SET2/4؂ւ}Nǉ
              98-05-25 SET4RpC̃oOC
              98-06-19 SET5Ή
              98-07-08 C0ĂtɑΉi|[Yǉj
              98-09-16 eNX`obt@mۂ̃TCYύX
              99-04-07 appends the English comments
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}

#define TEXNUM 1
#define MAX_VERTEXES 1000
#define VERTEX_MAX 1000

static NJS_VERTEX_BUF  *VBuf;

/*eNX`ݒ*/
static NJS_TEXNAME Texname[] = {
    {"Sprite.pvr", NJD_TEXATTR_GLOBALINDEX, 0 },
};
static NJS_TEXANIM Texanim[] = {
    {400, 300, 200, 150, 0, 0, 255, 255, 0, 0},
};
static NJS_TEXLIST Texlist = {Texname, TEXNUM};
static NJS_TEXMEMLIST Texmemlist[TEXNUM];

static NJS_SPRITE Sprite;
static NJS_ARGB Argb;

PDS_PERIPHERAL* Per;

void PauseMode(void);

/************************************************************
  
  initialize
************************************************************/
void njUserInit(void)
{
    /*VXe*/
    /* Initializes the Dreamcast H/W and readies the SEGA library */
    sbInitSystem(NJD_RESOLUTION_320x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);

    VBuf = (NJS_VERTEX_BUF *)syMalloc(sizeof(NJS_VERTEX_BUF) * VERTEX_MAX);

    /*obNOEhJ[ݒ*/
    /* sets the background color */
    njSetBackColor(ARGB(0, 150, 0, 0), ARGB(0, 150, 0, 0), ARGB(0, 0, 0, 0));

    /* eNX`obt@̊m */
    /* sets necessary memory for work area of a texture */
    njInitTextureBuffer((Sint8 *)VBuf,0x800*10);

    /*_f[^o^pobt@AP[g*/
    /* allocates the buffers for registration of vertex data */
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0, 0);

	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );

    /*eNX`i[̈ݒ*/
    /* sets the area used for storing texture information */
    njInitTexture(Texmemlist, TEXNUM);

    /*eNX`[h*/
    /* load texture */
    njLoadTexture(&Texlist);
    /* JgeNX`Xgtexlistɂ */
    /* set current texture */
    njSetTexture(&Texlist);

    Sprite.p.x = 160; /* ŜW  sprite position x */
    Sprite.p.y = 120; /* ŜW  sprite position y */
    Sprite.sx = 0.5F; /* ̊g嗦 sprite scale x */
    Sprite.sy = 0.5F; /* ̊g嗦 sprite scale y */
    Sprite.ang = NJM_DEG_ANG(0.0F); /* ]px sprite angle */
    Sprite.tlist = &Texlist;
    Sprite.tanim = Texanim;

    /* fAIuWFNg̕`Rg[ */
    njControl3D(NJD_CONTROL_3D_CONSTANT_MATERIAL);
    Argb.a = 1.0F;

    /* ̎ݒ */
    njRandomSeed(0);

    /* fobO̐F */
    /* set text color */
    njPrintColor(ARGB(255, 150, 150, 150));
}

/************************************************************
  s郁C
  main
************************************************************/
Sint32 njUserMain(void)
{
    static Bool pauseMode = FALSE;

    static Angle ramdaX = NJM_DEG_ANG(0.0F);
    static Angle ramdaY = NJM_DEG_ANG(0.0F);
    static Angle stepX = NJM_DEG_ANG(5.0F);
    static Angle stepY = NJM_DEG_ANG(3.0F);

    Float scaleX;
    Float scaleY;

    /*Tv̕\*/
    /* prints the sample program name */
    njPrintC(NJM_LOCATION(6, 5), "Ninja Sample ROT SPRITE 2");
    njPrintC(NJM_LOCATION(6, 7), "Press Start Button To Pause");

    /* ytF`FbN */
    /* gets the peripheral infomation */
    Per = pdGetPeripheral(PDD_PORT_A0);
    if (Per->press & PDD_DGT_ST) { /* X^[g{^ꂽ */
                                   /* checking key */
        pauseMode = !pauseMode;
    }
    /* |[Yʂ */
    /* pause mode */
    if (pauseMode == TRUE) {
        Argb.r = 0.25F;
        Argb.g = 0.25F;
        Argb.b = 0.25F;

        PauseMode();
    }
    else {
        Argb.r = 0.7F;
        Argb.g = 0.7F;
        Argb.b = 0.7F;
    }

    if (pauseMode == FALSE) { /* ]pg嗦̍XV */
                              /* change sprite angle & scale */
        Sprite.ang += NJM_DEG_ANG(1.0F);
        if (Sprite.ang == NJM_DEG_ANG(0.0F)) {
            stepX = NJM_DEG_ANG((int)(njRandom() * 10.0F) + 2.0F);
            stepY = NJM_DEG_ANG((int)(njRandom() * 10.0F) + 2.0F);
        }
        ramdaX += stepX;
        ramdaY += stepY;
        scaleX = njSin(ramdaX) * 0.5F + 0.7F ;
        scaleY = njCos(ramdaY) * 0.5F + 0.7F ;
        Sprite.sx = scaleX;
        Sprite.sy = scaleY;
    }

    njSetConstantMaterial(&Argb);

    /*QcXvCg̕\*/
    /* draw a sprite */
    njDrawSprite2D(&Sprite, 0, -2.0F, NJD_SPRITE_ANGLE | NJD_SPRITE_COLOR);

    return NJD_USER_CONTINUE;
}

/************************************************************
  sIɌĂяoI
  exit
************************************************************/
void njUserExit(void)
{
	njExitPrint();
    njExitTexture();
    syFree(VBuf);
    sbExitSystem();
}

/************************************************************
  |[YɌĂяo鏈
  pause routine
************************************************************/
void PauseMode(void)
{
    static Sint16 interval = 0;
    static Bool display = TRUE;

    interval++;
    if (interval >= 30) {
        display = !display;
        interval = 0;
    }
    if (display == TRUE) {
        njPrintSize(20);
        njPrintC(NJM_LOCATION(5, 4),"PAUSE!");
        njPrintSize(8);
    }
}
