/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F XvCggk
              zoom sprite
  ҏW F 98-04-24 Jn
              98-06-19 SET5Ή
              98-09-16 eNX`obt@mۂ̃TCYύX
              99-04-05 appends the English comments
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}


/* O[oZNV */
/* global data          */
#define VERTEX_MAX  1000     /* _̍ő吔 */
                             /* maximum number of vertex */
/* eNX`f[^ */
/* texture data     */

#define TEXTURE_NUM  1  /* eNX`f[^̐ */
                        /* the number of texture data */

/* LbVɓǂݍ܂eNX`` */
/* defines the textuer data that loads to the cache memory */
static NJS_TEXNAME g_TexName[] = {"walmap.pvr", NJD_TEXATTR_GLOBALINDEX, 0};

static NJS_TEXLIST g_TexList = {g_TexName, TEXTURE_NUM};
static NJS_TEXMEMLIST g_Texture[TEXTURE_NUM];

/* XvCgf[^ */
/* sprite data      */
static NJS_SPRITE g_Sprite;    /* XvCgf[^ێ */

/* XvCg̃Aj[Vf[^Zbg */
/* sprite animation data                    */
static NJS_TEXANIM g_SpriteAnim[] = {                      
    {256, 256, 128, 128, 0, 0, 255, 255, 0, 0}, 
};

static NJS_VERTEX_BUF *vbuf;

/* |[YtO */
/* pause flag       */
Bool g_bPause = FALSE;

/* ANeBu֐ */
/* main function      */
void ActivePhase(void);

/* |[Y֐  */
/* pause founction */
void PausePhase(void);

/***************************************************************************

	njSetBorderColor( 0x00000000 );
    njUserInit --- NinjaVXe֐
                   initialize
***************************************************************************/

void njUserInit (void)
{
    /* ʃ[ȟ */
    /* Initializes the Dreamcast H/W and readies the SEGA library */
    sbInitSystem(NJD_RESOLUTION_320x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);

    /* _̍ő吔obt@AP[g */
    /* sets necessary memory for work area of a texture */ 
    njInitVertexBuffer(VERTEX_MAX * 64 / 4, 0, VERTEX_MAX * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );
    vbuf = syMalloc( sizeof( NJS_VERTEX_BUF ) * 4096 );
    njInitTextureBuffer( ( Sint8 * )vbuf, 0x800*10 ); 

    /* eNX`̐f[^̈m */
    /* sets necessary memory for work area of a texture */ 
    njInitTexture(g_Texture, TEXTURE_NUM);

    /* w肵eNX`XgɂeNX`f[^ */
    /* LbVɃ[h */   
    /* loads the texture to cache memory */
    njLoadTexture(&g_TexList);  
                                
    njSetTexture(&g_TexList);   /* Jg̃eNX`Xgݒ */
                                /* sets current texture list        */
    njSetTextureNum(0);         /* OԃeNX`JgeNX`ɃZbg   */
                                /* sets the texture No.0 as the current texture */
    /* XvCgf[^̏ */
    /* initializes sprite data  */
    g_Sprite.p.x = 160.0F;  /* \ʒu */
    g_Sprite.p.y = 120.0F;  /* drawing position */
    g_Sprite.sx  = 1.F;     /* gk */
    g_Sprite.sy  = 1.F;     /* sprite scale value */
    g_Sprite.tlist = &g_TexList; /* gpeNX`Xg */
                                 /* texture list */
    g_Sprite.tanim = g_SpriteAnim;  /* Aj[V` */
                                    /* texture animation pattern */
    /* wiݒ */
    /*  E  ̃J[w */
	/* sets the background color */
    njSetBackColor(0xffc00000, 0xff00c000, 0xff0000c0); 

    /* eLXg̃J[ݒ */
	/* sets the text color */
    njPrintColor(ARGB(0xff, 0xc0, 0xc0, 0xc0));
}


/***************************************************************************

    njUserMain --- NinjaVXeC֐
                   main
***************************************************************************/

Sint32 njUserMain(void)
{
    NJS_PERIPHERAL *per;

    /* WCXeBbN|[gP̃ytF擾 */
    /* gets the peripheral infomation (port A) */
    per = njGetPeripheral(NJD_PORT_A0);

    /* {^ꂽǂ`FbN */
    /* checks the start button          */
    if (per->press & NJD_DGT_ST) {
        g_bPause = !g_bPause;
    }	

	/* |[YԂɂď؂ւ */
	/* pause or not */
	if (!g_bPause) {
		ActivePhase();
	} else {
		PausePhase();
	}

    /* fobO̕\ */
    /* prints the sample program name */
    njPrintC(NJM_LOCATION(6, 5), "Ninja Sample Sprite Zoom");
    
    return NJD_USER_CONTINUE;
}


/***************************************************************************

    ActivePhase --- ANeBu֐
                    active (not pause)
***************************************************************************/

void ActivePhase(void)
{
    static Angle ang = NJM_DEG_ANG(0.0F);

    /* gkω*/
    /* changes scale         */
    ang += 100;
    g_Sprite.sx = njSin(ang) + 0.5F;
    g_Sprite.sy = njCos(ang) + 0.5F;

    /* XvCg̕` */
    /* draws sprite     */
    njDrawSprite2D(&g_Sprite, 0, -150.0F, 0);

	/* fobO̕\      */
    /* prints debug infomation */
    njPrintC(NJM_LOCATION(5, 8), "sx = ");
    njPrintF(NJM_LOCATION(10, 8), g_Sprite.sx, 1);
    njPrintC(NJM_LOCATION(5, 9), "sy = ");
    njPrintF(NJM_LOCATION(10, 9), g_Sprite.sy, 1);
}


/***************************************************************************

    PausePhase --- |[Y֐
                   pause
***************************************************************************/

void PausePhase(void)
{
    NJS_POINT2COL pc;
    NJS_POINT2    p[4];
    NJS_COLOR     col[4];
    static int	  timer = 0;
        
    /* XvCg̕` */
    /* draws sprite     */
    njDrawSprite2D(&g_Sprite, 0, -150.0F, 0);

    /* Z[o[pXvCg̐ݒ */
    /* sets the sprite for screen saver */
    pc.p   = p;
    pc.col = col;
    pc.tex = NULL;
    pc.num = 4;
    
    p[0].x = 0;
    p[0].y = 0;
    col[0].color = 0xff000000;

    p[1].x = 0;
    p[1].y = 480;
    col[1].color = 0xff000000;

    p[2].x = 640;
    p[2].y = 480;
    col[2].color = 0xff000000;

    p[3].x = 640;
    p[3].y = 0;
    col[3].color = 0xff000000;

    /* Z[o[p|S̕` */
    /* draws polygon for screen saver */
    njDrawPolygon2D(&pc, 4, -2.0F, NJD_FILL);

	timer++;
	njPrintColor(ARGB(0xff, 0xc0, 0xc0, 0x00));
	if (timer > 720) {
		timer = 0;
	}
	njPrintColor(ARGB(0xff, 0xc0, 0xc0, 0xc0));				

	/* |[Ŷm点     */
	/* draws 'PAUSE' string */
    njPrintC(NJM_LOCATION(19, 15), "PAUSE");
}


/***************************************************************************

    njUserExit --- NinjaVXeI֐
                   exit
***************************************************************************/

void njUserExit(void)
{
	njExitPrint();
    njExitTexture();
    syFree(vbuf);
    /* VXȅIs܂ KŌɌĂяoĂ */
    /* exits the system    */
    njExitSystem(); 
}
