/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F Op`|SP\
  ҏW F 98-04-20 Jn
              98-06-19 SET5Ή
              98-07-09 pause@\(\Ȃ)A
                       ĕth~΍
              99-04-05 appends the English comments
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
        njUserInit();
        while (njUserMain() == NJD_USER_CONTINUE) {
                njWaitVSync();
        }
        njUserExit();
}

#define MAX_MATRIX_DEPTH 10
#define MAX_VERTEXES 1000
extern NJS_OBJECT object_cube_root[];

static NJS_MATRIX *matrix;
static NJS_VERTEX_BUF *vbuf;
NJS_POINT3COL p;
NJS_VIEW view;
NJS_LIGHT light;

void MallocP3C(NJS_POINT3COL *p3c, Uint32 n);
void FreeP3C(NJS_POINT3COL *p3c);


/*----------------------------------------------------------------------
           
           initialize
----------------------------------------------------------------------*/
void njUserInit(void)
{
    /* VXȅ */
    /* Initializes the Dreamcast H/W and readies the SEGA library */
    sbInitSystem(NJD_RESOLUTION_640x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);

    /* ʂ̃AXyNg␳ */
	/* corrects the screen aspect ratio */
    njSetAspect( 1.0F, 0.45F );

    /*matrixvertexobt@̊m*/
    /* allocates the memory */
    matrix = (NJS_MATRIX *)syMalloc(sizeof (NJS_MATRIX) * MAX_MATRIX_DEPTH);
    vbuf = (NJS_VERTEX_BUF *)syMalloc(sizeof (NJS_VERTEX_BUF) * MAX_VERTEXES);

    /* wiF̐ݒ */
	/* sets background color */
    njSetBackColor(ARGB(0, 0, 0, 0), ARGB(0, 0, 0, 0), ARGB(0, 0, 0, 0));

    /* _i[obt@̊m */
    /* allocates the buffers for registration of vertex data */
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );

    /* }gNXX^bN̏ */
  	/* initializes the matrix stack */
    njInitMatrix(matrix, MAX_MATRIX_DEPTH, 1);

    /* 3DVXȅ */
    /* initializes 3D system  */ 
    njInit3D(vbuf, MAX_VERTEXES);

    /* ̏ */
    /* initializes the light source */
    njCreateLight(&light, NJD_DIR_LIGHT);

    /* r[̏ */
    /* initializes the user-defined view */
    njInitView(&view);

    /* r[̐ݒ */
	/* specifies the current view */
    njSetView(&view);

    /*debugύX(Ăth~)*/
	/* sets the text color */
    njPrintColor(0xffc0c0c0);
}

/*----------------------------------------------------------------------
         C
----------------------------------------------------------------------*/
Sint32 njUserMain(void)
{
    static PDS_PERIPHERAL *input;
    static Bool pause = FALSE;  /*flag for pausing*/
    static Sint16 pauseCnt = 1;

    input = pdGetPeripheral(PDD_PORT_A0);/*L|ԂƂ*/
    /*Checking key*/
    if (input->press & PDD_DGT_ST)
        pause = !pause;

    /* Tv̕\ */
    /* prints the sample program name */
    njPrintC(NJM_LOCATION(23, 4), "Ninja Sample TRIANGLE");

    /*}gbNX̃NA     */
    /* clears the matrix stack */
    njClearMatrix();

    /*checking pause |[ŶƂ̓|S̕\Ȃ*/
    if (pause) {
        if (pauseCnt <=50){
            njPrintC(NJM_LOCATION(35, 27), "PAUSE");
        } else if (pauseCnt == 100)
            pauseCnt = 0;
        pauseCnt++;
    } else{
        /* Tv̕\ */
        /* prints the sample program name */
        njPrintC(NJM_LOCATION(23, 4), "Ninja Sample TRIANGLE");

        /*̊m*/
        /* allocate the memory */
        MallocP3C(&p, 3);

        /*|Sf[^̐ݒ*/
        /* sets the polygon data */
        p.p[0].x = 0.0F;
        p.p[0].y = 0.0F;
        p.p[0].z = -2000.0F;
        p.col[0].argb.a = 0xff;
        p.col[0].argb.r = 0xc0;
        p.col[0].argb.g = 0xc0;
        p.col[0].argb.b = 0xc0;
        p.p[1].x = 160.0F;
        p.p[1].y = -320.0F;
        p.p[1].z = -2000.0F;
        p.col[1].argb.a = 0xff;
        p.col[1].argb.r = 0xc0;
        p.col[1].argb.g = 0xc0;
        p.col[1].argb.b = 0xc0;
        p.p[2].x = -160.0F;
        p.p[2].y = -320.0F;
        p.p[2].z = -2000.0F;
        p.col[2].argb.a = 0xff;
        p.col[2].argb.r = 0xc0;
        p.col[2].argb.g = 0xc0;
        p.col[2].argb.b = 0xc0;

        /*Op`|S̕`*/
        /* draws triangle polygon */
        njDrawTriangle3D(&p, 1, NJD_DRAW_NORMAL | NJD_FILL);

        /*̊J*/
        /* frees memory */
        FreeP3C(&p);
    }
    return NJD_USER_CONTINUE;
}

void MallocP3C(NJS_POINT3COL *p3c, Uint32 n)
{
    p3c->p = (NJS_POINT3 *)syMalloc(n * sizeof (NJS_POINT3));
    p3c->col = (NJS_COLOR *)syMalloc(n * sizeof (NJS_COLOR));
    p3c->tex = (NJS_COLOR *)syMalloc(n * sizeof (NJS_COLOR));
    p3c->num = n;
}

void FreeP3C(NJS_POINT3COL *p3c)
{
    syFree(p3c->p);
    syFree(p3c->col);
    syFree(p3c->tex);
    p3c->num = 0;
}
/*----------------------------------------------------------------------
         I
----------------------------------------------------------------------*/
void njUserExit(void)
{
	njExitPrint();

    /*matrixvbuf̃NA*/
	/* frees the memory area */
    syFree(matrix);
    syFree(vbuf);

    /* VXȅI */
    /* exits the system    */
    sbExitSystem();
}






