/*
    Ninja Sample

    COPYRIGHT (C) SEGA ENTERSRISES,LTD.

    TexLow Sample for SET5

    1999.3.4
*/
#include <Shinobi.h>
#include <string.h>

#define LOAD_END			0
#define READ_START			1
#define FILE_READ			2
#define FILE_READ_WAIT		3
#define GET_SURFACE			4
#define LOAD_TEX			5
#define LOAD_DMA_WAIT		6
#define DMA_WAIT_ERR_COUNT	10

static GDFS tex_loadreq_fp;
static Int load_mode = LOAD_END;
static NJS_TEXLIST *load_list = NULL;
static Uint32 load_n = 0;
static Uint32 globalIndex_S = NJD_START_GLOBALINEX;


void EntryTexMemList(NJS_TEXMEMLIST *texmemlist);
void FreeTexMemList(NJS_TEXMEMLIST *texmemlist);
void CheckFileName(char* namedst,const char* namesrc);
void InitTextureErrStat(void);

/************************************************
	LoadTexture
	eNX`̃[hv֐
	ۂɃ[ĥLoadTextureServer֐
	@[hI܂Ŏ̃[h͗vłȂ
	@LoadMode֐ŊmF邱
	LbVeNX`ɂ͑ΉĂ܂
	
	
		NJS_TEXLIST *texlist@	eNX`Xg
		Sint32 n				eNX`ԍ
	
	߂l
		[hv@P
		[hvs@|P
*************************************************/
/************************************************
	LoadTexture
	A function to demand a road of a texture
	Actually, it is LoadTextureServer function that load
      The next road cannot demand it till a road is finished
	@Confirm it by LoadMode function
	Is not equivalent to cache texture
	
	Argument
		NJS_TEXLIST *texlist    texture list
		Sint32 n				texture number
	
	Return value
		Load demand success 1
		Load demand failure -1
*************************************************/
Sint32 LoadTexture(NJS_TEXLIST *texlist,Uint32 n)
{
	if(load_mode == LOAD_END){
		/* G[̏@*/
		/* Initialization of error */
		InitTextureErrStat();
		load_mode = READ_START;
		load_list = texlist;
		load_n = n;
		return 1;
	}
	else{
		/* [hœo^łȂ@*/
		/* Load a texture, and cannot register itself.*/
		return -1;
	}
	
}

/************************************************
	LoadTextureServer
	LoadTexture֐Ń[hvꂽ֐[h
	LbVeNX`ɂ͑ΉĂ܂
	
	
		Ȃ
	߂l
			1
		G[	-1
*************************************************/
/************************************************
	LoadTextureServer
	Load a function demanded that it was loaded by LoadTexture function.
	Is not equivalent to cache texture
	
	Argument
		
	Return value
		Normality	1
		error		-1
*************************************************/
Sint32 LoadTextureServer(void)
{
	Sint8 *filename;
	static Sint32 file_sect_size;
	static Sint32 buffer_sect_size;
	static Sint32 r_sect_size;
	static Sint32 offset=0;
	static Sint32 dma_count;
	static Sint32 read_size;
	static Uint32 *buffer_start;
	Uint32 *pTexture;
	Sint32 ret;
	static Uint32 globalIndex;
	static NJS_TEXMEMLIST *texmemlist;
	NJS_PVRHEADERDATA pvrh;
	Int i,no;
	Sint8 filename2[128];/* 128܂*//* To 128 characters */
	NJS_TEXINFO *info;
	
	/* [hGh̎͂Ƀ^[ */
	/* Make a return at the time of LOAD_END immediately. */
	if(load_mode == LOAD_END) return;

	if(load_mode == READ_START){
				/* eNX`̏ꍇ@*/
				/* Load of a texture is a case from memory. */
		if(load_list->textures[load_n].attr & NJD_TEXATTR_TYPE_MEMORY){
			buffer_start = ((NJS_TEXINFO*)load_list->textures[load_n].filename)->texaddr;
			/* wb_f[^擾 pTextureɂ̓f[^̐擪AhXԂ@*/
			/* Acquire header data. The top address of data returns in pTexture.*/
			if((pTexture = njLoadPvrHeader(&pvrh,&globalIndex,buffer_start)) != NULL){
				buffer_start = pTexture;
			}
			else{
				/* wb_f[^Ȃꍇ@*/
				/* When there are not header data */
				info = (NJS_TEXINFO*)load_list->textures[load_n].filename;
				pvrh.nWidth = info->texsurface.nWidth;
				pvrh.nHeight = info->texsurface.nHeight;
				pvrh.nTextureType = (info->texsurface.Type >> 16);
				globalIndex = NJD_GLOBAXINDEX_FIRST_VAL;
			}

			/* O[oCfbNX[Uw̏ꍇ@*/
			/* Global index is a case user setting. */
			if(load_list->textures[load_n].attr & NJD_TEXATTR_GLOBALINDEX){
					globalIndex = load_list->textures[load_n].texaddr;
			}
			else{
				/* t@CɃO[oCfbNXȂꍇ@*/
				/* When there is not a global index in a file. */
				if(globalIndex == NJD_GLOBAXINDEX_FIRST_VAL){
					/* O[oCfbNXt@*/
					/* Establish a global index. */
					globalIndex = (globalIndex_S--);
				}
			}
			
			no = -1;
			/* eNX`Xg̋󂢂ĂꏊT@*/
			/* Look for a place becoming vacant of texture memory list. */
		    for(i = 0;i < _nj_texmemsize;i++){
		        if(_nj_texmemlist[i].globalIndex == globalIndex){
			        	/* łɃ[hĂ@*/
			        	/* Is loaded already. */
						load_mode = LOAD_END;
						_nj_texmemlist[i].count++;
						return 1;
		        }
				else{
					if(no < 0){
						if(_nj_texmemlist[i].globalIndex == NJD_GLOBAXINDEX_FIRST_VAL){
					        	no = i;
				        }
				    }
			    }
		    }
	    	/* eNX`Xg͎擾łȂ*/
	    	/* Texture memory list was not able to acquire it. */
		    if(no < 0){
				load_mode = LOAD_END;
				texmemlist = NULL;
				/*********** G[R[hԂ ************/
				/********* Turn over error code ************/
				_nj_texerr_.n = load_n;
				_nj_texerr_.texerr = NJD_TEXERR_OTHER;
				return -1;
		    }
			texmemlist = &_nj_texmemlist[no];
			texmemlist->globalIndex = globalIndex;
			/* eNX`T[tFX쐬@*/
			/* Make texture SurfaceDesc. */
			if(njGetTexSurface(texmemlist,&pvrh) == -1){
				/* T[tFX擾Ɏs̎@*/
				/* In failing in the SurfaceDesc acquisition. */
				load_mode = LOAD_END;
				FreeTexMemList(texmemlist);
				texmemlist = NULL;
				/*********** G[R[hԂ ************/
				/********* Turn over error code ************/
				_nj_texerr_.n = load_n;
				_nj_texerr_.texerr = NJD_TEXERR_SURFACE;
				return -1;
			}
			njSetTextureParam(texmemlist);
			load_mode = LOAD_TEX;
			read_size = texmemlist->texinfo.texsurface.TextureSize;
			offset = 0;
			r_sect_size = 0;
		}
		else{
			/* [ht@C̎擾@*/
			/* The acquisition of load file name. */
			filename = load_list->textures[load_n].filename;
			/* .PVRtĂ邩mF@*/
			/* Confirm whether ".PVR" is on. */
			CheckFileName(filename2,filename);
			if((tex_loadreq_fp = gdFsOpen(filename2,NULL)) != NULL){
				/* t@C̃ZN^TCY̌vZ */
				/* A calculation of sector size of a file. */
				gdFsGetFileSctSize(tex_loadreq_fp,&file_sect_size);
				/* t@Cobt@̃ZN^TCY̌vZ */
				/* A calculation of sector size of file buffer. */
				buffer_sect_size = _nj_texture_buffer_max_size/NJD_GD_SECT_SIZE;
				/* c̃ZN^TCY */
				/* Remaining sector size. */
				r_sect_size = file_sect_size;
				offset = 0;
				/* ̃[hݒ */
				/* The next mode setting. */
				load_mode = FILE_READ;
			}
			else{
				/* t@CI[vłȂꍇ */
				/* When it is not possible for a file to open it.*/
				load_mode = LOAD_END;
				/*********** G[R[hԂ ************/
				/********* Turn over error code ************/
				_nj_texerr_.n = load_n;
				_nj_texerr_.texerr = NJD_TEXERR_FILEOPEN;
				return -1;
			}
		}
	}
	
	if(load_mode == FILE_READ){
		if(buffer_sect_size >= r_sect_size){
			/* obt@̕傫ꍇ@*/
			/* When a sector of a buffer is bigger than a sector loading it. */
			if((ret = gdFsReqRd32(tex_loadreq_fp,r_sect_size,_nj_texture_buffer_st)) < 0){
				/* G[@*/
				/* error */
				load_mode = LOAD_END;
				/*********** G[R[hԂ ************/
				/********* Turn over error code ************/
				_nj_texerr_.n = load_n;
				_nj_texerr_.texerr = NJD_TEXERR_FILELOAD;
				return -1;
			}
			read_size = r_sect_size*NJD_GD_SECT_SIZE;
			r_sect_size = 0;
		}
		else{
			/* obt@̕ꍇ@*/
			/* When a sector of a buffer is smaller than a sector loading it.*/
			if((ret = gdFsReqRd32(tex_loadreq_fp,buffer_sect_size,_nj_texture_buffer_st)) < 0){
				/* G[@*/
				/* error */
				load_mode = LOAD_END;
				/*********** G[R[hԂ ************/
				/********* Turn over error code ************/
				_nj_texerr_.n = load_n;
				_nj_texerr_.texerr = NJD_TEXERR_FILELOAD;
				return -1;
			}
			r_sect_size -= buffer_sect_size;
			read_size = buffer_sect_size*NJD_GD_SECT_SIZE;
		}
		load_mode = FILE_READ_WAIT;
		buffer_start = _nj_texture_buffer_st;
	}

	if(load_mode == FILE_READ_WAIT){
		ret = gdFsGetStat(tex_loadreq_fp);
		switch(ret){
		case GDD_STAT_COMPLETE:
			if(offset == 0){
				load_mode = GET_SURFACE;
			}
			else{
				load_mode = LOAD_TEX;
			}
			break;
		case GDD_STAT_IDLE:
		case GDD_STAT_READ:
		case GDD_STAT_SEEK:
		case GDD_STAT_BUSY:
			load_mode = FILE_READ_WAIT;
			return;
			break;
		case GDD_STAT_ERR:
			/* G[̏ꍇ */
			/* error */
			load_mode = LOAD_END;
			gdFsClose(tex_loadreq_fp);
			/*********** G[R[hԂ ************/
			/********* Turn over error code ************/
			_nj_texerr_.n = load_n;
			_nj_texerr_.texerr = NJD_TEXERR_FILELOAD;
			return -1;
			break;
		}
	}

	if(load_mode == GET_SURFACE){
		/* wb_f[^擾 pTextureɂ̓f[^̐擪AhXԂ@*/
		/* Acquire header data. The top address of data returns in pTexture. */
		if((pTexture = njLoadPvrHeader(&pvrh,&globalIndex,buffer_start)) != NULL){
			read_size -= (Sint32)((Uint32)pTexture - (Uint32)buffer_start);
			/* O[oCfbNX[Uw̏ꍇ@*/
			/*  Global index is a case user setting. */
			if(load_list->textures[load_n].attr & NJD_TEXATTR_GLOBALINDEX){
					globalIndex = load_list->textures[load_n].texaddr;
			}
			else{
				/* t@CɃO[oCfbNXȂꍇ@*/
				/* When there is not a global index in a file. */
				if(globalIndex == NJD_GLOBAXINDEX_FIRST_VAL){
					/* O[oCfbNXt@*/
					/* Establish a global index. */
					globalIndex = (globalIndex_S--);
				}
			}
			no = -1;
			/* eNX`Xg̋󂢂ĂꏊT@*/
			/* Look for a place becoming vacant of texture memory list. */
		    for(i = 0;i < _nj_texmemsize;i++){
		        if(_nj_texmemlist[i].globalIndex == globalIndex){
			        	/* łɃ[hĂ@*/
			        	/* Is loaded already. */
						gdFsClose(tex_loadreq_fp);
						load_mode = LOAD_END;
						_nj_texmemlist[i].count++;
						return 1;
		        }
		        else{
					if(no < 0){
						if(_nj_texmemlist[i].globalIndex == NJD_GLOBAXINDEX_FIRST_VAL){
					        	no = i;
				        }
				    }
			    }
		    }
	    	/* eNX`Xg͎擾łȂ */
	    	/* Texture memory list was not able to acquire it. */
		    if(no < 0){
				load_mode = LOAD_END;
				texmemlist = NULL;
				gdFsClose(tex_loadreq_fp);
				/*********** G[R[hԂ ************/
				/********* Turn over error code ************/
				_nj_texerr_.n = load_n;
				_nj_texerr_.texerr = NJD_TEXERR_OTHER;
				return -1;
		    }
			texmemlist = &_nj_texmemlist[no];
			texmemlist->globalIndex = globalIndex;
			/* eNX`T[tFX쐬@*/
			/* Make texture SurfaceDesc. */
			if(njGetTexSurface(texmemlist,&pvrh) < 0){
				/* T[tFX擾Ɏs̎@*/
				/* In failing in the SurfaceDesc acquisition. */
				load_mode = LOAD_END;
				FreeTexMemList(texmemlist);
				texmemlist = NULL;
				gdFsClose(tex_loadreq_fp);
				/*********** G[R[hԂ ************/
				/********* Turn over error code ************/
				_nj_texerr_.n = load_n;
				_nj_texerr_.texerr = NJD_TEXERR_SURFACE;
				return -1;
			}
			njSetTextureParam(texmemlist);
			buffer_start = pTexture;
			load_mode = LOAD_TEX;
			offset = 0;
		}
	}

	if(load_mode == LOAD_TEX){
		if(njLoadTexturePartLow(texmemlist,buffer_start,offset,read_size) == -1){
				/* eNX`[hG[@*/
				/* Texture load error. */
				load_mode = LOAD_END;
				/* 擾ĂT[tFX̃[X@*/
				/* Release of the SurfaceDesc which acquired it. */
				njReleaseTextureLow(texmemlist);
				/* 擾ĂXg[X@*/
				/* Release of the texture memory list which acquired it.*/
				FreeTexMemList(texmemlist);
				texmemlist = NULL;
				/* t@C̃N[Y@*/
				/* Closing of a file. */
				gdFsClose(tex_loadreq_fp);
				/*********** G[R[hԂ ************/
				/********* Turn over error code ************/
				_nj_texerr_.n = load_n;
				_nj_texerr_.texerr = NJD_TEXERR_TEXMEMLOAD;
				return -1;
		}
		offset += read_size;
		load_mode = LOAD_DMA_WAIT;
		dma_count = 0;
	}


	if(load_mode == LOAD_DMA_WAIT){
		/* DMAI̊mF@*/
		/* The confirmation that DMA finished. */
		if(njLoadTextureFinishDMA() == 1){
			if(r_sect_size <= 0){
				/* ׂẴ[hI@*/
				/* All texture load is finished. */
				gdFsClose(tex_loadreq_fp);
				load_mode = LOAD_END;
				/* eNX`Xgɒǉ */
				/* Is addition information in texture memory list. */
				EntryTexMemList(texmemlist);
				/* eNX`XgƃeNX`Xg̃N͂ */
				/* Set up a link of texture list and texture memory list. */ 
				load_list->textures[load_n].texaddr = (Uint32)texmemlist;
				/* [heNX`̐JEg
				@̐NINDOWS̃eNX`r[AŌ邱Ƃł
				*/
				/* Count number of the texture which loaded it.
				   Can watch it with texture viewer of NINDOWS for these several minutes.
				*/
				_nj_tex_count++;
			}
			else{
				/* ̃t@C̃[h@*/
				/* A lead of the next file. */
				load_mode = FILE_READ;
			}
			dma_count = 0;
		}
		else{
			/* */
			dma_count++;
		}
		if(dma_count > DMA_WAIT_ERR_COUNT){
			/* DMA_WAIT_ERR_COUNT(10)񐔗Ă[hȂꍇ̓G[Ƃ*/
			/* When load is not completed even if comes, do DMA_WAIT_ERR_COUNT(10) frequency with an error. */
			load_mode = LOAD_END;
			/* T[tFX[X@*/
			/* Release a SurfaceDesc. */
			njReleaseTextureLow(texmemlist);
			FreeTexMemList(texmemlist);
			texmemlist = NULL;
			gdFsClose(tex_loadreq_fp);
			/*********** G[R[hԂ ************/
			/********* Turn over error code ************/
			_nj_texerr_.n = load_n;
			_nj_texerr_.texerr = NJD_TEXERR_OTHER;
			return -1;
		}
	}


	return 1;
}


/************************************************
	LoadMode
	LoadTextureServer֐݂̌̃[h擾
	
	
		Ȃ
	߂l
		[h

		LOAD_END			0	eNX`[hI
		READ_START			1	t@C[hX^[g
		FILE_READ			2	t@C[hv
		FILE_READ_WAIT		3	t@C[hDMA҂
		GET_SURFACE			4	T[tFX擾
		LOAD_TEX			5	eNX`[hv
		LOAD_DMA_WAIT		6	eNX`[hDMA҂

*************************************************/
/************************************************
	LoadMode
	Acquire a current mode of LoadTextureServer function.
	
	Argument
		
	Return value
		Mode

		LOAD_END			0	Texture load end
		READ_START			1	File read start
		FILE_READ			2	During file read demand
		FILE_READ_WAIT		3	Wait for file read DMA
		GET_SURFACE			4	During the SurfaceDesc acquisition
		LOAD_TEX			5	During texture load demand
		LOAD_DMA_WAIT		6	Wait for texture load DMA

*************************************************/
Sint32 LoadMode(void)
{
	return load_mode;
}

/************************************************
	EntryTexMemList
	eNX`XgɃ[htO𗧂Ă
	
	
		NJS_TEXMEMLIST *texmemlist
	߂l
		Ȃ
*************************************************/
/************************************************
	EntryTexMemList
	Make the flag which loaded it in texture list.
	
	Argument
		NJS_TEXMEMLIST *texmemlist
	Return value
		
*************************************************/
void EntryTexMemList(NJS_TEXMEMLIST *texmemlist)
{
	texmemlist->count = 1;
	texmemlist->texaddr = NJD_TEXMEMFLAG_TEXMEM;
	texmemlist->dummy = 0;
}


/************************************************
	FreeTexMemList
	eNX`Xgt[
	
	
		NJS_TEXMEMLIST *texmemlist
	߂l
		Ȃ
*************************************************/
/************************************************
	FreeTexMemList
	Release texture memory list.
	
	Argument
		NJS_TEXMEMLIST *texmemlist
	Return value
		
*************************************************/
void FreeTexMemList(NJS_TEXMEMLIST *texmemlist)
{
	texmemlist->globalIndex 					= 	0xFFFFFFFF;
	texmemlist->bank 							= 	0xFFFFFFFF;
    texmemlist->tspparambuffer					= 	0;
    texmemlist->texparambuffer					= 	0;
    texmemlist->texinfo.texaddr 				= 	0;
	texmemlist->texinfo.texsurface.Type 		= 	0;
	texmemlist->texinfo.texsurface.BitDepth 	= 	0;
	texmemlist->texinfo.texsurface.PixelFormat 	= 	0;
	texmemlist->texinfo.texsurface.nWidth 		= 	0;
	texmemlist->texinfo.texsurface.nHeight 		= 	0;
	texmemlist->texinfo.texsurface.TextureSize 	= 	0;
	texmemlist->texinfo.texsurface.fSurfaceFlags = 	0;
	texmemlist->texinfo.texsurface.pSurface 	= 	0;
	texmemlist->texaddr 						= 	0;
    texmemlist->count							=	0;
}

/************************************************
	CheckFileName
	PVRt@C`FbNB
	PVRgqt@CɂȂꍇPVR
	
	
		char* namedst		`FbÑt@C
		const char* namesrc@̓t@C
	߂l
		Ȃ
*************************************************/
/************************************************
	CheckFileName
	Check PVR file name.
	When there is not it, PVR expansion child adds PVR to a file name
	
	Argument
		char* namedst		A file name after a check
		const char* namesrc The input file name
	Return value
		
*************************************************/
void CheckFileName(char* namedst,const char* namesrc)
{
	Sint32 strl;
	char ext[5];
	Sint32 i;
	Sint32 ret;

	strl = strlen(namesrc);
	/* gq͌3Ɍ߂@*/
	/* Back three characters consider it to be expansion. */
	strcpy(ext,&namesrc[strl-4]);	/* gq̃Rs[ *//* A copy of expansion */
	strupr(ext);					/* 啶ɕϊ *//* Convert it into large characters */

	if(ext[0] == '.'){/* gq *//* There is expansion. */
		if(ret = strcmp(ext,".PVR") != 0){
			/* PVRȊO̎@*/
			/* When is not PVR. */
			strcpy(namedst,namesrc);
			strcat(namedst,".PVR");
			return ;
		}
		else{
			strcat(namedst,namesrc);
			return ;
		}
	}
	else{/* gqȂƂPVR */
		 /* When there is not expansion, add PVR.*/
			strcpy(namedst,namesrc);
			strcat(namedst,".PVR");
			return ;
	}
}

/************************************************
	ReleaseTexture
	eNX`̃[X
	
	
		NJS_TEXLIST *texlist	eNX`Xg
		Sint32 n				eNX`ԍ
	߂l
		Ȃ
*************************************************/
/************************************************
	ReleaseTexture
	Release of a texture.
	
	Argument
		NJS_TEXLIST *texlist	texture list
		Sint32 n				texture number
	Return value
		
*************************************************/
void ReleaseTexture(NJS_TEXLIST *texlist,Uint32 n)
{
	NJS_TEXMEMLIST *texmemlist;
	
	texmemlist = (NJS_TEXMEMLIST*)texlist->textures[n].texaddr;
	if(texmemlist->texaddr & NJD_TEXMEMFLAG_TEXMEM){
		/* eNX`[X@*/
		/* Release a texture. */
		njReleaseTextureLow(texmemlist);
		_nj_tex_count--;
		/* 擾ĂXg[X@*/
		/* Release the memory list which acquired it. */
		FreeTexMemList(texmemlist);
	}
}

/************************************************
	LoadTextureStop
	eNX`[h̒~
	
	
		Ȃ
	߂l
		@P
		s@|P
*************************************************/
/************************************************
	LoadTextureStop
	Stop load texture.
	
	Argument
		
	Return value
	Success  1
	Failure -1
*************************************************/
Sint32 LoadTextureStop(void)
{
	Sint32 ret;
	
	InitTextureErrStat();

	if(load_mode == FILE_READ_WAIT){
		ret = gdFsStopRd(tex_loadreq_fp);
		gdFsClose(tex_loadreq_fp);
		if(ret != GDD_ERR_OK){
			_nj_texerr_.n = load_n;
			_nj_texerr_.gderr = ret;
			_nj_texerr_.texerr = NJD_TEXERR_OTHER;
			load_mode = LOAD_END;
			return -1;
		}
	}

	load_mode = LOAD_END;

	return 1;
	
}

/************************************************
	InitTextureErrStat
	eNX`G[̏
	
	
		Ȃ
	߂l
		Ȃ
*************************************************/
/************************************************
	InitTextureErrStat
	Initialization of texture error.
	Argument
	
	Return value

*************************************************/
void InitTextureErrStat(void)
{
	_nj_texerr_.n = NJD_GLOBAXINDEX_FIRST_VAL;
	_nj_texerr_.globalIndex = NJD_GLOBAXINDEX_FIRST_VAL;
	_nj_texerr_.texerr = 0;
	_nj_texerr_.gdstat = 0;
	_nj_texerr_.gderr = 0;

}
