/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F JAOύX
  ҏW F 98-04-24 Jn
              98-06-19 SET5Ή
              98-08-21  Foge[ũZbgnjUserInit̒Ɉړ
              99-04-05 appends the English comments
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}


/* O[oZNV */
/* global data          */
extern NJS_CNK_OBJECT   object_cube_root[];

/* }gNX֘A */
/* matrix         */
#define MATRIX_DEPTH 10
#define VERTEX_MAX   256

static NJS_MATRIX     *g_Matrix;
static NJS_VERTEX_BUF *g_VBuf;

/*   _ */
/* light resource and view point */
static NJS_VIEW  g_View;
static NJS_LIGHT g_Light;

/* |[YtO */
/* pause flag       */
Bool g_bPause = FALSE;

/* ֐̃vg^Cv */
/* prototype declarations */
void ActiveProc(void);	/* ANeBu֐ */
void DrawProc(void);	/* `揈֐ */
void PauseProc(void);	/* |[Y֐ */

static NJS_FOG_TABLE fog;

/**********************************************************************

	njSetBorderColor( 0x00000000 );
    njUserInit --- NinjaVXe֐

**********************************************************************/

void njUserInit(void)
{
    /* VXȅ */
    /* Initializes the Dreamcast H/W and readies the SEGA library */
    sbInitSystem(NJD_RESOLUTION_640x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);

    /* msrbʂ̏c␳ */
  	/* corrects the screen aspect ratio */
    njSetAspect(1.0F, 0.45F);

    /* ̊蓖 */
    /* allocates the memory */
    g_Matrix = (NJS_MATRIX *)syMalloc(sizeof(NJS_MATRIX) * MATRIX_DEPTH);
    g_VBuf = (NJS_VERTEX_BUF *)syMalloc(sizeof(NJS_VERTEX_BUF) * VERTEX_MAX);

    /* _i[obt@̊m */
    /* allocates the buffers for registration of vertex data */
    njInitVertexBuffer(VERTEX_MAX * 64 / 4, 0, VERTEX_MAX * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );

    /* }gNXX^bN̏ */
   	/* initializes the matrix stack */
    njInitMatrix(g_Matrix, MATRIX_DEPTH, 1);

    /* Zp_obt@̏ */
    /* initializes 3D system  */ 
    njInit3D(g_VBuf, VERTEX_MAX);

    /* fAIuWFNg̕`Rg[ */
    /* controls drawing of models and objects */
    njControl3D(NJD_CONTROL_3D_CONSTANT_ATTR);

    /* ̏ */
    /* initializes the light source */
    njCreateLight(&g_Light, NJD_SPEC_DIR);

    /* r[̏ */
    /* initializes the user-defined view */
    njInitView(&g_View);

    /* r[̐ݒ */
    /* sets the user-defined view as the current view */
    njSetView(&g_View);

    /* wiF̐ݒ */
	/* sets background color */
    njSetBackColor(ARGB(0xff, 0xc0, 0, 0), 
                        ARGB(0xff, 0, 0xc0, 0), ARGB(0xff, 0, 0, 0xc0));

    /* eLXg̃J[ݒ */
	/* sets the color of debug printing */
    njPrintColor(ARGB(0xff, 0xc0, 0xc0, 0xc0));


    /* tHOe[uZbg */
    /* sets the fog table */
	njGenerateFogTable(fog);
	njSetFogTable(fog);
}


/**********************************************************************

    njUserMain --- NinjaVXeC֐

**********************************************************************/

Sint32 njUserMain(void)
{
    PDS_PERIPHERAL *per;

    /* WCXeBbN|[gP̃ytF擾 */
    /* gets the peripheral information */
    per = pdGetPeripheral(PDD_PORT_A0);    

    /* {^ꂽǂ`FbN */
    /* checks the pressing of start button */
    if (per->press & PDD_DGT_ST) {
        g_bPause = !g_bPause;
    }

	if (!g_bPause) {    
	   	/* ANeBu */
	   	/* not pause        */
		ActiveProc();
	} else {
		/* |[Y */
		/* pause        */
		PauseProc();
	}
		
    /* fobO̕\ */
    /* prints the sample program name */
    njPrintC(NJM_LOCATION(23, 5), "Ninja Sample CAMERA ANGLE");

    return NJD_USER_CONTINUE;
}



/**********************************************************************

    DrawProc --- `揈֐

**********************************************************************/

void DrawProc(void)
{
    int i, j;

    /* S̊pɗ̂zu */
    /* draws the cube at the 4 corners */ 
    for (j = 0; j < 2; j++) {
        for (i = 0; i < 2; i++) {
            njPushMatrix(NULL);
                njTranslate(NULL, i * 10.0f - 5.0f, 0.0f, j * 10.0f - 5.0f);

                /* IuWFNg̕` */
                /* draw the object    */
                njCnkDrawObject(object_cube_root);
                
            njPopMatrix(1);
        }
    }
}


/**********************************************************************

    ActiveProc --- ANeBu֐

**********************************************************************/

void ActiveProc(void)
{
    static Angle theta = NJM_DEG_ANG(0.0F);

    /* J] */
    /* rotates the camera */
    theta += NJM_DEG_ANG(0.5F);
    njRotateViewYAbsolute(NULL, theta);
    njSetView(&g_View);
    
    /* `揈 */
    /* draw     */
    DrawProc();
}


/**********************************************************************

    PauseProc --- |[Y֐

**********************************************************************/

void PauseProc(void)
{

	/* tHO̐ݒ */
	/* sets the fog information */
	njSetFogColor(0x00000000);
	njSetFogDensity(0xfff0);
	njFogEnable();

	/* `揈 */
	/* draws    */
    DrawProc();

	/* tHO𖳌ɂ */
	/* clears the fog table */
	njFogDisable();

    /* |[YԂ̕\ */
    /* prints the pause status */
    njPrintC(NJM_LOCATION(38, 25), "PAUSE");
}


/**********************************************************************

    njUserExit --- NinjaVXeI֐

**********************************************************************/

void njUserExit(void)
{
	njExitPrint();

    /* ̊J */
	/* frees the memory area */
    syFree(g_Matrix);
    syFree(g_VBuf);
    
    /* VXȅI܂ ŌɕKĂяoĂ */
    /* exits the system    */
    sbExitSystem();
}
