/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD

  ^Cg F _̐ݒA
              O[AtbgVF[fBO̐؂ւ
              point light,shading mode
  ҏW F 98-04-30 쐬Jn
              98-06-19 SET5Ή
              99-04-05 appends the English comments
************************************************************/

#include <shinobi.h>
#include <njdef.h>
void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}


/* O[of[^ZNV */
/* global data */

#define MATRIX_DEPTH    12
#define VERTEX_MAX      1024

extern NJS_CNK_OBJECT object_cube_root[];

/* 3D֘Af[^ */
/* 3D data */
static NJS_MATRIX     *g_Matrix;   /* }gNXX^bN */
                                   /* matrix stack */
static NJS_VERTEX_BUF *g_VBuf;     /* _obt@ */
                                   /* vertex buffer */

static NJS_VIEW    g_View;         /* _ */
                                   /* view point */
static NJS_LIGHT   g_Light;        /*  */
                                   /* light source */

/* |[Y֐ */
/* puase function */
void PausePhase(void);

/* ANeBu֐ */
/* main function */
void ActivePhase(void);

/* |[YtO */
/* pause flag */
Bool g_bPause = FALSE;


/**************************************************************************

	njSetBorderColor( 0x00000000 );
    njUserInit --- NinjaVXe֐
                   initialize
**************************************************************************/

void njUserInit(void)
{
    /* ʃ[hݒ */
    /* Initializes the Dreamcast H/W and readies the SEGA library */
    sbInitSystem( NJD_RESOLUTION_640x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);

    /* ʂ̃AXyNgύX */
	/* corrects the screen aspect ratio */
    njSetAspect(1.0F, 0.45F);

    /* ̊蓖 */
    /* allocates the memory */
    g_Matrix = (NJS_MATRIX *)syMalloc(sizeof(NJS_MATRIX) * MATRIX_DEPTH);
    g_VBuf = (NJS_VERTEX_BUF *)syMalloc(sizeof(NJS_VERTEX_BUF) * VERTEX_MAX);

    /* _obt@̊m */
    /* allocates the buffers for registration of vertex data */
    njInitVertexBuffer(VERTEX_MAX * 64 / 4, 0, VERTEX_MAX * 64, 0, 0); 
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );

    /* }gNXX^bN̏ */
  	/* initializes the matrix stack */
    njInitMatrix(g_Matrix, MATRIX_DEPTH, 1);

    /* Zp_obt@̊m */
    /* initializes 3D system  */ 
    njInit3D(g_VBuf, VERTEX_MAX);

    /* r[̏ */
    /* initializes the user-defined view */
    njInitView(&g_View);
    njSetView(&g_View);

    /* Cg̏ */
    /* initializes the light source  */
    njCreateLight(&g_Light, NJD_SPEC_POINT);
    njSetLightIntensity(&g_Light, 0.5F, 1.0F, 0.2F);
    njSetLightLocation(&g_Light, 0.0F, 0.0F, -7.0F);

    /* Agr[gύXł悤ɂ */
    /* attributes of the CHUNK model can be changed */
    njControl3D( NJD_CONTROL_3D_CNK_CONSTANT_ATTR );

    /* obNOEh̃J[ݒ */
   	/* sets background color */
    njSetBackColor(ARGB(0xff, 0xc0, 0, 0), 
                            ARGB(0xff, 0, 0xc0, 0), ARGB(0xff, 0, 0, 0xc0));
    /* eLXg̃J[w */
    /* sets the text color */
    njPrintColor(ARGB(0xff, 0xc0, 0xc0, 0xc0));
}


/**************************************************************************

    njUserMain --- NinjaVXeC֐
    main
    
**************************************************************************/

Sint32 njUserMain(void)
{
    NJS_PERIPHERAL *per;

    /* WCXeBbN|[gP̃ytF擾 */
    /* gets the peripheral information (port A) */
    per = njGetPeripheral(NJD_PORT_A0);    

    /* {^ꂽǂ`FbN */
    /* checks the start button */
    if (per->press & NJD_DGT_ST) {
        g_bPause = !g_bPause;
    }

	if (!g_bPause) {
	   	/* ANeBu */
	   	/* not pause */
		ActivePhase();
	} else {
		/* |[Y */
		/* pause */
		PausePhase();
	}

    /* fobO\ */
    /* prints the sample program name */
    njPrintC(NJM_LOCATION(23, 4), "Ninja Sample POINT LIGHT");

    return NJD_USER_CONTINUE;
}


/**************************************************************************

    ActivePhase --- ANeBu֐
                    not pause
**************************************************************************/

void ActivePhase(void)
{
    static Angle x_ang = NJM_DEG_ANG(0.0F);
    static Angle y_ang = NJM_DEG_ANG(0.0F);
    static Angle z_ang = NJM_DEG_ANG(0.0F);

    static int time = 0;

    /* oߎԂɂVF[fBO؂ւ */
    /* changes the shading mode by the time */
    if (++time > 600) {
        time = 0;
    }
    if (time < 300) {
        njSetConstantAttr( 0xffffffff, NJD_FST_FL );
        njPrintC(NJM_LOCATION(5, 8), "Shading Mode = Flat");
    } else {
        njSetConstantAttr( 0xffffffff, 0);
        njPrintC(NJM_LOCATION(5, 8), "Shading Mode = Gouraud");
    }

    /* }gNX̃NA */
    /* clears the matrix stack */
    njClearMatrix();

    /* ړ */
    /* translate */
    njTranslate(NULL, 0.0F, 0.0F, -10.0F); 

    /* ] */
    /* rotates  */
    x_ang += NJM_DEG_ANG(1.0F);
    y_ang += NJM_DEG_ANG(1.0F);
    z_ang += NJM_DEG_ANG(1.0F);
    njRotateXYZ(NULL, x_ang, y_ang, z_ang);

    /* ` */
    /* draw */
    njCnkDrawObject(object_cube_root);
}


/**************************************************************************

    PausePhase --- |[Y֐
                   puase
**************************************************************************/

void PausePhase(void)
{
	static NJS_FOG_TABLE fog;

	/* tHO̐ݒ */
	/* sets the fog data */
	njSetFogColor(0x00000000);
	njSetFogDensity(0xfff0);
	njGenerateFogTable(fog);
	njSetFogTable(fog);
	njFogEnable();

    /* ` */
    /* draws the object */
    njCnkDrawObject(object_cube_root);

	/* tHO𖳌ɂ */
	/* Disables the fog effect  */
	njFogDisable();

    /* |[YԂ̕\ */
    /* prints the pause status */
    njPrintC(NJM_LOCATION(38, 25), "PAUSE");
}


/**************************************************************************

    njUserExit --- NinjaVXeI֐

**************************************************************************/

void njUserExit(void)
{
	njExitPrint();
	
    /* ̊J */
   	/* exits texture use  */
    syFree(g_Matrix);
    syFree(g_VBuf);

    /*  VXȅIs܂ */
    /* exits the system    */
    sbExitSystem();
}
