/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD

  ^Cg F ̐ݒA
              O[AtbgVF[fBO̐؂ւ
              spot light, shading mode
  ҏW F 98-05-01 쐬Jn
              98-06-19 SET5Ή
              98-07-09 |[Y@\(light 0ff)ǉA
              fobNFύX
              99-04-05 appends the English comments
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
        njUserInit();
        while (njUserMain() == NJD_USER_CONTINUE) {
                njWaitVSync();
        }
        njUserExit();
}

#define MAX_MATRIX_DEPTH 12
#define MAX_VERTEXES 2000
#define OBJECT_1 object_cube_root
#define CUBE_X 10.5F
#define CUBE_Y 10.F
#define CUBE_Z -20.F
#define CUBE_NEXT 2.4F

extern NJS_CNK_OBJECT OBJECT_1[];
extern NJS_MATRIX object;
static NJS_MATRIX *matrix;
static NJS_VERTEX_BUF *vbuf;
NJS_VIEW view;
NJS_LIGHT light;
NJS_LIGHT light1;
NJS_ARGB argb;

/*VF[fBOptO*/
/* shading mode flag */
Bool  flat = FALSE;
/*----------------------------------------------------------------------
           
           initialize
----------------------------------------------------------------------*/
void njUserInit(void)
{
    /* VXȅ */
    /* Initializes the Dreamcast H/W and readies the SEGA library */
    sbInitSystem(NJD_RESOLUTION_640x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);

    /* ʂ̏c␳ */
	/* corrects the screen aspect ratio */
    njSetAspect(1.0F, 0.45F);

    /*matrixvertexobt@̊m*/
    /* allocates the memory */
    matrix = (NJS_MATRIX *)syMalloc(sizeof (NJS_MATRIX) * MAX_MATRIX_DEPTH);
    vbuf = (NJS_VERTEX_BUF *)syMalloc(sizeof (NJS_VERTEX_BUF) * MAX_VERTEXES);

    /* wiF̐ݒ */
	/* sets background color */
    njSetBackColor(ARGB(0, 0, 0, 0), ARGB(0, 0, 0, 0), ARGB(0, 0, 0, 255));

    /* _i[obt@̊m */
    /* allocates the buffers for registration of vertex data */
    njInitVertexBuffer(MAX_VERTEXES * 256 , 0, MAX_VERTEXES * 256 , 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );

    /* }gNXX^bN̏ */
  	/* initializes the matrix stack */
    njInitMatrix(matrix, MAX_MATRIX_DEPTH, 1);

    /* 3DVXȅ */
    /* initializes 3D system  */ 
    njInit3D(vbuf, MAX_VERTEXES);

    /* r[̏ */
    /* initializes the user-defined view */
    njInitView(&view);

    /* r[̐ݒ */
	/* specifies the current view */
    njSetView(&view);

    /* ̐ݒ */
    /* initializes the light source */
    njCreateLight(&light, NJD_SPEC_DIR);
    njSetLightIntensity( &light, 0.1F, 0.2F, 0.1F );

    njCreateLight( &light1, NJD_SPOT_LIGHT);
    njSetLightLocation(&light1, 0.F, -1.F, -8.F);
    njSetLightIntensity( &light1, 1.0F, 1.0F, 1.0F );

    njControl3D(NJD_CONTROL_3D_CNK_CONSTANT_ATTR|NJD_CONTROL_3D_CONSTANT_TEXTURE_MATERIAL);
    /*light color*/
    argb.r = 0;
    argb.g = 0;
    argb.b = 0;
    
    /*debugύX(Ăth~)*/
    /* sets the text color */
    njPrintColor(0xffc0c0c0);
}

/*----------------------------------------------------------------------
         C
----------------------------------------------------------------------*/
Sint32 njUserMain(void)
{
    int i = 0;
    int j = 0;
    static PDS_PERIPHERAL *input; /*L[͗p */
                                  /* peripheral information */
    static Bool pause = FALSE;    /*flag for pause */

    input = pdGetPeripheral(PDD_PORT_A0);
    /*|[Y̔ */
    /* checks the start button */
    if (input->press & PDD_DGT_ST) {
        pause = !pause;
        if(pause){  /*|[Y猸*/
                    /* decreases the light intensity when pause */
            njSetLightIntensity(&light, 0.01F, 0.01F, 0.01F);
            njSetLightIntensity(&light1, 0.1F, 0.1F, 0.1F);
            njSetBackColor(ARGB(0, 0, 0, 0), ARGB(0, 0, 0, 0), ARGB(0, 0, 0, 100));
        } else {    /*|[YʂPx߂*/
                    /* increates the light intensity when not pause */
            njSetLightIntensity(&light, 0.1F, 0.2F, 0.1F);
            njSetLightIntensity(&light1, 1.F, 1.F, 1.F);
            njSetBackColor(ARGB(0, 0, 0, 0), ARGB(0, 0, 0, 0), ARGB(0, 0, 0, 255));
        }
    }
    /*|[Y̏*/
    /* pause */
    if (pause){
        njPrintC(NJM_LOCATION(35, 25), "PAUSE");
    }

    /*sample name*/
    njPrintC(NJM_LOCATION(23, 4),"Ninja Sample SOPT LIGHT");

    /* }gNXX^bÑNA */
    /* clears the matrix stack */
    njClearMatrix();

    /* IuWFNg̕` */
	/* draws the object */
    for (j = 0; j < 10; j++) {
        for (i = 0; i < 10; i++) {
            njPushMatrix(NULL);
            njTranslate(NULL, CUBE_X - (j * CUBE_NEXT), CUBE_Y - (i * CUBE_NEXT), CUBE_Z);
            njCnkDrawObject(OBJECT_1);
            njPopMatrix(1);
        }
    }
    if (!pause) {   /*|[Yɂ̓f[^̍XVsȂ*/
                    /* not pause */
        /*VF[fBOF̍XV*/
        /* updates the shading color */
        njSetLightColor(&light1, argb.r, argb.g, argb.b);
        argb.r += 0.003F;
        argb.g += 0.002F;
        argb.b += 0.001F;
        if (argb.r > 1)
            argb.r = 0;
        if (argb.g > 1)
            argb.g = 0;
        if (argb.b > 1)
            argb.b = 0;
        
        /*VF[fBO̐؂ւ*/
        /* changes the shading mode */
        if (argb.r >= 1)
            if (!flat) {
                flat = TRUE;
            }else {
                flat = FALSE;
            }
        if (!flat) {
            njSetConstantAttr( ~NJD_FST_FL, 0);
            njPrintC(NJM_LOCATION(2, 7), "Gouraud Shading");
        }else {
            njSetConstantAttr( 0xffffffff, NJD_FST_FL);
            njPrintC(NJM_LOCATION(2, 7), "Flat Shading");
        }
    }
    return NJD_USER_CONTINUE;
}

/*----------------------------------------------------------------------
         I
----------------------------------------------------------------------*/
void njUserExit(void)
{
	njExitPrint();

    /*matrixvbuf̃NA*/
   	/* frees the memory area */
    syFree(matrix);
    syFree(vbuf);

    /* VXȅI */
    /* exits the system    */
    sbExitSystem();
}
