/*
	Ninja Sample

	COPYRIGHT (C) SEGA ENTERSRISES,LTD.

	Multilight Sample

	1998.9.08
*/

#include <Shinobi.h>
#include <Nindows.h>

#define	OBJECT	object_tea_Teapot1E_Teapot1E

extern NJS_CNK_OBJECT OBJECT[];
extern NJS_MATRIX	matrix[8];
extern NJS_VERTEX_BUF	vbuf[4096];

NJS_TEXMEMLIST	tex[10];
NJS_VIEW	view;
NJS_PERIPHERAL *per;

Sint32	xx,yy,zz = 0;

void njUserInit(void)
{
	/* {[_[J[ɃZbg */
	/* Setting border color at black */
	njSetBorderColor(0x00000000);
	sbInitSystem( NJD_RESOLUTION_640x480_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1 );
	/* 2V[eV[h */
	/* Establishing in 2V Latency Mode */
	njInitVertexBuffer( -800000, 0, 200000, 0 ,0);
	/* fobOvg̏ */
	/* Initialization of debugging print */
	njInitPrint(NULL,0,0);
	njInitMatrix( matrix, 8 , 0);
	njInit3D( vbuf, 4096 );
	njInitView( &view );
	njSetView( &view );

	/*NindowsŎgpeNX`*/
	/* Preparing texture share to use it for Nindows */
	njInitTexture( tex, 10 );
	nwInitSystem(10,NJD_PORT_B0);

	njControl3D( NJD_CONTROL_3D_CONSTANT_ATTR );
	njSetConstantAttr( 0xffffffff, NJD_FLAG_USE_TEXTURE | NJD_FLAG_USE_ENV|NJD_FILTER_BILINEAR);

	njSetBackColor(0x00000000,0x00000000,0x000000FF);

	njPrintSize(16);
	
	/* `NCǧ̐ݒ              *
	 * iŌݒL[Ȃ̂    *
	 *   ƃCg̎ނ͈ȉ̂悤      *
	 *   ֘A܂B                     j   *
	 *                                         *
	 * 1:sP                            *
	 * 2:sP+_Q                   *
	 * 3:sP+_Q+_R          *
	 * 4:sP+_Q+_R+_S *
	 *                                         */
	/* Setting of number of chunk-light        *
	 * (The number and a kind of a light are   *
	 * related as follows because of no Light  *
	 * Source Setting Queue.)                  *
	 *                                         *
	 * 1:DIRECT1                               *
	 * 2:DIRECT1+POINT2                        *
	 * 3:DIRECT1+POINT2+POINT3                 *
	 * 4:DIRECT1+POINT2+POINT3+POINT4          *
	 *                                         */
	 
	njCnkSetEasyMultiLight(4);

	/* `NCg̕siԖڂ̌jݒ */
	/* Directional Light (the 1st source of light) *
	 * direction setting of chunk light            */
	njCnkSetEasyMultiLightVector(0.f, 0.f, -1.f);

	/* `NCg̓_ʒuݒ */
	/* QԖڂ̌i_j̐ݒ */
	/* Point Light Source position setting of chunk light */
	/* Setting of the 2nd source of light (a point light source) */
	njCnkSetEasyMultiLightPoint(NJD_CNK_EASY_MULTILIGHT_2, 0.f, 0.f, -12.f);
	/* RԖڂ̌i_j̐ݒ */
	/* Setting of the 3rd source of light (a point light source) */
	njCnkSetEasyMultiLightPoint(NJD_CNK_EASY_MULTILIGHT_3, 0.f, 0.f, -12.f);
	/* SԖڂ̌i_j̐ݒ */
	/* Setting of the 4th source of light (a point light source) */
	njCnkSetEasyMultiLightPoint(NJD_CNK_EASY_MULTILIGHT_4, 0.f, 0.f, -12.f);

	/* `NCg̓_͈́ijݒ */
	/* Point Light source range (distance) setting of chunk light */
	njCnkSetEasyMultiLightRange(NJD_CNK_EASY_MULTILIGHT_2, 6.f, 40.f);
	njCnkSetEasyMultiLightRange(NJD_CNK_EASY_MULTILIGHT_3, 6.f, 40.f);
	njCnkSetEasyMultiLightRange(NJD_CNK_EASY_MULTILIGHT_4, 6.f, 40.f);

	/* `NCg̃ArGgFݒ */
	/* Ambient color setting of chunk light */
	njCnkSetEasyMultiAmbient(0.1f, 0.1f, 0.1f);

	/* `NCǧFݒ */
	/* light color setting of chunk light */
	njCnkSetEasyMultiLightColor(NJD_CNK_EASY_MULTILIGHT_1, 0.6f, 0.5f, 0.3f);
	njCnkSetEasyMultiLightColor(NJD_CNK_EASY_MULTILIGHT_2, 1.f, 0.5f, 0.5f);
	njCnkSetEasyMultiLightColor(NJD_CNK_EASY_MULTILIGHT_3, 0.5f, 1.f, 0.5f);
	njCnkSetEasyMultiLightColor(NJD_CNK_EASY_MULTILIGHT_4, 0.5f, 0.5f, 1.f);
}

#define RANGE	10
#define LTNUM	10
Sint32 njUserMain(void)
{
	static int _num = 0;
	static int _stop = 1;
	static int _lt_1[LTNUM]={1,0,1,0,0,0,0,0,0,0};
	static int _lt_2[LTNUM]={1,0,0,1,0,0,1,1,0,1};
	static int _lt_3[LTNUM]={1,0,0,0,1,0,1,0,1,1};
	static int _lt_4[LTNUM]={1,0,0,0,0,1,0,1,1,1};
	static char *_name[LTNUM]=
	{
		"ALL", "OFF", "DIR", "PT1", "PT2", "PT3", "P12", "P13", "P23", "P123",
	};
	
	per = njGetPeripheral(NJD_PORT_A0);
	if( per->press & NJD_DGT_TA ) {
		_num++;
		_num %= LTNUM;

		/* `NCĝnmEneeݒ               *
		 * inmFPAneeFOj                       *
		 *  ̊֐́ANJD_CNK_EASY_MULTILIGHT_ALLtO *
		 *  ݒł܂Bɂݒ肳ꂽׂĂ  *
		 *  Cg؂芷܂B                      */
 		/* "ON"or"OFF" setting of chunk light                *
		 * (ON = 1, OFF = 0)                                 *
		 * This function can establish                       *
		 * NJD_CNK_EASY_MULTILIGHT_ALL flag. It is changed   *
		 * lighting of all lights set by this or lights out. */

		if (!_num) njCnkSetEasyMultiLightSwitch(NJD_CNK_EASY_MULTILIGHT_ALL, 1);
		if (_num==1) njCnkSetEasyMultiLightSwitch(NJD_CNK_EASY_MULTILIGHT_ALL, 0);
		else {
			njCnkSetEasyMultiLightSwitch(NJD_CNK_EASY_MULTILIGHT_1, _lt_1[_num]);
			njCnkSetEasyMultiLightSwitch(NJD_CNK_EASY_MULTILIGHT_2, _lt_2[_num]);
			njCnkSetEasyMultiLightSwitch(NJD_CNK_EASY_MULTILIGHT_3, _lt_3[_num]);
			njCnkSetEasyMultiLightSwitch(NJD_CNK_EASY_MULTILIGHT_4, _lt_4[_num]);
		}
	}
	
	njClearMatrix();
	{
		NJS_POINT3 p1,p2,p3;
		static int a1,a2,a3;
		
		a1 += 0x100;
		a2 += 0x200;
		a3 += 0x300;
		
		p1.x = RANGE * njCos(a1);
		p1.y = RANGE * njSin(a1);
		p1.z = -12.f;
		
		p2.x = RANGE * njCos(a2);
		p2.y = 0.f;
		p2.z = -12.f + RANGE * njSin(a2);
		
		p3.x = 0.f;
		p3.y = RANGE * njSin(a3);
		p3.z = -12.f + RANGE * njCos(a3);
		
		njCnkSetEasyMultiLightPoint(NJD_CNK_EASY_MULTILIGHT_2, p1.x, p1.y, p1.z);
		njCnkSetEasyMultiLightPoint(NJD_CNK_EASY_MULTILIGHT_3, p2.x, p2.y, p2.z);
		njCnkSetEasyMultiLightPoint(NJD_CNK_EASY_MULTILIGHT_4, p3.x, p3.y, p3.z);
		
		/* `NCg̕Eʒu̔f              *
		 * ̊֐́A{IɃr[EJ̐ݒ  *
		 * ݒ肵ĂBiFnjClearMatrix̌㓙j *
		 * Oɐݒ肳ꂽׂẴCg̈ʒuE  *
		 * 𔽉f܂B                          */
		/* Reflection of a direction / a position of chunk light              *
		 *                                                                    *
		 * Use this function after setting of view/camera fundamentally,      *
		 * to reflect a position / a course of all lights set before by this. */
		 
		njCnkSetEasyMultiLightMatrices();
	}

	njTranslate( NULL, 0.f, 0.f, -12.f );
	njRotateXYZ( NULL, xx,yy,zz );
	njCnkEasyMultiDrawObject( OBJECT );
	
	if (_stop) {
		xx += 257;
		yy += 179;
		zz += 193;
	}
	
	njPrint(NJM_LOCATION(2,2), "PUSH A:CHANGE LIGHT");
	njPrint(NJM_LOCATION(2,3), "LIGHT : %s", _name[_num]);
	
	if(per->press & NJD_DGT_ST){
		_stop ^= 1;
	}

	return nwExecute();
}

void njUserExit(void)
{
	/* fobOvg̏I */
	/* End handling of debugging print */
	njExitPrint();
	nwExitSystem();
	njExitTexture();
	sbExitSystem();
}

