/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F p[XύX
              changes 
  ҏW F 98-04-28 Jn
              98-06-19 SET5Ή
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}


/* O[oZNV */
/* global section       */
#define MATRIX_DEPTH    10
#define VERTEX_MAX      200

/* O`IuWFNg */
/* external symbol object */
extern NJS_CNK_OBJECT object_cube_root[];

/* }gNXf[^ */
/* matrix data      */
static NJS_MATRIX     *g_Matrix;
static NJS_VERTEX_BUF *g_VBuf;

/* r[Cg */
/* view & light   */
static NJS_VIEW  g_View;
static NJS_LIGHT g_Light;

/* |[Y֐ */
/* pause function   */
void PausePhase(void);

/* ANeBu֐ */
/* main function        */
void ActivePhase(void);

/* |[YtO */
/* pause flag       */
Bool g_bPause = FALSE;

/* p[Xpϐ */
/* */
float g_Ang;
float g_Dist;

/***********************************************************************

	njSetBorderColor( 0x00000000 );
    njUserInit --- NinjaVXe֐
                   initialize
************************************************************************/

void njUserInit(void)
{
    /* VXȅ */
    /* Initializes the Dreamcast H/W and readies the SEGA library */
    sbInitSystem(NJD_RESOLUTION_640x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);

    /* msrbʂ̏c␳ */
	/* corrects the screen aspect ratio */
    njSetAspect(1.0F, 0.45F);

    /* ̊蓖 */
    /* allocates the memory */
    g_Matrix = (NJS_MATRIX *)syMalloc(sizeof(NJS_MATRIX) * MATRIX_DEPTH);
    g_VBuf = (NJS_VERTEX_BUF *)syMalloc(sizeof(NJS_VERTEX_BUF) * VERTEX_MAX);

    /* _i[obt@̊m */
    /* allocates the buffers for registration of vertex data */
    njInitVertexBuffer(VERTEX_MAX * 64 / 4, 0, VERTEX_MAX * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );

    /* }gNXX^bN̏ */
  	/* initializes the matrix stack */
    njInitMatrix(g_Matrix, MATRIX_DEPTH, 1);
    
    /* Zp_obt@̊m */
    /* initializes 3D system  */ 
    njInit3D(g_VBuf, VERTEX_MAX);

    /* ̏ */
    /* initializes the light source */
    njCreateLight(&g_Light, NJD_SPEC_DIR);
    
    /* r[̏ */
    /* initializes the user-defined view */
    njInitView(&g_View);

    /* r[̐ݒ */
	/* specifies the current view */
    njSetView(&g_View);

    /* wiF̐ݒ */
	/* sets background color */
    njSetBackColor(ARGB(0xff, 0xc0, 0, 0), 
                        ARGB(0xff, 0, 0xc0, 0), ARGB(0xff, 0, 0, 0xc0));

	/* eLXg̃J[̐ݒ */
    /* sets the text color */
	njPrintColor(ARGB(0xff, 0xc0, 0xc0, 0xc0));
}


/***********************************************************************

    njUserMain --- NinjaVXeC֐
                   main
************************************************************************/

Sint32 njUserMain(void)
{
    PDS_PERIPHERAL *per;

    /* WCXeBbN|[gP̃ytF擾 */
    /* get the peripheral information (port A) */
    per = pdGetPeripheral(PDD_PORT_A0);    

    /* {^ꂽǂ`FbN */
    /* checks the start button */
    if (per->press & PDD_DGT_ST) {
        g_bPause = !g_bPause;
    }

	if (!g_bPause) {    
	   	/* ANeBu */
	   	/* not pause        */
		ActivePhase();
	} else {
		/* |[Y */
		/* pause        */
		PausePhase();
	}

	/* Tv̕\ */
    /* prints the sample program name */
    njPrintC(NJM_LOCATION(23, 4), "Ninja Sample PERS CHANGE");

    return NJD_USER_CONTINUE;
}


/***********************************************************************

    ActivePhase --- ANeBu֐

************************************************************************/

void ActivePhase(void)
{
    static int count = 0;

    /* pXOx𒆐SɂĂSTx͈̔͂ŕύX */
    count++;
    g_Ang = 90.0F + njSin(NJM_DEG_ANG(count)) * 45.0F;
    njSetPerspective(NJM_DEG_ANG(g_Ang));

    /* p瓊eʂ܂ł̋Zo */
    g_Dist = 320.0F / njTan(NJM_DEG_ANG(g_Ang / 2.0F));

    /* Tv̕\ */
    /* prints the sample program name */
    njPrintC(NJM_LOCATION(5, 7), " PERS ANGLE =");
    njPrintF(NJM_LOCATION(18, 7), g_Ang, 3); 

    /* }gNXX^bÑNA */
	/* clears the matrix stack    */
    njClearMatrix();

    /* 䗦̏ɕsړ */
    njTranslate(NULL, 0.0F, 0.0F, - g_Dist / 45.0F);

    /* X,Y,Z ̏Ԃɉ] */
    /* rotates x,y,z */
    njRotateXYZ(NULL, NJM_DEG_ANG(30.0F), 
                            NJM_DEG_ANG(30.0F), NJM_DEG_ANG(0.0F));
    /* IuWFNg̕` */
    /* draws the object */
    njCnkDrawObject(object_cube_root);
}


/***********************************************************************

    PausePhase --- |[Y֐

************************************************************************/

void PausePhase(void)
{
	static int cnt = 0;

	cnt++;

	njSetFadeColor(0xff000000);
	njExecuteFade((njSin(NJM_DEG_ANG(cnt)) / 2.0F + 0.5F));
	njFadeEnable();

    /* }gNXX^bÑNA */
    /* clears the matrix stack    */
    njClearMatrix();

    /* 䗦̏ɕsړ */
    njTranslate(NULL, 0.0F, 0.0F, - g_Dist / 45.0F);

    /* X,Y,Z ̏Ԃɉ] */
    /* rotates x,y,z */
    njRotateXYZ(NULL, NJM_DEG_ANG(30.0F), 
                            NJM_DEG_ANG(30.0F), NJM_DEG_ANG(0.0F));
    /* IuWFNg̕` */
    /* draws the object */
    njCnkDrawObject(object_cube_root);

	njFadeDisable();

    njPrintC(NJM_LOCATION(38, 30), "PAUSE");
}


/***********************************************************************

    njUserExit --- NinjaVXeI֐
                   Exit
************************************************************************/

void njUserExit(void)
{
	njExitPrint();

    /* ̊J */
	/* frees the memory area */
    syFree(g_Matrix);
    syFree(g_VBuf);

    /* VXȅI */
    /* exits the system    */
    sbExitSystem();
}
