/*
** sbinit.c Ver.0.70  1999/1/5
** Copyright (C) 1998 SEGA Enterprises Co.,Ltd
** All Rights Reserved
*/

#include <shinobi.h>      /* Ewb_t@C                         */
                          /* Shinobi library header file              */
#include <sg_syhw.h>      /* n[hEFACu             */
                          /* Hardware initialization library          */

#define P1AREA   0x80000000

extern Uint8* _BSG_END;   /* BSG/BSG32ZNV̏IAhX        */
                          /* End address of BSG/BSG32 section         */

/* [NRAM̏IAhX                                            */
/* End of work RAM                                                    */
#define WORK_END (((Uint32)_BSG_END) & 0xe0000000 | 0x0d000000)




/* ̋Lq́ACugp҂̃VXeɍ킹                 */
/* ύX邱Ƃł܂B                                           */
/* ύX̍ۂ͊֘AhLgQƂAeڂK؂ɏCĂ */

/* You can change a description of this place according to a system   */
/* of library user.                                                   */
/* When change it, please refer to a document concerned and revise    */
/* each item adequately.                                              */


/***** GDt@CVXegǂ *******************************/
/***** Do you use GD filesystem ?                                     */
#define USE_GDFS 0        /* 0...gȂ                             */
                          /* 0...Do not use.                          */
                          /* 1...g(DEFALUT)                        */
                          /* 1...Use (default)                        */

/***** BZNV̏Iq[v̐擪Ƃ邩 **********************/
/* Do you assign an end of B Section to the top op the heap area ?    */
#define USE_B_END 1       /* 0...Ȃ                               */
                          /* 0...Do not assign.                       */
                          /* 1...(DEFALUT)                        */
                          /* 1...Assign (default)                     */


/* BZNV̏Iq[v̐擪ƂȂꍇA                    */
/* HEAP_SIZE Ƀq[veʂ`ĂB                         */
/* When you do not assign an end of B section to the top of the heap  */
/* area, please define the size of heap area in HEAP_SIZE macro.      */


/* GD:ɊJƂ̂łőt@C                            */
/* GD:Maximum file number opening at the same time.                   */
#define FILES 8

/* GD:JgfBNgobt@                                    */
/* GD:Current directory buffer                                        */
#define BUFFERS 1024

/* syMalloc()Ŋmۂł鍇ve(4MB)                              */
/* (BZNV̏Iq[v̐擪ƂȂꍇ̂ݗL)            */
/* The total volume that can be secured with syMalloc() (about 4MB)   */
/* (This is effective whed does not assign an end of B section to the */
/* top of the heap area.                                              */
#if !USE_B_END
#define HEAP_SIZE 0x00400000
#endif









/* O[o[N̐錾                                             */
/* Global work area                                                   */

Uint8 gMapleRecvBuf[1024 * 24 * 2 + 32];
Uint8 gMapleSendBuf[1024 * 24 * 2 + 32];

#if USE_GDFS
Uint8 gdfswork[GDFS_WORK_SIZE(FILES) + 32];
Uint8 gdfscurdir[GDFS_DIRREC_SIZE(BUFFERS) + 32];
#endif

/* syMalloc()̊Ǘɒuq[v̐擪AhX */
/* The top address of the heap area                                   */
#if USE_B_END
#define HEAP_AREA ((void*)((((Uint32)_BSG_END | P1AREA) & 0xffffffe0) + 0x20))
#define HEAP_SIZE (WORK_END - (Uint32)HEAP_AREA)
#else
#define HEAP_AREA ((void*)((Uint32)WORK_END - (Uint32)HEAP_SIZE))
#endif


/*
** AvP[V̏֐ (njInitSystem()݊)
** Initialization function of the application.
**                  Arguments are compatible with njInitSystem().
*/

void sbInitSystem(Int mode, Int frame, Int count)
{
	/* WIȏs܂B                             */
	/* ̐ݒŁÃAvP[Vő̃ptH[}X */
	/* 邱Ƃł܂B                                       */
	/* ɗR̂ȂA̋LqCȂłB     */
	/* Cꍇ́AeCu̎dl\A       */
	/* Cugp҂̐ӔCɂďCĂB           */

	/* Do standard initialization.                                */
	/* By this setting, many applications can get the greatest    */
	/* performance.                                               */
	/* Without the special reason, please do not change a         */
	/* desctiption of this place.                                 */
	/* When change it, please understand specification of each    */
	/* library enough, and revise it in responsibility of library */
	/* user.                                                      */

	/* 荞݋֎~       */
	/* Disable interrupt. */
	set_imask(15);

	/* n[hEFȀ */
	/* Initialize hardware.  */
	syHwInit();

	/* Ǘ̏            */
	/* Initialize memory management. */
	syMallocInit(HEAP_AREA, HEAP_SIZE);

	/* Ninja/Kamuȉ     */
	/* Initialize Ninja/Kamui. */
	njInitSystem(mode, frame, count);

	/* n[hEFȀ̂Q */
	/* Initialize hardware 2.     */
	syHwInit2();

	/* Rg[Cȕ */
	/* Initialize controller library. */
	pdInitPeripheral(PDD_PLOGIC_ACTIVE, gMapleRecvBuf, gMapleSendBuf);

	/* RTCCȕ   */
	/* Initialize RTC library. */
	syRtcInit();

	/* 荞݋      */
	/* Enable interrupt. */
	set_imask(0);

#if USE_GDFS
	/* GDt@CVXȅ                               */
	/* Initialize GD filesystem.                                */
	{
		Uint8* wk;
		Uint8* dir;
		Sint32 err;
		Sint32 i;

		wk  = (Uint8*)(((Uint32)gdfswork & 0xffffffe0) + 0x20);
		dir = (Uint8*)(((Uint32)gdfscurdir & 0xffffffe0) + 0x20);

		for (i = 8; i > 0; i--) {
			err = gdFsInit(FILES, wk, BUFFERS, dir);

			if (err == GDD_ERR_TRAYOPEND ||
				err == GDD_ERR_UNITATTENT) {
				sbExitSystem();
				syBtExit();
			} else if (err == GDD_ERR_OK) {
				break;
			}
		}

		if (i == 0) {
			sbExitSystem();
			syBtExit();
		}
	}
#endif

	/* ̑̏                                           */
	/* ɂȂ̑̃CȕA               */
	/* [U[ōsׂꍇAɋLqł܂B */
	/* Other initializations.                                   */
	/* When there are initializations of the other libraries    */
	/* which there are not and the initializations that should  */
	/* be done by user aloft, please describe it here.          */

	;

}


/*
** AvP[V̏I֐
** Finalize application.
*/

void sbExitSystem(void)
{

#if USE_GDFS
	/* GDt@CVXȅI */
	/* Finalize GD filesystem.      */
	gdFsFinish();
#endif

	/* RTCCȕI */
	/* Finalize RTC library.   */
	syRtcFinish();

	/* Rg[CȕI */
	/* Finalize controller library.     */
	pdExitPeripheral();

	/* Ninja/KamuȉI */
	/* Finalize Ninja/Kamui.       */
	njExitSystem();

	/* Ǘ̏I        */
	/* Finalize memory management. */
	syMallocFinish();

	/* n[hEFȀI */
	/* Finalize hardware.     */
	syHwFinish();

	/* 荞݋֎~       */
	/* Disable interrupt. */
	set_imask(15);
}


/******************************* end of file *******************************/

