/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F |SfɃeNX`𒣂
              texture
  ҏW F 98-04-28 Jn
              98-06-19 SET5Ή
              98-09-16 eNX`obt@mۂ̃TCYύX
              99-04-05 appends the English comments
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}


/* O[oZNV */
/* global data */

/* O`̃ff[^ƃeNX`f[^ */
/* model and texture data */
extern NJS_OBJECT   object_cube[];
extern NJS_TEXLIST  texlist_cube;

/* }gNX֘A */
/* matrix */
#define MATRIX_DEPTH 16
#define VERTEX_MAX   1048

/*   _ */
/* light source and view point */

static NJS_VIEW  g_View;
static NJS_LIGHT g_Light;

/* ]f[^ */
/* rotation data */

static Angle g_XAng = NJM_DEG_ANG(0.0F);
static Angle g_YAng = NJM_DEG_ANG(0.0F);
static Angle g_ZAng = NJM_DEG_ANG(0.0F);

/* eNX`f[^ */
/* texture data */
#define TEXTURE_NUM 1

static NJS_TEXMEMLIST g_Texture[TEXTURE_NUM]; /*eNX`f[^ێ̈*/
                                              /* texture data area */

static NJS_VERTEX_BUF *g_VBuf;
static NJS_MATRIX *g_Matrix;  /* }gNXX^bN */
                              /* matrix stack */

/* |[YtO */
/* pause flag */
Bool g_bPause = FALSE;

/* |[Y֐ */
/* pause function */
void ActivePhase(void);

/* ANeBu֐ */
/* active(not pause) function */
void PausePhase(void);

/**********************************************************************

	njSetBorderColor( 0x00000000 );
    njUserInit --- NinjaVXe֐
                   initialize
**********************************************************************/

void njUserInit(void)
{
    /* VXȅ */
    /* Initializes the Dreamcast H/W and readies the SEGA library */
    sbInitSystem(NJD_RESOLUTION_640x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);

    /* ʂ̃AXyNgݒ */
	/* corrects the screen aspect ratio */
    njSetAspect( 1.0F, 0.45F );

    /* ̊蓖 */
    /* allocates the memory */
    g_Matrix = (NJS_MATRIX *)syMalloc(sizeof(NJS_MATRIX) * MATRIX_DEPTH);
    g_VBuf = (NJS_VERTEX_BUF *)syMalloc(sizeof(NJS_VERTEX_BUF) * VERTEX_MAX);
    njInitTextureBuffer( ( Sint8 * )g_VBuf, 0x800*10 );

    /* wiF̐ݒ */
	/* sets background color */
    njSetBackColor(ARGB(0xff, 0xc0, 0, 0), 
                        ARGB(0xff, 0, 0xc0, 0), ARGB(0xff, 0, 0, 0xc0));

    /* _i[obt@̊m */
    /* allocates the buffers for registration of vertex data */
    njInitVertexBuffer(VERTEX_MAX * 64 / 4, 0, VERTEX_MAX * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );

    /* }gNXX^bN̏ */
  	/* initializes the matrix stack */
    njInitMatrix(g_Matrix, MATRIX_DEPTH, 1);

    /* Zp_obt@̏ */
    njInit3D( g_VBuf, VERTEX_MAX);
    /* initializes 3D system  */ 

    /* ̏ */
    /* initialize the light source */
    njCreateLight(&g_Light, NJD_LAMBERT_DIR);

    /* r[̏ */
    /* initializes the user-defined view */
    njInitView(&g_View);

    /* r[̐ݒ */
	/* specifies the current view */
    njSetView(&g_View);

    /* eNX`̃[hƃZbgAbv */
    /* loads and sets up the texture */
    njInitTexture(g_Texture, TEXTURE_NUM);  /* eNX`̗̈m */
                                            /* sets the area used for storing texture information */
    njLoadTexture(&texlist_cube);  /* eNX`Xg̃f[^̃[h */
                                   /* loads data in the texture list  */
    njSetTexture(&texlist_cube);   /* eNX`XgJgɃZbg */
                                   /* sets current texture list */

    /* NbsOʂ̐ݒ */
	/* specifies the limit values of near clipping and far clipping */
    njClipZ( -1.0f, -500.f );
    
    /* eLXg̃J[̐ݒ */
     /* sets the text color */
   njPrintColor(ARGB(0xff, 0xc0, 0xc0, 0xc0));
}


/**********************************************************************

    njUserMain --- NinjaVXeC֐
                   main
**********************************************************************/

Sint32 njUserMain(void)
{
    NJS_PERIPHERAL *per;

    /* WCXeBbN|[gP̃ytF擾 */
    /* gets the peripheral information (port A) */
    per = njGetPeripheral(NJD_PORT_A0);    

    /* {^ꂽǂ`FbN */
    /* checks the start button */
    if (per->press & NJD_DGT_ST) {
        g_bPause = !g_bPause;
    }

	/* |[YԂɂď؂ւ */
	/* pause or not */
	if (!g_bPause) {
		ActivePhase();
	} else {
		PausePhase();
	}

    /* fobO̕\ */
    /* prints the sample program name */
    njPrintC(NJM_LOCATION(23, 4), "Ninja Sample TEXTURE CUBE");

    return NJD_USER_CONTINUE;
}


/**********************************************************************

    ActivePhase --- ANeBu֐
                    main ( not pause )
**********************************************************************/

void ActivePhase(void)
{
    /* }gNXX^bÑNA */
    /* clears the matrix stack */
    njClearMatrix();

    /* sړ */
    /* translate */
    njTranslate(NULL, 0.0F, 0.0F, -10.0F);

    /* X,Y,Z ̏Ԃɉ] */
    /* rotates x,y,z */
    njRotateXYZ(NULL, g_XAng, g_YAng, g_ZAng);

    /* IuWFNg̕` */
    /* draws the object */
    njDrawObject(object_cube);

    /* X,Y,Z ւ̉]p̍XV */
    /* updates rotation angle (x,y,z) */
    g_XAng += NJM_DEG_ANG(1.0F);
    g_YAng += NJM_DEG_ANG(1.0F);
    g_ZAng += NJM_DEG_ANG(1.0F);
}


/**********************************************************************

    PausePhase --- |[Y֐
                   pause
**********************************************************************/

void PausePhase(void)
{
    NJS_POINT2COL pc;
    NJS_POINT2    p[4];
    NJS_COLOR     col[4];
    Uint8  alpha;
	static Angle ang = NJM_DEG_ANG(0.0F);
	
    /* }gNXX^bÑNA */
    /* clears the matrix stack */
    njClearMatrix();

    /* sړ */
    /* translate */
    njTranslate(NULL, 0.0F, 0.0F, -10.0F);

    /* X,Y,Z ̏Ԃɉ] */
    /* rotates x,y,z */
    njRotateXYZ(NULL, g_XAng, g_YAng, g_ZAng);

    /* IuWFNg̕` */
    /* draws the object */
    njDrawObject(object_cube);

    /* Z[o[pXvCg̐ݒ */
    /* sets polygon for screen saver */

    /* At@l̎Zo */
    /* calculates alpha value */
    ang += NJM_DEG_ANG(2.0F);
    alpha = (Uint8)(njSin(ang) * 64 + 192);
    
    pc.p   = p;
    pc.col = col;
    pc.tex = NULL;
    pc.num = 4;
    
    p[0].x = 0;
    p[0].y = 0;
    col[0].argb.a = alpha;
	col[0].argb.r = 0;
	col[0].argb.g = 0;
	col[0].argb.b = 0;

    p[1].x = 0;
    p[1].y = 480;
    col[1].argb.a = alpha;
	col[1].argb.r = 0;
	col[1].argb.g = 0;
	col[1].argb.b = 0;

    p[2].x = 640;
    p[2].y = 480;
    col[2].argb.a = alpha;
	col[2].argb.r = 0;
	col[2].argb.g = 0;
	col[2].argb.b = 0;

    p[3].x = 640;
    p[3].y = 0;
    col[3].argb.a = alpha;
	col[3].argb.r = 0;
	col[3].argb.g = 0;
	col[3].argb.b = 0;

    /* Z[o[p|S̕` */
    /* draws the screen saver */
    njDrawPolygon2D(&pc, 4, -2.0F, NJD_FILL | NJD_TRANSPARENT);

	/* |[Ŷm点 */
	/* prints 'PAUSE' string */
    njPrintC(NJM_LOCATION(38, 30), "PAUSE");
}


/**********************************************************************

    njUserExit --- NinjaVXeI֐
                   exit
**********************************************************************/

void njUserExit(void)
{
    /* ̊J */
	/* frees the memory area */
    syFree(g_Matrix);
    syFree(g_VBuf);

	njExitPrint();
    njExitTexture();

    /* VXȅI܂ ŌɕKĂяoĂ */
    /* exits the system    */
    sbExitSystem();
}
