/*
      Sequance play Test
*/

/*                 */
/* Include headers */
/*                 */
#include <shinobi.h>

#include "..\include\sndutls.h"

/* defines */
#define MAX_OF_FX 1 

/*                   */
/* Declare Prototype */
/*                   */
void SoundInit( void );
void SoundMain( PDS_PERIPHERAL * );
void setpan( Sint8 *, Sint8 );
void main( void );

/*                 */
/* Function Define */
/*                 */

void SoundMain( PDS_PERIPHERAL *pad ) {
  static SDMIDI midi_handle;
  static Sint8  num = 0, base = 0;
  static Sint32 status = 0;
  GDFS          fd;
  char *msg[] = { "STOP", "PLAY" };

  if ( pad->press & PDD_DGT_ST ) {
    if ( status == 0 ) {
      /* Sequence play */
      sdMidiOpenPort( &midi_handle );
      sdMidiPlay( midi_handle, 0, 0, 0 );
      status = 1; 
    } else {
      sdMidiStop( midi_handle );
      sdMidiClosePort( midi_handle );
      status = 0; 
    }
  }

  if ( pad->press & PDD_DGT_TX ) {
    sdSndClearFxPrg();
    sdSndSetFxPrg( num, 0 );
  } else if ( pad->press & PDD_DGT_TY ) {
    sdSndSetFxOut( 1 );
  }
  if ( pad->press & PDD_DGT_KU ) {
    if ( ++num > MAX_OF_FX ) num = MAX_OF_FX;
  } else if ( pad->press & PDD_DGT_KD ) {
    if ( --num < 0 ) num = 0;
  }

  njPrintC( NJM_LOCATION( 5, 10 ), "FX Program Number:" );
  njPrintH( NJM_LOCATION( 24, 10 ), num, 3 );
  njPrintC( NJM_LOCATION( 5, 11 ), "Play Status:" );
  njPrintC( NJM_LOCATION( 20, 11 ), msg[ status ] );
}
 
void main(void)
{
  Int            y = 0, x = 0;
  static Sint32  i = 0;
  PDS_PERIPHERAL *pad;

  /* Initialize System */
  njSetBorderColor( 0x00000000 );
#ifdef VGA
  sbInitSystem( NJD_RESOLUTION_VGA, NJD_FRAMEBUFFER_MODE_RGB565, 1 );
#else
  sbInitSystem( NJD_RESOLUTION_320x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1 );
#endif

  njInitVertexBuffer( 10000, 0, 20000, 0, 0 );
  njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );
  njSetBackColor( 0x00000000, 0x00000000, 0x000000FF );

  SoundInitialize( "MANATEE.DRV", "FX.MLT" );

  njSetVSyncFunction( sdSysServer );

  while ( 1 ) {
    pad = pdGetPeripheral( PDD_PORT_A0 );
    njPrintC( NJM_LOCATION( 5, 4 ), "-- Sequence Test --" );
    njPrintC( NJM_LOCATION( 5, 5 ), "START     : Play music" );
    njPrintC( NJM_LOCATION( 5, 6 ), "Up/Down   : Select FX Program" );
    njPrintC( NJM_LOCATION( 5, 7 ), "X         : FX On" );
    njPrintC( NJM_LOCATION( 5, 8 ), "Y         : FX Off" );

    SoundLibVer( 4, 13 );
    SoundDrvVer( 4, 14 );
    SoundDrvStat( 4, 15 );

    SoundMain( pad );

    njWaitVSync();
  }
}

/******************************* end of file *******************************/
